      subroutine CG_AllBand(ilocal,nline,tol,
     &     E_st,err_st,ave_line,vr,workr_n,mbad,ave_err,kpt,iislda)
****************************************
c     c     Written by Lin-Wang Wang, March 30, 2001. 
*************************************************************************
*     *  copyright (c) 2003, The Regents of the University of California,
*     *  through Lawrence Berkeley National Laboratory (subject to receipt of any
*     *  required approvals from the U.S. Dept. of Energy).  All rights reserved.
*************************************************************************
****************************************
****  The main conjugate gradient routine
****  mbad=0, normal iCG=1 run, ave_err not used
****  mbad>0, called from CG_new, fix the states: mx-mbad,mx to ave_err
******************************************
******************************************
      use fft_data
      use load_data
      use data

      implicit double precision (a-h,o-z)

      include 'mpif.h'
      include 'param.escan_real'
***********************************************
      complex*16 pg_m(mg_nx,mx), pg_old_m(mg_nx,mx), pgh_m(mg_nx,mx)
      complex*16 ugh_m(mg_nx,mx), overlap_mat(mx,mx), U_cholesky(mx,mx)           
      complex*16, allocatable, dimension(:,:) :: C_tmp
      real*8 prec_m(mg_nx)
      real*8 s_m(mx), err_m(mx), err2_m(mx), E_ug_m(mx), eigen_m(mx)
      real*8 rr0_m(mx), rr00_m(mx), rr1_m(mx), beta_m(mx)
      real*8 E_upg_m(mx), E_pg_m(mx)
      real*8 theta_m(mx), cos_th_m(mx), sin_th_m(mx)
      real*8 pred_E_m(mx),tmp_real(mx)

      complex*16 pg(mg_nx),ugh(mg_nx),pgh(mg_nx)
      complex*16 pg_old(mg_nx),ughh_old(mg_nx)

      integer isNLa(9,matom),ipsp_type(mtype)

      real*8 vr(mr_n)
      real*8 prec(mg_nx)
      complex*16 workr_n(mr_n)
      complex*16 cc, c_one, c_zero
**********************************************
****  if iopt=0 is used, pghh_old can be deleted
**********************************************
      integer lin_st(mst)
      real*8 E_st(mst),err_st(mst),err2_st(mst)
      real*8 Ef
      complex*16 sumdum_m(9,natom,mx),sumdum2_m(9,natom,mx)
      real*8 occ_t(mtype)
      integer iiatom(mtype),icore(mtype),numref(matom),ityatom(mtype)

      common /com123b/m1,m2,m3,ngb,nghb,ntype,rrcut,msb
      common /comEk/Ek
      common /comisNLa/isNLa,Dij0,Qij,ipsp_all,ipsp_type
      common /comNL2/occ_t,iiatom,icore,numref,ityatom

      complex*16 sss

      complex*16 h(mst,mst),hh(mst,mst)
      parameter (lwork=6000)
      complex*16 workx(lwork)
      real*8 workrx(3*mst)
      integer info
      complex*16, allocatable, dimension(:,:) :: ug_n_tmp


      if(ipsp_all.eq.2) then
         write(6,*) "imth=3 doesn't work for ipsp_all.eq.2, ultrasoft"
         call system_flush(6)
         call mpi_abort(MPI_COMM_WORLD,ierr)
      endif

      ng_n=ngtotnod(inode,kpt)

      err2_m=1.d0
      pg_old_m = (0.0d0,0.0d0)
      
      if(mbad.eq.0) mstart=1
      if(mbad.gt.0) mstart=mx-mbad+1
      
      do m=mstart,mx
         do i=1,ng_n
            x=gkk_n(i,kpt)/Ek
            y=27.d0+x*(18.d0+x*(12.d0+x*8.d0))
            prec_m(i)=y/(y+16.d0*x**4)   
         enddo
         rr0_m(m) = 1.d+40
      enddo
      
      

      time_Hpsi=0.d0
      time_p_ug=0.d0
      time_orth=0.d0
      time_other=0.d0

      nltot = 0
      do 3000 nint2=1,nline
         nltot=nltot+1
         

 555     continue               ! turning back point for mbad.gt.0 run

!111111111111111111111111111111111111111111111111111111111111111

************************************************
****  E_ug = < ug(i) | H | ug(i) >
****  = < ug(i) | ugh(i) >
************************************************

         time_000=mpi_wtime()
         if(nint2.eq.1) then
            nblock = mx-mstart+1
            call Hpsi_comp_AllBand(ug_n(1,mstart),ugh_m(1,mstart),
     &           nblock,ilocal,vr,workr_n,kpt,1,sumdum_m,iislda)

c     do m=mstart,mx
c     call orth_comp(ug_n(1,m),ug_n,0,1,kpt,
c     &      sug_n,sug_n(1,m),ipsp_all,1,1,fnorm)     ! normalize ug_n and sug_n
c     ugh_m(:,m)=fnorm*ugh_m(:,m)
c     sumdum_m(:,1:natom,m)=fnorm*sumdum_m(:,1:natom,m)
c     enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccthis might not work for ipsp_all.eq.2
            do m=mstart,mx
               s_m(m)=0.d0
               do i=1,ng_n
                  s_m(m)=s_m(m)+cdabs(ug_n(i,m))**2
               enddo
            enddo

            call mpi_allreduce(s_m(mstart),tmp_real(mstart),
     &           mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
            s_m(mstart:mx)=tmp_real(mstart:mx)

            do m=mstart,mx
               s_m(m)=dsqrt(1.d0/(s_m(m)*vol))
               sumdum_m(:,1:natom,m)=s_m(m)*sumdum_m(:,1:natom,m)
               do i=1,ng_n
                  ug_n(i,m)=s_m(m)*ug_n(i,m)
                  ugh_m(i,m)=s_m(m)*ugh_m(i,m)
               enddo
            enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         else
            do m=mstart,mx
               do i=1,ng_n
                  ugh_m(i,m)=ugh_m(i,m)*cos_th_m(m)
     &                 + pgh_m(i,m)*sin_th_m(m)
               enddo
               sumdum_m(:,1:natom,m)=
     &              sumdum_m(:,1:natom,m)*cos_th_m(m)
     &              + sumdum2_m(:,1:natom,m)*sin_th_m(m)
            enddo
         endif
         time_001=mpi_wtime()
         time_Hpsi=time_Hpsi+(time_001-time_000)
**********************************************************************
         
         do m=mstart, mx        ! a big "do m" loop
            s_m(m)=0.d0
            do i=1,ng_n
               s_m(m)=s_m(m)+dreal(ugh_m(i,m)*dconjg(ug_n(i,m)))
            enddo
         enddo
         
         
         call mpi_allreduce(s_m(mstart),tmp_real(mstart),
     &        mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         s_m(mstart:mx)=tmp_real(mstart:mx)

         
         do m=mstart,mx
            s_m(m)=s_m(m)*vol
            E_ug_m(m)=s_m(m)
            eigen_m(m)=s_m(m)
            
!     err = < ug | (H-E_ug)^2 | ug >                                
!     pg = (H-E_ug) | ug >
            err_m(m)=0.d0
            do i=1,ng_n
               err_m(m)=err_m(m)
     &              +cdabs(ugh_m(i,m)-s_m(m)*ug_n(i,m))**2
               pg_m(i,m)=ugh_m(i,m)-s_m(m)*ug_n(i,m)
            enddo            
         enddo                  ! do m
         
         call mpi_allreduce(err_m(mstart),tmp_real(mstart),
     &        mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         err_m(mstart:mx)=tmp_real(mstart:mx)


         do m=mstart,mx
            err_m(m)=dsqrt(dabs(err_m(m)*vol))
            err2_m(m)=0.d0
            do i=1,ng_n
               err2_m(m)=err2_m(m)+cdabs(pg_m(i,m))**2
            enddo
         enddo

         call mpi_allreduce(err2_m(mstart),tmp_real(mstart),
     &        mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         err2_m(mstart:mx)=tmp_real(mstart:mx)


         do m=mstart,mx
            err2_m(m)=dsqrt(dabs(err2_m(m)*vol))
************************************************
****  begin conjugate gradient
****  should I use pg**2 formula, or pg*s*pg formula here !!??
****  This is still not clear. 
************************************************

            rr1_m(m)=0.d0
            rr00_m(m)=0.d0
            do i=1,ng_n
               rr00_m(m)=rr00_m(m)+cdabs(pg_m(i,m))**2*prec_m(i)
               rr1_m(m)=rr1_m(m)+cdabs(pg_m(i,m))**2*prec_m(i)
            enddo
         enddo                  ! do m

         call mpi_allreduce(rr00_m(mstart),tmp_real(mstart),
     &        mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         rr00_m(mstart:mx)=tmp_real(mstart:mx)


         call mpi_allreduce(rr1_m(mstart),tmp_real(mstart),
     &        mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         rr1_m(mstart:mx)=tmp_real(mstart:mx)


**********************************************
****  here, pg == ughh
**********************************************

         do m=mstart,mx
            beta_m(m)=rr1_m(m)/rr0_m(m)
            rr0_m(m)=rr00_m(m)
         enddo     
**********************************************
***** pg(i) is the line minimization direction
**********************************************
***** preconditioning should be done before this
**********************************************


         do m=mstart, mx
            do i=1,ng_n
               pg_m(i,m)=-pg_m(i,m)*prec_m(i)
     &              +beta_m(m)*pg_old_m(i,m)
            enddo
         enddo
!111111111111111111111111111111111111111111111111111111111111111
         time_002=mpi_wtime()
         time_other=time_other+(time_002-time_001)


!222222222222222222222222222222222222222222222222222222222222222

         call orthogonal_projection(pg_m,mg_nx,mx,
     &        ug_n,mg_nx,mx,ng_n)
         pg_old_m = pg_m

         time_003=mpi_wtime()
         time_p_ug=time_p_ug+(time_003-time_002)

!222222222222222222222222222222222222222222222222222222222222222


!333333333333333333333333333333333333333333333333333333333333333

**********************************************
***** pgh = H * pg
**********************************************

         call Hpsi_comp_AllBand(pg_m(1,mstart),pgh_m(1,mstart),nblock,
     &        ilocal,vr,workr_n,kpt,1,sumdum2_m,iislda) 

         time_004=mpi_wtime()
         time_Hpsi=time_Hpsi+(time_004-time_003)

ccccc we should probably do it explicitly here, so there will be no mx global sum
c     do m=mstart, mx
c     call orth_comp(pg_m(1,m),ug_n,0,1,kpt, ! now we can normalize pg
c     &        sug_n,spg_m(1,m),ipsp_all,1,1,fnorm)   
c     
c     do i=1,ng_n
c     pgh_m(i,m)=fnorm*pgh_m(i,m) ! also normalize pgh
c     enddo
c     sumdum2_m(:,1:natom,m)=fnorm*sumdum2_m(:,1:natom,m)
c     enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccthis might not work for ipsp_all.eq.2
         do m=mstart,mx
            s_m(m)=0.d0
            do i=1,ng_n
               s_m(m)=s_m(m)+cdabs(pg_m(i,m))**2
            enddo
         enddo

         call mpi_allreduce(s_m(mstart),tmp_real(mstart),mx-mstart+1,
     $        MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         s_m(mstart:mx)=tmp_real(mstart:mx)

         do m=mstart,mx
            s_m(m)=dsqrt(1.d0/(s_m(m)*vol))
            sumdum2_m(:,1:natom,m)=s_m(m)*sumdum2_m(:,1:natom,m)
            do i=1,ng_n
               pg_m(i,m)=s_m(m)*pg_m(i,m)
               pgh_m(i,m)=s_m(m)*pgh_m(i,m)
            enddo
         enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
**********************************************
         do m=mstart,mx
            E_upg_m(m)=0.d0
            E_pg_m(m)=0.d0

            do i=1,ng_n
               E_upg_m(m)=E_upg_m(m)
     &              + dreal(pg_m(i,m)*dconjg(ugh_m(i,m)))
               E_pg_m(m)=E_pg_m(m)
     &              + dreal(pg_m(i,m)*dconjg(pgh_m(i,m)))
            enddo
         enddo                  ! do m

         call mpi_allreduce(E_upg_m(mstart),tmp_real(mstart),
     &        mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         E_upg_m(mstart:mx)=tmp_real(mstart:mx)


         call mpi_allreduce(E_pg_m(mstart),tmp_real(mstart),
     &        mx-mstart+1,MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)
         E_pg_m(mstart:mx)=tmp_real(mstart:mx)



         do m=mstart,mx
            E_upg_m(m)=E_upg_m(m)*vol
            E_pg_m(m)=E_pg_m(m)*vol
**********************************************
****  calculate the theta from E_ug,E_pg,E_upg:
****  ug_new = ug*cos(th)+pg*sin(th)
****  E=E_ug*cos(th)^2+2*E_upg*cos(th)*sin(th)+E_pg*sin(th)^2
**********************************************

            theta_m(m)=0.5d0
     &           *dabs(datan(2.d0*E_upg_m(m)/(E_ug_m(m)-E_pg_m(m))))
            cos_th_m(m)=dcos(theta_m(m))
            sin_th_m(m)=dsin(theta_m(m))

            pred_E_m(m)=E_ug_m(m)*cos_th_m(m)**2
     &           +2*E_upg_m(m)*cos_th_m(m)*sin_th_m(m)
     &           +E_pg_m(m)*sin_th_m(m)**2

**********************************************
****  update ug using theta
**********************************************
            do i=1,ng_n
               ug_n(i,m)=ug_n(i,m)*cos_th_m(m)+pg_m(i,m)*sin_th_m(m)
            enddo

         enddo                  ! do m

!333333333333333333333333333333333333333333333333333333333333333
         time_005=mpi_wtime()
         time_other=time_other+(time_005-time_004)

************************************************
******check convergency
************************************************
         if(all(err2_m.lt.tol).or.nint2.eq.nline) then
            lin_st(:)=nint2 
            E_st=eigen_m
            err_st=err_m
            err2_st=err2_m
            goto 3001
         endif

cccccccusing err2 to stop, instead of err. 
cccccccThe closeness to minimum for this conjugate gradient 
cccccccdepends on err2, not err. Err depends on the accuracy of previous states. 

c     if(mbad.gt.0.and.err2.gt.ave_err.and.
c     &   err_st(m).ge.tol.and.nltot.lt.40) goto 555
         if(mbad.gt.0.and.all(err2_m.gt.ave_err).and.
     &        all(err2_m.ge.tol).and.nltot.lt.40) goto 555

c         if(mbad.gt.0.and.inode_tot.eq.1) then
c            write(6,*) "nltot,err2,err_st", nltot,err2,err_st(m)
c         endif


**********************************************
****  do 3000, is for the nline line minimization
**********************************************
 3000 continue
 3001 continue


ccccccstore sumdum in beta_psi
      do m=mstart, mx
         mx_n=mx/nnodes+1
         if((m-1)/mx_n+1.eq.inode) then
            im=m-(inode-1)*mx_n
            iref_t=0
            do ia=1,natom 
               do iref=1,numref(ia)
                  iref_t=iref_t+1
                  beta_psi(iref_t,im)=sumdum_m(iref,ia,m)
               enddo
            enddo
         endif
      enddo


!     Orthogonalize ug_n.

      time_006=mpi_wtime()
      call orthogonal_cholesky(ug_n,mg_nx,mx,ng_n,U_cholesky)      
      time_007=mpi_wtime()
      time_orth=time_orth+(time_007-time_006)

      if(mbad.gt.0) return


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     Subspace diagonalizaton.
!
!     Following whole section should be equivalenct to calling diag_comp_allband.
!       call diag_comp_allband(ilocal,E_st,err_st,vr,workr_n,kpt,iislda)
!
      c_one=dcmplx(1.d0,0.d0)
      c_zero=dcmplx(0.d0,0.d0)

!!     Caculate H*psi.
!!     This segment is equivalent to calling Hpsi_comp_Allband.       
!!      call Hpsi_comp_AllBand(ug_n(1,1),ugh_m(1,1),mx,
!!     &    ilocal,vr,workr_n,kpt,1,sumdum_m,iislda)

      do m=mstart,mx
         do i=1,ng_n
            ugh_m(i,m)=ugh_m(i,m)*cos_th_m(m)
     &           + pgh_m(i,m)*sin_th_m(m)
         enddo
      enddo
      
      allocate(C_tmp(mg_nx,mx))
      CALL zgemm('N','N',ng_n,mx,mx,c_one,
     &     ugh_m,mg_nx,U_cholesky,mx,c_zero,C_tmp,mg_nx)
      ugh_m = C_tmp
      deallocate(C_tmp)


!!     Calculate the overlap matrix h.
      CALL zgemm('c','n',mst,mst,ng_n,c_one,ugh_m,mg_nx,ug_n,
     &   mg_nx,c_zero,h,mst)

      CALL mpi_allreduce(h,hh,mst*mst,MPI_DOUBLE_COMPLEX,
     &     MPI_SUM,MPI_COMM_K,ierr)
      

!!     Diagonalize the overlap matrix h. (h is not normalized.)
      call system_czheev('V','U',mx,hh,mst,E_st,workx,
     &     lwork,workrx,info)

      E_st = E_st*vol

!!     Rotate the wavefunction.
       allocate(ug_n_tmp(mg_nx,mst))
       call zgemm('N','N',ng_n,mst,mst,c_one,ug_n,mg_nx,hh,mst,
     &  c_zero,ug_n_tmp,mg_nx)

       ug_n(1:ng_n,1:mst)=ug_n_tmp(1:ng_n,1:mst)
       deallocate(ug_n_tmp)

!     End of subspace diagonalization.
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      Esum=0.d0
      ave_line=0.d0
      ave_err2=0.d0
      do i=1,mx
         Esum=Esum+E_st(i)
         ave_line=ave_line+lin_st(i)
         ave_err2=ave_err2+err2_st(i)
      enddo

      ave_line=ave_line/mx
      ave_err2=ave_err2/mx

c      if(inode.eq.1) then
c         write(6,*) "time: Hpsi,P+Ug,other,orth,tot",
c     &        time_Hpsi,time_p_ug,time_other,time_orth,
c     &        time_Hpsi+time_p_ug+time_other+time_orth
c      endif



c      if(nline.ne.0.and.inode_tot.eq.1) then
c         write(6,*) "*********************************"
c         write(6,*) "**** kpt=", kpt
c         write(6,*) "the number of line minimization used"
c         write(6,101) (lin_st(i),i=1,mx)
c         write(6,104) ave_err2
c 104     format("the err of each states, A.U.    Aver err2=", E10.4)
c         write(6,102) (err_st(i), i=1,mx)
c         write(6,*) "the eigen energies, in eV"
c         write(6,103) (E_st(i)*27.211396d0, i=1,mx)
c         write(6,*) "*********************************"
c         write(6,*) "sum eigen(dbl occ, Ryd)=", Esum*2*2
c         write(6,*) "*********************************"
c      endif
 101  format(5(i6,7x))
 102  format(5(E10.4,3x))
 103  format(5(f13.8,1x))

***********************************************

      return
      end

