        module IOmch

        implicit none

c       from LS3DF.f
        integer iter_PEtot, niter, iter_init

c        real*8 AA_G(NPULAY, NPULAY)  ! AA multiple definition
        real*8,allocatable,dimension(:,:,:)  :: dw_G,dR_G
        real*8,allocatable,dimension(:,:)    :: R0_G,w_in0_G
      
        real*8,allocatable,dimension(:)  :: vion_nLH,rhocr_nLH
        real*8,allocatable,dimension(:,:) :: rho_nLH
        real*8,allocatable,dimension(:,:) :: vr_nLH

ccccccccccccccccccccccccccc the following is for the variables in gen_G2_real
        integer,allocatable,dimension(:) :: ngcol02_G,ngcol2_G,
     &   ngycol2_G,ngzcol2_G,ncol2_G,ngtotnod2_G,n1p2_n_G,n2p2_n_G,
     &   n3p2_n_G,igstar_jjcol2_G,igfin_jjcol2_G
        integer iorg2_G(2)
        integer,allocatable,dimension(:,:) :: jjnode2_G,iycol2_G,
     &  izcol2_G,jjcol2_G
        real*8,allocatable,dimension(:) :: gkk2_n_G,gkx2_n_G,
     &  gky2_n_G,gkz2_n_G
        
        integer ng2_G,ng2_n_G
        integer nr1x_G,nr2x_G,nr3x_G
        integer ncolx_G,itemp_G,nnodes_Gst

        real*8,allocatable,dimension(:,:) :: AA_G


cccccccccccccccccccccccccccccccccccccccccccccc
        real*8 mr_nLH

        contains

        subroutine allocate_mch(npulay_max,islda,mr_n,mr_nL,nnodes_G,
     &    n1L_G,n2L_G,n3L_G)
        integer npulay_max, islda, mr_nL,mr_n
        integer nnodes_G,n1L_G,n2L_G,n3L_G,itemp
        integer ierr

        nnodes_Gst=nnodes_G
        
        mr_nLH = mr_nL


cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccc for npulay_max.eq.1, the whole mch_pulay_GENPOT(x) is not used, so don't need to allocate these arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        if(npulay_max.gt.1) then     

        allocate(dw_G(mr_nL,npulay_max,islda),stat=ierr)    ! store them on disk later
	if (ierr /= 0) then
	write(6,*) 'dw_G error', mr_nL, npulay_max, islda
	flush(6)
	endif
	

        allocate(dR_G(mr_nL,npulay_max,islda),stat=ierr)    ! store them on disk later
        if (ierr /= 0) then
        write(6,*) 'dR_G error', mr_nL, npulay_max, islda
        flush(6)
        endif




        allocate(R0_G(mr_nL,islda),stat=ierr)
        if (ierr /= 0) then
        write(6,*) 'R0_G error', mr_nL, islda
        flush(6)
        endif



        allocate(w_in0_G(mr_nL,islda),stat=ierr)
        if (ierr /= 0) then
        write(6,*) 'w_in0_G error', mr_nL, islda
        flush(6)
        endif

        endif        !  npulay_max.gt.1
ccccccccccccccccccccccccccccccccccccccccccccccccccccc




        allocate(AA_G(npulay_max,npulay_max),stat=ierr)
        if (ierr /= 0) then
        write(6,*) 'AA_G error', npulay_max
        flush(6)
        endif



        allocate(vion_nLH(mr_nL),stat=ierr)
        if (ierr /= 0) then
        write(6,*) 'vion_nLH error', mr_nL
        flush(6)
        endif





        allocate(rhocr_nLH(mr_nL),stat=ierr)
        if (ierr /= 0) then
        write(6,*) 'rhocr_nLH error', mr_nL
        flush(6)
        endif


 
        allocate(rho_nLH(mr_nL, islda),stat=ierr)
        if (ierr /= 0) then
        write(6,*) 'rho_nLH error', mr_nL, islda
        flush(6)
        endif





        allocate(vr_nLH(mr_nL, islda),stat=ierr)
        if (ierr /= 0) then
        write(6,*) 'dw_G error', mr_nL, islda
        flush(6)
        endif



cccccccccccccccccccccccccccccccccccccccccccccccccccccc
        nr1x_G=n1L_G
        nr2x_G=n2L_G
        nr3x_G=n3L_G+2
        itemp_G=nr2x_G*(nr3x_G-2)
        ncolx_G=(nr2x_G*nr3x_G)/nnodes_Gst
  
      allocate(ngcol2_G(itemp_G))
      allocate(ngcol02_G(itemp_G))
      allocate(ngycol2_G(itemp_G))
      allocate(ngzcol2_G(itemp_G))

      allocate(ncol2_G(nnodes_Gst))
      allocate(jjcol2_G(nr2x_G,nr3x_G))
      allocate(jjnode2_G(nr2x_G,nr3x_G))
      allocate(iycol2_G(ncolx_G,nnodes_Gst))
      allocate(izcol2_G(ncolx_G,nnodes_Gst))
      allocate(igstar_jjcol2_G(ncolx_G))
      allocate(igfin_jjcol2_G(ncolx_G))

      allocate(ngtotnod2_G(nnodes_Gst))

      allocate(n1p2_n_G(mr_n))
      allocate(n2p2_n_G(mr_n))
      allocate(n3p2_n_G(mr_n))

      allocate(gkk2_n_G(mr_n/2))
      allocate(gkx2_n_G(mr_n/2))
      allocate(gky2_n_G(mr_n/2))
      allocate(gkz2_n_G(mr_n/2))


        end subroutine allocate_mch


        end module IOmch


