      subroutine diag_comp_allband(ilocal,E_st,err_st,vr,workr_n,
     &    kpt,iislda)
*************************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
*************************************************************************
**  copyright (c) 2003, The Regents of the University of California,
**  through Lawrence Berkeley National Laboratory (subject to receipt of any
**  required approvals from the U.S. Dept. of Energy).  All rights reserved.
*************************************************************************

******************************************
***  Note for subspace diagonalization, the purpose is to make:
****  ug_m1 * H * ug_m2 = delta_m1,m2. 
****  as a result, the S operation is not really needed here. 
****  We will diagonalize h(m1,m2), find U.  We don't need to call the
****  general eigen vector solver for h*psi=e s*psi


      use fft_data
      use load_data
      use data

      implicit double precision (a-h,o-z)

      parameter (lwork=6000)

      include 'mpif.h'
      include 'param.escan_real'

      complex*16 ugh(mg_nx),ugh_m(mg_nx,mx)
      complex*16 h(mst,mst),hh(mst,mst)
      real*8 E_st(mst),err_st(mst)
      complex*16 workx(lwork)
      real*8 workrx(3*mst)

      real*8 vr(mr_n)
      complex*16 workr_n(mr_n)

      real*8 Dij0(32,32,mtype),Qij(32,32,mtype)
      integer isNLa(9,matom),ipsp_type(mtype)
      complex*16 sumdum(32,natom),sumdum_m(32,natom,mx)
      complex*16, allocatable, dimension(:,:) :: ug_n_tmp



******* extra due to djacobi()
      integer ind(mst)


      complex*16 ctmp(mst),c,c_one,c_zero

      common /comisNLa/isNLa,Dij0,Qij,ipsp_all,ipsp_type

      complex*16 sss

**********************************************
**** prepare the matrix
**********************************************
      ng_n=ngtotnod(inode,kpt)


      call Hpsi_comp_AllBand(ug_n(1,1),ugh_m(1,1),mx,
     &    ilocal,vr,workr_n,kpt,1,sumdum_m,iislda)


      c_one=dcmplx(1.d0,0.d0)
      c_zero=dcmplx(0.d0,0.d0)
      CALL zgemm('c','n',mst,mst,ng_n,c_one,ugh_m,mg_nx,ug_n,
     &   mg_nx,c_zero,h,mst)

      CALL mpi_allreduce(h,hh,mst*mst,MPI_DOUBLE_COMPLEX,
     &   MPI_SUM,MPI_COMM_K,ierr)

      h=hh*vol
********************************************
      call system_czheev('V','U',mx,h,mst,E_st,workx,
     &  lwork,workrx,info)
************************************
       
       allocate(ug_n_tmp(mg_nx,mst))
       call zgemm('N','N',ng_n,mst,mst,c_one,ug_n,mg_nx,h,mst,
     &  c_zero,ug_n_tmp,mg_nx)

       ug_n(1:ng_n,1:mst)=ug_n_tmp(1:ng_n,1:mst)
       deallocate(ug_n_tmp)


************************************
      if(ipsp_all.eq.2) then
      do 201 i=1,ng_n

      do m=1,mx
       c=dcmplx(0.d0,0.d0)

       do m1=1,mx
       c=c+h(m1,m)*sug_n(i,m1)    ! terrible operation
       enddo

       ctmp(m)=c

      enddo

      do m=1,mx
      sug_n(i,m)=ctmp(m)         ! terrible operation
      enddo
201   continue
      endif
*********************************
***********************************
      if(inode_tot.eq.1) then
       write(6,*) "*********************************"
       write(6,*) "*****kpt= ", kpt
       write(6,*) "report from diag_real"
       write(6,*) "eigen energies, in eV"
       write(6,103) (E_st(i)*27.211396d0, i=1,mx)
       write(6,*) "*********************************"
      endif
101   format(5(i6,7x))
102   format(5(E10.4,3x))
103   format(5(f12.8,1x))

      return
      end



