******************************************
*******************************************
c      program GENPOT_V3
      subroutine GENPOT_V3_S(nscf,frho_in_t,
     &  fvr_in_t,fvr_out_t,
     & ivr_in_t,ivr_out_t,irho_in_t,irho_out_t,
     & inode_all_G,nnodes_all_G,inode_tot_G,
     & nnodes_tot_G,my_color_G,
     & nnodes_k_G,num_group_G,icolor_G,ikey_G,nnodes_G,inode_G,
     & MY_COMM_WORLD_G,MPI_COMM_K_G,MPI_COMM_N_G,ido_dVr,
     & Ealphat_head,Ewald_head,E_Hxc,E_ion,V_error,
     & iflag_report,npulay_max_G)

******************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
*************************************************************************
**  copyright (c) 2003, The Regents of the University of California,
**  through Lawrence Berkeley National Laboratory (subject to receipt of any
**  required approvals from the U.S. Dept. of Energy).  All rights reserved.
*************************************************************************

******************************************
**  nscf=0, the first step to calculate dvr
**  nscf=1,niter, the actually selfconsistent loop
**  Note, because nscf=0, icoul=0, and nscf=1,niter, icoul could be other, so
**  we will only save vion,rhocor,etc in nscf=1, not in nscf=0
******************************************


      use fft_data
      use load_data
      use data
      use IOmch

      implicit double precision (a-h,o-z)

      include 'mpif.h'

      include 'param.escan_real'

      integer status(MPI_STATUS_SIZE)

******************************************
       real*8 AL(3,3),ALt(3,3)
********************************************
       real*8,allocatable,dimension(:,:,:)  :: E_st,err_st
       real*8,allocatable,dimension(:)  :: wmasktmp,xyzmaptmp
       integer,allocatable,dimension(:) :: indmtmp
       real*8,allocatable,dimension(:) :: rhonew1_nL,rhonew2_nL
       real*8,allocatable,dimension(:) :: tempvr1

       complex*16,allocatable,dimension(:,:)  :: ug_n_tmp
       real*8,allocatable,dimension(:)    :: workr_n_tmp
       complex*16,allocatable,dimension(:)  :: workr_n

       real*8, allocatable, dimension(:)    :: vr_nL

       integer icoul
       real*8 xcoul(3)


       real*8 xatom(3,matomG)
c       integer imov_at(3,matomG)

c       real*8 fatom(3,matomG)
       real*8 fatom(3,1)
       real*8 occ_t(mtype)
       real*8 zatom(mtype),Ealpha(mtype)

        
       integer iiatom(mtype),icore(mtype)
       integer iatom(matomG),ityatom(matomG)
       integer is_ref(mtype),ip_ref(mtype),id_ref(mtype),
     &   nref_type(mtype),ipsp_type(mtype)
       integer iCGmth0(100),iCGmth1(100),iscfmth0(100),iscfmth1(100)
       real*8  FermidE0(100),FermidE1(100),totNel
       integer  itypeFermi0(100),itypeFermi1(100)
       integer smatr(3,3,48),nrot
       integer niter0,nline0,niter1,nline1,mCGbad0,mCGbad1
       integer kpt_dens(2),ispin_dens(2),iw_dens(2)
       integer lll(8,mtype),nbeta(mtype)
       real*8 Dij0(32,32,mtype),Qij(32,32,mtype)
*************************************************
       character*50 vwr_atom(mtype),fforce_out,fdens_out
       character*50 fwg_in(2),fwg_out(2),frho_in(2),frho_out(2),
     & fvr_in(2),fvr_out(2),f_tmp,fxatom_out,f_xatom,fvext_in
       character*50 file_tmp

       character*50 frho_in_t,fvr_in_t,fvr_out_t

       character*60 message
       character*50 tmp_arg
*************************************************

       common /comNL2_G/occ_t,iiatom,icore,ityatom
cc       common /comisNLa_G/Dij0,Qij,ipsp_all,ipsp_type
       common /comEk/Ek
       common /comzatom/zatom
c       common /comnmap/nmap
       common /comispd_ref/is_ref,ip_ref,id_ref

       common /comMainEtot1/totNel,
     &     smatr,nrot,ilocal,Ealpha,Ealphat

       common /comlll/lll,nbeta
       common /comcoul/icoul
       common /comxcoul/xcoul
       common /comVext/ivext_in
c
c saved arrays for mch_pulay
c

       complex*16,allocatable,dimension(:) :: ugtemp
       complex*16,allocatable,dimension(:) :: temp_array


cccccccc Since these parameters are in module and common block, there name (hence pointer)
cccccccc cannot be passed in directly from the subroutine header. Instead they need to be assigned the value

        real*8 dt1, dt2, dt3
       
        t3pulay =0
        t3rho = 0
        t3kerk=0

        inode_all=inode_all_G
        nnodes_all=nnodes_all_G
        inode_tot=inode_tot_G
        nnodes_tot=nnodes_tot_G
        my_color=my_color_G
        nnodes_k=nnodes_k_G
        num_group=num_group_G
        icolor=icolor_G
        ikey=ikey_G
        nnodes=nnodes_G
        inode=inode_G          ! in our case, inode_tot_G=inode_G
        MY_COMM_WORLD=MY_COMM_WORLD_G
        MPI_COMM_K=MPI_COMM_K_G
        MPI_COMM_N=MPI_COMM_N_G
ccccccccccccccccccccccccccccccccccccccccccccc
cccc use my_color_G to control, so we can use one core per node, or other pattern
cccc Don't use inode_all, use inode_tot
c        if(inode_all.gt.nnodes_tot) goto 9000      ! jump out place, these nodes are not used
        if(my_color.ne.0) goto 9000      ! jump out place, these nodes are not used
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       pi=4.0d0*datan(1.0d0)

       E_NSC0 = 0.0d0  !amc
       TS0= 0.0d0
       n33 = 0 
       E_COR0 = 0.0d0 
       E_HXC0 = 0.0d0
       E_TOT0 = 0.0d0
       DVE0 = 0.0d0

       dt00=mpi_wtime()
       call input_GENPOT(AL,ilocal,tolug,tolE,
     &  niter0,niter1,nline0,nline1,iCGmth0,iCGmth1,
     &  iscfmth0,iscfmth1,FermidE0,FermidE1,
     &  itypeFermi0,itypeFermi1,mCGbad0,mCGbad1,
     &  islda,igga,totNel,ntype,xatom,iatom,iiatom,ityatom,
     &  fxatom_out,iwg_in,fwg_in,iwg_out,fwg_out,irho_in,frho_in,
     &  irho_out,frho_out,ivr_in,fvr_in,ivr_out,fvr_out,
     &  iforce,fforce_out,ipsp_type,ipsp_all,vwr_atom,nkpt,smatr,
     &  nrot,num_mov,tolforce,dtstart,dd_limit,
     &  idens_out,kpt_dens,ispin_dens,iw_dens,fdens_out,
     &  f_xatom,nref_type,ivext_in,fvext_in,imv_cont,iThomas,
     &  icore)


       dt01=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT,input",dt01-dt00,nscf


        if(nscf.eq.0) icoul=0     
ccccccc Note, icoul is inputed from icoul_h in input_GENPOT, then passed
ccccccc in through the common block. So, next time when GENPOT is called, 
ccccccc icoul will be undated. 
cccccccccccccccccccccccccccccccccccccccccccc
cccc nscf.eq.0 is for dVr calculation. We always use icoul=0 for this. 
cccc for nscf.eq.0, fvr_in is not used either
cccc for the actual selfconsistent loop, nscf starts from 1. 

cccccccccccccccccccccccccccccccccccccccc
cccccccc replace these file names by online input, so it is easier for the job control 
        frho_in(1)=frho_in_t
        frho_in(2)=frho_in_t
        fvr_in(1)=fvr_in_t
        fvr_in(2)=fvr_in_t
        fvr_out(1)=fvr_out_t
        fvr_out(2)=fvr_out_t
        ivr_in=ivr_in_t
        ivr_out=ivr_out_t
        irho_in=irho_in_t
        irho_out=irho_out_t
cccccccccccccccccccccccccccccccccccccccc
        n_tmp1=nkpt*islda/num_group
        n_tmp2=nkpt*islda-n_tmp1*num_group
        if(icolor+1.le.n_tmp2) then
        kpt_slda_dis(1)=icolor*(n_tmp1+1)+1
        kpt_slda_dis(2)=(icolor+1)*(n_tmp1+1)
        else
        kpt_slda_dis(1)=icolor*n_tmp1+n_tmp2+1
        kpt_slda_dis(2)=(icolor+1)*n_tmp1+n_tmp2
        endif
cccccccccccccccccccccccccccccccccccccccc
        n_tmp1=nkpt/num_group
        n_tmp2=nkpt-n_tmp1*num_group
        if(icolor+1.le.n_tmp2) then
        kpt_dis(1)=icolor*(n_tmp1+1)+1
        kpt_dis(2)=(icolor+1)*(n_tmp1+1)
        else
        kpt_dis(1)=icolor*n_tmp1+n_tmp2+1
        kpt_dis(2)=(icolor+1)*n_tmp1+n_tmp2
        endif
cccccccccccccccccccccccccccccccccccccccc
        n_tmp1=natom/num_group
        n_tmp2=natom-n_tmp1*num_group
        if(icolor+1.le.n_tmp2) then
        natom_dis(1)=icolor*(n_tmp1+1)+1
        natom_dis(2)=(icolor+1)*(n_tmp1+1)
        else
        natom_dis(1)=icolor*n_tmp1+n_tmp2+1
        natom_dis(2)=(icolor+1)*n_tmp1+n_tmp2
        endif
        
cccccccccccccccccccccccccccccccccccccccc
        nrL=n1L*n2L*n3L
        nr_nL=n1L*n2L*n3L/nnodes
cccccccccccccccccccccccccccccccccccccccc
cccc this is the correct estimation for n1,n2,n3 even for nonorthogonal AL(3,3)
ccccccccccc
       fackpt=2*dsqrt(2.d0*Ecut)/(4*datan(1.d0))
       dd1=fackpt*dsqrt(AL(1,1)**2+AL(2,1)**2+AL(3,1)**2)
       dd2=fackpt*dsqrt(AL(1,2)**2+AL(2,2)**2+AL(3,2)**2)
       dd3=fackpt*dsqrt(AL(1,3)**2+AL(2,3)**2+AL(3,3)**2)

       fackpt=dsqrt(2.d0*Ecut2)/(4*datan(1.d0))
       dd11=fackpt*dsqrt(AL(1,1)**2+AL(2,1)**2+AL(3,1)**2)
       dd22=fackpt*dsqrt(AL(1,2)**2+AL(2,2)**2+AL(3,2)**2)
       dd33=fackpt*dsqrt(AL(1,3)**2+AL(2,3)**2+AL(3,3)**2)

       fackpt=dsqrt(2.d0*Ecut2L)/(4*datan(1.d0))
       dd11L=fackpt*dsqrt(AL(1,1)**2+AL(2,1)**2+AL(3,1)**2)
       dd22L=fackpt*dsqrt(AL(1,2)**2+AL(2,2)**2+AL(3,2)**2)
       dd33L=fackpt*dsqrt(AL(1,3)**2+AL(2,3)**2+AL(3,3)**2)


       if(inode_tot.eq.1.and.iflag_report.eq.1) then
       open(22,file='report')
       rewind(22)

       write(6,*) "************************"
       write(6,*) "  nnodes,num_group=", nnodes,num_group
       write(6,*) "************************"
       write(6,302)  dd1,dd2,dd3
       write(6,303)  dd11,dd22,dd33
       write(6,304)  n1,n2,n3
       write(6,3303) dd11L,dd22L,dd33L
       write(6,3304) n1L,n2L,n3L
       write(6,*) "************************"

       write(22,*) "***** ))) OUTPUT FILE FROM PETOT ((( *******"
       write(22,*) "for more inf. see file ****: etot.input"
       write(22,*) "atom config file       ****: ", f_xatom
       write(22,*) "************************"
       write(22,*) "  nnodes,num_group=", nnodes,num_group
       write(22,*) "************************"
       write(22,302)  dd1,dd2,dd3
       write(22,303)  dd11,dd22,dd33
       write(22,304)  n1,n2,n3
       write(22,3303) dd11L,dd22L,dd33L
       write(22,3304) n1L,n2L,n3L
       write(22,*) "************************"
       write(22,309) natom
       write(22,301) islda,igga
       write(22,305) Ecut*2,Ecut2*2,Ecut2L*2,Smth
       write(22,306) totNel,mx,tolug,tolE
       write(22,307) ilocal,rcut,ntype
       write(22,308) nkpt,nrot,num_mov,dtsart,dd_limit
       write(22,*) "*********************"
       write(22,*) "AL1,AL2,AL3 in (x,y,z)"
       write(22,133) AL(1,1),AL(2,1),AL(3,1)
       write(22,133) AL(1,2),AL(2,2),AL(3,2)
       write(22,133) AL(1,3),AL(2,3),AL(3,3)
       write(22,*) "************************"
       close(22)
       endif

302    format("recommended n1,n2,n3 from Ecut  ***: ",3(f6.1,1x))
303    format("recommended n1,n2,n3 from Ecut2 ***: ",3(f6.1,1x))
304    format("Actual      n1,n2,n3 used here  ***: ",3(i6,1x))
3303   format("recomm.   n1L,n2L,n3Lfrom Ecut2L***: ",3(f6.1,1x))
3304   format("Actual    n1L,n2L,n3L used here ***: ",3(i6,1x))
309    format(" natom=",i7)
301    format(" islda=",i7,    "     igga=", i7)
305    format("  Ecut=",f7.2,  "    Ecut2=",f7.2,"    Ecut2L=",f7.2,
     &   "   Smth=",f7.2)
306    format("totNel=",f7.2,  "       mx=",i7,  "     tolug=",E7.1,
     &   "   tolE=",E7.1)
307    format("ilocal=",i7,    "     rcut=",f7.2,"     ntype=",i7)
308    format("numkpt=",i7,    "  num-sym=",i7,  "  atom_mov=",i7,
     & " dtstart=",f9.4, " dd_limit=",f9.4)
133    format(3(f14.7,1x))

**********************************
ccccc  mx passed from input from param.escan_real
c       mst=mx
c        allocate(E_st(mst,nkpt,islda))
c        allocate(err_st(mst,nkpt,islda))
**********************************
       Ek=0.5d0

       nr=n1*n2*n3
       nr_n = nr/nnodes


       mr=n1*n2*(n3+2)
       mr_n=mr/nnodes*(1+3.d0*nnodes/(n2*n3))  ! possible imbalance factor, some proc. has 2-3 more column

       mr=mr_n*nnodes
ccccc  (n3+2) is for the half plane in d3fft_real2
ccccc  fact (1+2.d0*nnodes/(n2*n3)) is for possible column load imbalance between diff. processors. 
ccccc  need to check the d3fft_real2 more carefully, and fftprep_real2.f

       nrL=n1L*n2L*n3L
       nr_nL=nrL/nnodes

       mrL=n1L*n2L*(n3L+2)
       mr_nL=mrL/nnodes*(1+3.d0*nnodes/(n2L*n3L))
       mrL=mr_nL*nnodes
ccccc  (n3L+2) is for the half plane in d3fft_real2L
ccccc  fact (1+2.d0*nnodes/(n2*n3)) is for possible column load imbalance between diff. processors. 

c     Calculate the approx. no. of g points, so we can dimension arrays
      volume=al(3,1)*(al(1,2)*al(2,3)-al(1,3)*al(2,2))
     &     +al(3,2)*(al(1,3)*al(2,1)-al(1,1)*al(2,3))
     &     +al(3,3)*(al(1,1)*al(2,2)-al(1,2)*al(2,1))
      volume = dabs(volume)
      delta_k=(2*pi)**3/volume
      totg=(4.0d0/3.0d0*pi*(dsqrt(2.0d0*Ecut))**3)/delta_k
cccc      mg_nx=int(1.1d0*totg/nnodes)+100
      mg_nx=int(1.03d0*totg/nnodes)+100



c     Check that nr is a mulitple of the no. of nodes
      if (mod(nr,nnodes)/=0.or.mod(mr,nnodes)/=0) then
       write(6,*)"nr,mr cannot be divided by nnodes", 
     & inode,nr,mr,nnodes,n1,n2,n3    
         stop
      end if

ccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       npulay_max=npulay_max_G
cccccccc this will change the npulay_max in data.f, which will be passed into mch_pulay_GENPOT.f
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       call fft_allocate(n1,n2,n3,nnodes)
cccc  ncolx is defined inside fft_allocate
       call load_allocate(n1,n2,n3,ncolx,nnodes,mg_nx,mr_n)
       iGENPOT=1
       call data_allocate(mg_nx,mx,mr_n,mr_nL,ilocal,inode,nkpt,
     &   islda,natom,nref_tot,ipsp_all,nnodes,npulay_max,iGENPOT)

cccc iflag_fft2L is passed in through param.escan_real, 
cccc iflag_fft2L=0: no fft2L (which is the same as fft2, no denser grid)
cccc iflag_fft2L=1: fft2L is different from fft2, has a denser grid

       call fft_allocateL(n1L,n2L,n3L,nnodes,iflag_fft2L)
       call load_allocateL(n1L,n2L,n3L,ncolxL,nnodes,mr_nL,
     &       iflag_fft2L)


        allocate(workr_n(mr_n))

**********************************

       call get_ALI(AL,ALI)
       vol=AL(1,1)*(AL(2,2)*AL(3,3)-AL(3,2)*AL(2,3))+
     &        AL(2,1)*(AL(3,2)*AL(1,3)-AL(1,2)*AL(3,3))+
     &        AL(3,1)*(AL(1,2)*AL(2,3)-AL(2,2)*AL(1,3))
       vol=dabs(vol)

       dt02=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &     write(111,*) "GENPOT, header",dt02-dt01

       if(nscf.eq.0.or.(nscf.eq.1.and.ido_dVr.eq.0)) then        ! nscf=1: iter_PEtot=iter_init; nscf=0: ido_dVr
     
       dt_tmp1=mpi_wtime()
       call gen_G2_real()
       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, gen_G2_real",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00

       ngcol2_G(1:itemp_G)=ngcol2(1:itemp_G)
       ngcol02_G(1:itemp_G)=ngcol02(1:itemp_G)
       ngycol2_G(1:itemp_G)=ngycol2(1:itemp_G)
       ngzcol2_G(1:itemp_G)=ngzcol2(1:itemp_G)
       ncol2_G(1:nnodes_Gst)=ncol2(1:nnodes_Gst)
       jjcol2_G(1:nr2x_G,1:nr3x_G)=jjcol2(1:nr2x_G,1:nr3x_G)
       jjnode2_G(1:nr2x_G,1:nr3x_G)=jjnode2(1:nr2x_G,1:nr3x_G)
       iycol2_G(1:ncolx_G,1:nnodes_Gst)=iycol2(1:ncolx_G,1:nnodes_Gst)
       izcol2_G(1:ncolx_G,1:nnodes_Gst)=izcol2(1:ncolx_G,1:nnodes_Gst)
       igstar_jjcol2_G(1:ncolx_G)=igstar_jjcol2(1:ncolx_G)
       igfin_jjcol2_G(1:ncolx_G)=igfin_jjcol2(1:ncolx_G)
       ngtotnod2_G(1:nnodes_Gst)=ngtotnod2(1:nnodes_Gst)
       n1p2_n_G(1:mr_n)=n1p2_n(1:mr_n)
       n2p2_n_G(1:mr_n)=n2p2_n(1:mr_n)
       n3p2_n_G(1:mr_n)=n3p2_n(1:mr_n)
       gkk2_n_G(1:mr_n/2)=gkk2_n(1:mr_n/2)
       gkx2_n_G(1:mr_n/2)=gkx2_n(1:mr_n/2)
       gky2_n_G(1:mr_n/2)=gky2_n(1:mr_n/2)
       gkz2_n_G(1:mr_n/2)=gkz2_n(1:mr_n/2)
       iorg2_G=iorg2
       ng2_G=ng2
       ng2_n_G=ng2_n
       else
       ngcol2(1:itemp_G)=ngcol2_G(1:itemp_G)
       ngcol02(1:itemp_G)=ngcol02_G(1:itemp_G)
       ngycol2(1:itemp_G)=ngycol2_G(1:itemp_G)
       ngzcol2(1:itemp_G)=ngzcol2_G(1:itemp_G)
       ncol2(1:nnodes_Gst)=ncol2_G(1:nnodes_Gst)
       jjcol2(1:nr2x_G,1:nr3x_G)=jjcol2_G(1:nr2x_G,1:nr3x_G)
       jjnode2(1:nr2x_G,1:nr3x_G)=jjnode2_G(1:nr2x_G,1:nr3x_G)
       iycol2(1:ncolx_G,1:nnodes_Gst)=iycol2_G(1:ncolx_G,1:nnodes_Gst)
       izcol2(1:ncolx_G,1:nnodes_Gst)=izcol2_G(1:ncolx_G,1:nnodes_Gst)
       igstar_jjcol2(1:ncolx_G)=igstar_jjcol2_G(1:ncolx_G)
       igfin_jjcol2(1:ncolx_G)=igfin_jjcol2_G(1:ncolx_G)
       ngtotnod2(1:nnodes_Gst)=ngtotnod2_G(1:nnodes_Gst)
       n1p2_n(1:mr_n)=n1p2_n_G(1:mr_n)
       n2p2_n(1:mr_n)=n2p2_n_G(1:mr_n)
       n3p2_n(1:mr_n)=n3p2_n_G(1:mr_n)
       gkk2_n(1:mr_n/2)=gkk2_n_G(1:mr_n/2)
       gkx2_n(1:mr_n/2)=gkx2_n_G(1:mr_n/2)
       gky2_n(1:mr_n/2)=gky2_n_G(1:mr_n/2)
       gkz2_n(1:mr_n/2)=gkz2_n_G(1:mr_n/2)
       iorg2=iorg2_G
       ng2=ng2_G
       ng2_n=ng2_n_G
       endif
cccccccccccccccccccccccccccccccccccccccccccccccccc

       dt025=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, gen_G2",dt025-dt02,nscf

       call fftprep_real2(n1,n2,n3,mr_n)

       dt03=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, fftprep",dt03-dt025

       if(iflag_fft2L.eq.1) then
       call gen_G2L_real()
       call fftprep_real2L(n1L,n2L,n3L,mr_nL)
       else
       gkk2_nL=gkk2_n
       gkx2_nL=gkx2_n
       gky2_nL=gky2_n
       gkz2_nL=gkz2_n
       iorg2L=iorg2
       ngtotnod2L=ngtotnod2
       ncolz2L=ncolz2
       ncolzL=ncolz2          ! ncolzL and ncolz2L are the same
       ixcol_z2L=ixcol_z2
       iycol_z2L=iycol_z2
       jjnode2L=jjnode2
       jjcol2L=jjcol2
       igstar_jjcol2L=igstar_jjcol2
       igfin_jjcol2L=igfin_jjcol2
       n1p2_nL=n1p2_n
       endif

c       if(nrot.gt.1) then
c       allocate(ig_star(mr_nL))       ! defined in data.f
c       allocate(ig_star_stop(mr_nL))       ! defined in data.f
c       allocate(ig_local(mr_nL))      ! not, mr_n/2, since -k might be in it.
c       allocate(ig_lenstar(mr_nL))
c       call symmcheck(smatr,AL,nrot,xatom,iatom)
c       call gen_Gstar_ind(smatr,nrot,AL)
c       endif

*********************************************
*********************************************************
       Ealphat=0.d0
       if(nscf.eq.1.or.nscf.eq.0) then
       dt_tmp1=mpi_wtime()
       call w_line(ilocal,ntype,vwr_atom,Ealpha,
     & MY_COMM_WORLD_G,inode_tot_G,
     & occ_t,iiatom,icore,Dij0,Qij,ipsp_type)
       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, w_line",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00

       dt_tmp1=mpi_wtime()
         do ia=1,natom
            iitype=0
            do itype=1,ntype
            if(iatom(ia).eq.iiatom(itype)) iitype=itype
            enddo
            if(iitype.eq.0) then
            write(6,*) "itype not found, stop", iatom(ia),ia
            stop
            endif
          ityatom(ia)=iitype
          enddo

          Ealphat=0.d0
          ch=0.d0
          do ia=1,natom
          Ealphat=Ealphat+Ealpha(ityatom(ia))
          ch=ch+zatom(ityatom(ia))
          enddo
          Ealphat=Ealphat*ch/vol

ccccc this is for the reference sign for nonlocal projection, not needed here
ccc       call getNLsign(iatom,ntype,is_ref,ip_ref,id_ref)

       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, w_line part2",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00

       endif    ! nscf=1,0

******************************************************
       if(icoul.eq.0) goto 401

       if(inode_tot.eq.1) write(6,*) "enter getvcoul"

       if(icoul.ne.1.and.icoul.ne.11.and.icoul.ne.12.and.
     &  icoul.ne.13) then
       if(inode_tot.eq.1) write(6,*) 
     &       "input icoul not correct, stop", icoul
       call mpi_abort(MPI_COMM_K,ierr)
       endif

       if(icoul.eq.1)   then     ! cluster calculation, all three dimension increase x2
       n1L2=n1L*2
       n2L2=n2L*2
       n3L2=n3L*2
       AL2=AL*2
       endif
       if(icoul.eq.11) then      ! slab calculation along the first direction
       n1L2=n1L*2
       n2L2=n2L
       n3L2=n3L
       AL2(:,1)=2*AL(:,1)
       AL2(:,2)=AL(:,2)
       AL2(:,3)=AL(:,3)
       endif
       if(icoul.eq.12) then      ! slab calculation along the second direction
       n1L2=n1L
       n2L2=n2L*2
       n3L2=n3L
       AL2(:,1)=AL(:,1)
       AL2(:,2)=2*AL(:,2)
       AL2(:,3)=AL(:,3)
       endif
       if(icoul.eq.13) then      ! slab calculation along the third direction
       n1L2=n1L
       n2L2=n2L
       n3L2=n3L*2
       AL2(:,1)=AL(:,1)
       AL2(:,2)=AL(:,2)
       AL2(:,3)=2*AL(:,3)
       endif

       if(inode_tot.eq.1) then
       write(6,*) "n1L2,n2L2,n3L2=",n1L2,n2L2,n3L2
       endif

       nrL2=n1L2*n2L2*n3L2
       nr_nL2=nrL2/nnodes
       mrL2=n1L2*n2L2*(n3L2+2)
       mr_nL2=mrL2/nnodes*(1+3.d0*nnodes/(n2L2*n3L2))
       mrL2=mr_nL2*nnodes
ccccc  (n3L2+2) is for the half plane in d3fft_real2L2
ccccc  fact (1+3.d0*nnodes/(n2L2*n3L2)) is for possible column load imbalance between diff. processors. 

       vol2=AL2(1,1)*(AL2(2,2)*AL2(3,3)-AL2(3,2)*AL2(2,3))+
     &        AL2(2,1)*(AL2(3,2)*AL2(1,3)-AL2(1,2)*AL2(3,3))+
     &        AL2(3,1)*(AL2(1,2)*AL2(2,3)-AL2(2,2)*AL2(1,3))
       vol2=dabs(vol2)


       call fft_allocateL2(n1L2,n2L2,n3L2,nnodes)
       call load_allocateL2(n1L2,n2L2,n3L2,ncolxL2,
     &        nnodes,mr_nL2)
       call data_allocate_nL2(mr_nL2,ntype)
       call get_ALI(AL2,ALI2)
       call gen_G2L2_real()
       call fftprep_real2L2(n1L2,n2L2,n3L2,mr_nL2)

cccccccccccccccccccccccccccc
cccc here, we are in icoul=1. If icoul=0, we will never be here (jump out to 401)

cccc For nscf.eq.0 (for ido_dVr), we will not be here, since in that case, icoul=0
cccc For nscf.eq.1, we will calculate vcoul_nL2, then store it on disk, 
cccc We will read in vcoul_nL2 for later iterations (actually, we should keep it in the memory)
cccc This will be done later !!!! 
ccccc We need to keep vcoul_nL2 in the memory
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if(nscf.eq.1.or.nscf.eq.0) then

       dt_tmp1=mpi_wtime()
       call getvcoul(ntype,Ealpha,icoul) 
       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, getvcoul",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00

        
       dt_tmp1=mpi_wtime()

ccccccc the vcoul_nL2 is actually in G space, but we treat it here as real*8 in real space
       do ii=0,ntype
       file_tmp="vcoul_nL2.store."//char(ii+48)
       if(inode.eq.1) then
       open(14,file=file_tmp,form="unformatted")
       rewind(14)
       endif 

       allocate(tempvr1(mr_nL2))

          if(inode.eq.1) then
          tempvr1=vcoul_nL2(:,ii)
          write(14) tempvr1
          endif

       do isend=1,nnodes-1
         call mpi_barrier(MPI_COMM_K,ierr)
         if(inode.eq.isend+1) then
         tempvr1=vcoul_nL2(:,ii)
         call  mpi_send(tempvr1,mr_nL2,MPI_REAL8,0,
     &   100,MPI_COMM_K,ierr)
         endif

         if(inode.eq.1) then
         call mpi_recv(tempvr1,mr_nL2,MPI_REAL8,isend,
     &   100,MPI_COMM_K,status,ierr)
         write(14) tempvr1
         endif
       enddo
       if(inode.eq.1) close(14)
       deallocate(tempvr1)

       enddo    ! ii type

       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, write vcoul",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00

       else

       do ii=0,ntype
       file_tmp="vcoul_nL2.store."//char(ii+48)
       if(inode.eq.1) then
       open(14,file=file_tmp,form="unformatted")
       rewind(14)
       endif

       allocate(tempvr1(mr_nL2))

          if(inode.eq.1) then
          read(14) tempvr1
          vcoul_nL2(:,ii)=tempvr1
          endif

       do isend=1,nnodes-1
         call mpi_barrier(MPI_COMM_K,ierr)

         if(inode.eq.1) then
         read(14) tempvr1
         call mpi_send(tempvr1,mr_nL2,MPI_REAL8,isend,
     &   100,MPI_COMM_K,ierr)
         endif

         if(inode.eq.isend+1) then
         call  mpi_recv(tempvr1,mr_nL2,MPI_REAL8,0,
     &   100,MPI_COMM_K,status,ierr)
         vcoul_nL2(:,ii)=tempvr1
         endif

       enddo
       if(inode.eq.1) close(14)
       deallocate(tempvr1)

       enddo    ! ii, type
       endif

401    continue    ! jump out point for icoul
***************************************************************
cccc The charge density from the previous get_denstot_fmPN_NEW is always stored in rho_nLH
cccc regardless of the charge density name. 
cccc in some cases (iter=last iteration), it also write out the density on the disk
cccc In this version, the GENPOT can only get the charge density from the result of get_denstot_fmPN_NEW, 
cccc it cannot read in a charge density from the disk

       dt1 = mpi_wtime()
       if(irho_in.eq.1) then
       do iislda=1,islda
c       call rhoIO(AL,rho_nL(1,iislda),mr_nL,2,
c     &                 n1L,n2L,n3L,frho_in(iislda))     
        rho_nL(1:mr_nL, iislda) = rho_nLH(1:mr_nL, iislda) 

       enddo
       ido_rho=0
       else
       write(6,*) "must input charge in GENPOT, stop"
       ido_rho=1
       call abort()
       endif 


       if(ivext_in.eq.1) then
       call rhoIO(AL,vext_nL,mr_nL,2,
     &          n1L,n2L,n3L,fvext_in)
       else
       vext_nL=0.d0
       endif

       dt2 = mpi_wtime()
       t3rho = t3rho + dt2 - dt1

cccccccc  ido_rho=0;1, initially, not calc. or calc. rho_n from atom
cccccccc  ido_vr=0;1,  initially, not calc. or calc. vr_in_n from rho_n
cccccccc  iforce_cal=0;1    not calc. or calc. force

cccccccc   one total energy calculation before moving the atoms

cccccccccccccc nscf=0 is for dVr calculation
cccccccccccccc nscf=1 is for the first scf step calculation

       if(nscf.eq.0.or.
     &  (nscf.eq.1.and.(icoul.ne.0.or.ido_dVr.eq.0))) then

cc       if(nscf.eq.0.or.nscf.eq.1) then   

       dt_tmp1=mpi_wtime()

       if(icoul.eq.0) then
       call getewald(fatom,xatom,AL,ityatom,ewald)
       endif

       if(icoul.eq.1) then
c       call getewald3D(fatom,xatom,AL,ityatom,ewald)
       endif

       if(icoul.eq.11.or.icoul.eq.12.or.icoul.eq.13) then
c       call getewald2D(fatom,xatom,AL,ityatom,ewald)
       endif

       if(ivext_in.eq.1) then
c       call getEextV(fatom,xatom,AL,ityatom,E_IVext)
       endif

       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, getewald",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00


ccccccc This is done for both nscf.eq.0 (for ido_dvr) and nscf.eq.1 (first iter of the scf loop)
ccccccc because they can have different icoul (passed in getVrhoL_ through a common block
       dt_tmp1=mpi_wtime()
       call getVrhoL_GENPOT(AL,vion_nL,vionT_nL,xatom,ntype,
     &  iatom,rhocr_nL,totNel,ido_rho,islda)
       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1)
c     &    write(111,*) "GENPOT, getVrhoL_GENPOT",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00

cccccccc  only store vion_n,rhocr_n,vionT_n for nscf=1 (not for nscf=0) for later iter use
cccccccc  because their icoul can be different, and iteration follow nscf=1 (nscf=0 for ido_dvr is a stand alone calculation)
cccccccc  since we always calculate them for nscf=1 (iter_PEtot=iter_init), so no need to store them on the disk

        dt1 = mpi_wtime()

       tmp_arg="vion_n.GENPOT"
c       call rhoIO(AL,vion_nL,mr_nL,1,
c     &   n1L,n2L,n3L,tmp_arg)
       vion_nLH(1:mr_nL) = vion_nL(1:mr_nL)         ! store them in the memory
       icc=0
       do itype=1,ntype
       icc=icc+icore(itype)
       enddo
       if(icc.gt.0) then
       tmp_arg="rhocr_n.GENPOT"
c       call rhoIO(AL,rhocr_nL,mr_nL,1,
c     &   n1L,n2L,n3L,tmp_arg)
       rhocr_nLH(1:mr_nL) = rhocr_nL(1:mr_nL)
       endif
       if(iThomas.eq.1) then                 ! we should keep it in vionT_nLH, do it later
       tmp_arg="vionT_n.GENPOT"
       call rhoIO(AL,vionT_nL,mr_nL,1,
     &   n1L,n2L,n3L,tmp_arg)
       dt_tmp2=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1)
c     &    write(111,*) "GENPOT, store rhocr_nLH",dt_tmp2-dt_tmp1
c     &    ,dt_tmp2-dt00
       endif


       else    ! nscf > 1, or some nscf=0  read in vion_n,rhocr_n,vionT_n (stored from nscf=1)

cccccccc this will not work, because it is not read in for the first iteration

       tmp_arg="vion_n.GENPOT"
c       call rhoIO(AL,vion_nL,mr_nL,2,
c     &  n1L,n2L,n3L,tmp_arg)
       vion_nL(1:mr_nL) =vion_nLH(1:mr_nL)

       icc=0
       do itype=1,ntype
       icc=icc+icore(itype)
       enddo

       if(icc.gt.0) then
       tmp_arg="rhocr_n.GENPOT"
c       call rhoIO(AL,rhocr_nL,mr_nL,2,
c     &   n1L,n2L,n3L,tmp_arg)
       rhocr_nL(1:mr_nL) = rhocr_nLH(1:mr_nL)
       else
       rhocr_nL=0.d0
       endif

       if(iThomas.eq.1) then
       tmp_arg="vionT_n.GENPOT"
       call rhoIO(AL,vionT_nL,mr_nL,2,
     &   n1L,n2L,n3L,tmp_arg)
       else
       vionT_nL=0.d0
       endif

       endif  ! nscf.eq.1,0, 
cccc this end if corresponds to:
cc       if(nscf.eq.0.or.
cc     &  (nscf.eq.1.and.(icoul.ne.0.or.ido_dVr.eq.0))) then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        Ealphat_head=Ealphat
        Ewald_head=Ewald

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       dt2 = mpi_wtime()
       t3rho = t3rho + dt2 - dt1
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


ccccccc  add a symm op on the charge density !
         if(nrot.gt.1) then
         do iislda=1,islda
         call symmop(rho_nL(1,iislda))
         enddo
         endif

       E_rhoVext=0.d0
       do iislda=1,islda
       do i=1,nr_nL
       E_rhoVext=E_rhoVext+rho_nL(i,iislda)*vext_nL(i)
       enddo
       enddo

       call global_sumr(E_rhoVext)
       E_rhoVext=E_rhoVext*vol/nrL

       dt04=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, before getpot2",dt04-dt03
cccccc this is always needed, 2 fft for icoul=0


       if(islda.eq.1.and.igga.eq.0) then
       call getpot2L(rho_nL,vion_nL,rhocr_nL,vr_out_nL,
     &        v0,E_Hxc,E_coul,E_ion)
       endif
       if(islda.eq.2.and.igga.eq.0) then
       call getpot3L(rho_nL,vion_nL,rhocr_nL,vr_out_nL,v0,
     &           E_Hxc,E_coul,E_ion)
       endif

       if(islda.eq.1.and.igga.eq.1) then
       call getpot4L(rho_nL,vion_nL,rhocr_nL,vr_out_nL,v0,
     &           E_Hxc,E_coul,E_ion)
       endif

       if(islda.eq.2.and.igga.eq.1) then
       call getpot5L(rho_nL,vion_nL,rhocr_nL,vr_out_nL,v0,
     &           E_Hxc,E_coul,E_ion)
       endif

       dt05=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &    write(111,*) "GENPOT, getpot2",dt05-dt04

       
       if(icoul.eq.1.or.icoul.eq.11.or.icoul.eq.12.
     &                      or.icoul.eq.13) Ealphat=0.d0

******  E_extV is the energy due to all the external potential corrections

       E_extV=E_IVext+E_rhoVext    ! sum over ionic part and electronic part

       call mpi_barrier(MPI_COMM_K,ierr)
ccccccccccccccccccccccccccccccccccc!!!!!!!!!!!!



       if(nscf.eq.0) then
       vr_in_nL=vr_out_nL
       goto 2000
       endif


cccccccccccccccccccccccccccccccccccccccccccccccccdd
cccc The input potential for the previous mainMV2_S2 run has been used in get_vrF, and 
cccc it is always stored in vr_nLH, so now, just read it in from the memory
ccccccccccccccccccccccccccccccccccccccccccccccccccccc
       dt1 = mpi_wtime()
       if(ivr_in.eq.1) then
       do iislda=1,islda
c       call rhoIO(AL,vr_in_nL(1,iislda),mr_nL,2,
c     &  n1L,n2L,n3L,fvr_in(iislda))
        vr_in_nL(1:mr_nL,iislda) = vr_nLH(1:mr_nL,iislda)      
       enddo
       else
cc it is not used in the calculation
       write(6,*) "must input vr_in for mch_pulay, stop"
       call abort()
       endif
       dt2 = mpi_wtime()
       t3rho = t3rho + dt2 - dt1


cccccccc calculate the diff: rho*|vr_out-vr_in|
       sum1=0.d0
       sum2=0.d0
       do iislda=1,islda
       do i=1,nr_nL
       sum1=sum1+rho_nL(i,iislda)
     & *abs(vr_in_nL(i,iislda)-vr_out_nL(i,iislda))
       sum2=sum2+rho_nL(i,iislda)
       enddo
       enddo

       call global_sumr(sum1)
       call global_sumr(sum2)
       v_error=sum1/sum2


c       if(inode.eq.1) then
c       open(13,file="GENPOT.report",position='append')
c       if(nscf.eq.1) then
c       write(13,*) Ealphat,Ewald, "    ! Ealphat,Ewald (a.u) "
c       write(13,*) "nscf,E_Hxc,E_ion,v_error (a.u)"
c       write(13,400) nscf,E_Hxc,E_ion,v_error,E_coul,E_ion
c       else if (nscf.gt.1) then
c       write(13,400) nscf,E_Hxc,E_ion,v_error,E_coul,E_ion
c400    format(i5,2x,5(E20.12,1x))
c       endif
c       close(13)
c       endif


c        Ealphat_head=Ealphat
c        Ewald_head=Ewald

c        if(inode.eq.1.and.nscf.eq.1) then
c        open(13,file="Ewald.report")
c        rewind(13)
c        write(13,*) Ealphat,Ewald, "    ! Ealphat,Ewald (a.u) "
c        close(13)
c        endif

ccccccccccccccccccccccccccccc
cccccc test
c       stop
cccccccccccccccccccccccccc


**************************************************
*** mch_pulay: input the current vr_in->vr_out,
*** using previous such relation, and make a linear combination
*** output: a new vr_in->vr_out, with smaller difference
**************************************************
*** mch_kerk, Thomas3: input the vr_in -> vr_out,
*** Using non linear-combination prediction (preconditioning)
*** output: a new vr_in->vr_out, with smaller difference.
***  the vr_in is used in the next iteration
**************************************************
       call mpi_barrier(MPI_COMM_K,ierr)

       dt1 = mpi_wtime()
       call mch_pulay_GENPOT(vr_in_nL,vr_out_nL,nscf,islda,AL)
       dt2 = mpi_wtime()
c       t3pulay = t3pulay + dt2 - dt1
       t3pulay =  dt2 - dt1

       dt1 = mpi_wtime()
       do iislda=1,islda

        if(iThomas.eq.0) then
        call mch_kerk(vr_in_nL(1,iislda),vr_out_nL(1,iislda))  ! generate new vr_in_n
        else

       if(irho_in.ne.1.and.inode.eq.1) then
       write(6,*) "need to read in the charge density for Thomas3.f"
       call mpi_abort(MPI_COMM_WORLD,ierr)
       endif

       call Thomas3(vr_in_nL(1,iislda),vr_out_nL(1,iislda),   ! to be installed, vionT_n
     &     Ef0,totNel,islda,ipsp_all)    ! here Ef0 is a output
        endif
       enddo
       dt2 = mpi_wtime()
       t3kerk = d3kerk + dt2 - dt1

************************************************************
2000   continue

       dt06=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1)
c     &    write(111,*) "GENPOT, Pulay+Kerk ",dt06-dt05


       dt1 = mpi_wtime()
       do iislda=1,islda

        if (ivr_out.eq.10) then

       call rhoIO(AL,vr_in_nL(1,iislda),mr_nL,1,
     &  n1L,n2L,n3L,fvr_out(iislda))
        endif

        vr_nLH(1:mr_nL,iislda) = vr_in_nL(1:mr_nL,iislda)
       enddo
       dt2 = mpi_wtime()
       t3rho = t3rho + dt2 - dt1

c       if (inode_all_G.eq.1.and.iflag_report.eq.1) then
c        print *, "T3PULAY ", t3pulay
c        print *, "T3KERK  ", t3kerk
c        print *, "T3RHO   ", t3rho
c        write(111, *) "T3PULAY ", t3pulay
c        write(111, *) "T3KERK  ", t3kerk
c        write(111, *) "T3RHO   ", t3rho
c       endif



      call data_deallocate(iGENPOT)
      call load_deallocate()
      call fft_deallocate()
      call fft_deallocateL(iflag_fft2L)
      call load_deallocateL(iflag_fft2L)
      deallocate(workr_n)
c      deallocate(E_st)
c      deallocate(err_st)
      call data_deallocate_akx()    
      if(icoul.ne.0) then
      call data_deallocate_nL2()
      call fft_deallocateL2()        
      call load_deallocateL2()       
      endif
      if(nrot.gt.1) then
      deallocate(ig_star)
      deallocate(ig_star_stop)
      deallocate(ig_local)
      deallocate(ig_lenstar)
      endif

       dt07=mpi_wtime()
c       if(inode.eq.1.and.iflag_report.eq.1) 
c     &   write(111,*) "GENPOT, total (inside)",dt07-dt00

9000   continue

      call mpi_barrier(MPI_COMM_WORLD,ierr)      

      return
      end


