      subroutine getV_Hartree0(rho,vtot)
******************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
*************************************************************************
**  copyright (c) 2003, The Regents of the University of California,
**  through Lawrence Berkeley National Laboratory (subject to receipt of any
**  required approvals from the U.S. Dept. of Energy).  All rights reserved.
*************************************************************************

******************************************
***** All the arrays are in nr_nL in this subroutine


      use fft_data
      use load_data
      use data

      implicit double precision (a-h,o-z)
      include 'param.escan_real'

      real*8 vtot(mr_n),rho(mr_n)
      real*8, allocatable, dimension(:) :: workr_n,workr_n2,vtmp_n2
      integer icoul
      real*8 xcoul(3)
      
      common /comcoul/icoul
      common /comxcoul/xcoul


**************************************************
ccccc generate the potential vtot from rho(i)

      if(icoul.ne.0.and.inode.eq.1) then
      write(6,*) "icoul must be 0 in this version, stop"
      stop
      endif
      

      allocate(workr_n(mr_n))

      ng2_n=ngtotnod2(inode)
      nr_n=n1*n2*n3/nnodes
      nr=n1*n2*n3

      vtot = 0.0d0

      do i=1,nr_n
      workr_n(i) = rho(i)
      enddo

      call d3fft_real2(vtot,workr_n,1,0)


      pi=4*datan(1.d0)

      do 100 i=1,ng2_n
 
      if(inode.eq.iorg2(1).and.i.eq.iorg2(2)) then
      ig = iorg2(2)
      vtot(ig*2)=0.d0
      vtot(ig*2-1)=0.d0
      else
      vtot(i*2)=vtot(i*2)*2*pi/gkk2_n(i)
      vtot(i*2-1)=vtot(i*2-1)*2*pi/gkk2_n(i)
      endif

100   continue

      call d3fft_real2(vtot,workr_n,-1,0)

      do i=1,nr_n
      vtot(i) = workr_n(i)
      enddo

      deallocate(workr_n)
      return

      end

