      subroutine init_ugSP(AL,iwg_in,workr_n,kpt,iranm,
     &  iunit,ifrag)
******************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
*************************************************************************
**  copyright (c) 2003, The Regents of the University of California,
**  through Lawrence Berkeley National Laboratory (subject to receipt of any
**  required approvals from the U.S. Dept. of Energy).  All rights reserved.
*************************************************************************

******************************************
ccc if iwg_in.eq.1           :      read wavefunction from disk
ccc if iwg_in.eq.100         :      read wavefunction from memory frag_group_wave 
ccc if iwg_in.eq.0           :      generate wavefunction from random

cccc we will not copy the wavefunction to frag_group_wave. We only do that at the end
****************************************
cccccc this is just for one kpt. 
****************************************
****  It stores the wavefunction in G space. 
******************************************
      use fft_data
      use load_data
      use data
      use IOdata
      use MParallel
      implicit double precision (a-h,o-z)

c      include 'mpif.h'
      include 'param.escan_real'

      integer status(MPI_STATUS_SIZE)
******************************************
       real*8 AL(3,3),ALt(3,3)
***********************************************
       complex*16 workr_n(mr_n)
       real*8 x1a(mg_nx), x2a(mg_nx), xnorm(mx)
       complex*16 c1, ci

       c1 = dcmplx(1.d0,0.d0)
       ci = dcmplx(0.d0,1.d0)

*************************************************
****  input ug from file  and check the consistency
*************************************************

       if(iwg_in.eq.1) then
       call read_ug()
       endif

       if(iwg_in.eq.100) then
       ig0=io_wfrag(ifrag)%ipos_wave
       do m=1,mx
       ug_n(1:mg_nx,m)=frag_group_wave(ig0:ig0+mg_nx-1)
       ig0=ig0+mg_nx
       enddo
       endif
       
************************************************
*** generate the initial wavefunction ug from random if iwg_in.eq.0
************************************************
      if(iwg_in.eq.0) then
c$$$****  this is the one should be used later
c$$$	do m=1,mx
c$$$	do i=1,nr_n
c$$$        x1=ran1(iranm)
c$$$        x2=ran1(iranm)
c$$$        workr_n(i)=dcmplx(x1-0.5d0,x2-0.5d0)
c$$$cc        workr_n(i)=dcmplx(x1-0.5d0,0.d0)
c$$$	enddo
c$$$************************************************
c$$$
c$$$        call mpi_barrier(MPI_COMM_K,ierr)
c$$$
c$$$        call d3fft_comp(ug_n(1,m),workr_n,1,kpt)

        
         ng_n = ngtotnod(inode,kpt) 
         call random_seed(iranm)
         do m=1,mx
            call random_number(x1a)
            call random_number(x2a)
 
            
            do ig=1, ng_n
               ug_n(ig,m) = dcmplx(x1a(ig)-0.5d0,x2a(ig)-0.5d0)
            enddo
            
            do ig=ng_n+1, mg_nx
               ug_n(ig,m) = dcmplx(0.d0,0.d0)
            enddo
         enddo

!	I found orthogonalizing waveufunction heare make convergence faster, at least 1 iteration faster.
!       Following subroutine ortho-normalize wf. Byounghak
!         call orthogonal_cholesky2(ug_n,mg_nx,mx,ng_n)

      endif
*************************************************
**** end generate the initial wavefunction from random
*************************************************
ccccccccccccccccccccccccccccccccccccccccccccccccc
ccc    This cannot be called. Otherwise, it will cause segmentation fault. Something is not 
ccc   defined yet at this step. In any case, it is not necessary to make this orthogonal. 
cccc  The random wavefunctions are almost orthogonal anyway.  
cccc don't uncomment this !!!  Lin-Wang, Feb.12, 2008
c        do m=1,mx
c        call orth_comp(ug_n(1,m),ug_n,m-1,1,kpt,
c     &   sug_n,swg,1,0,fnorm)     ! ipsp_all always be 1 here, since sug_n is not known yet
c	enddo
*************************************************
      return
      contains
*************************************************

       subroutine read_ug()

       complex*16,allocatable,dimension(:) :: ugtemp

        call mpi_barrier(MPI_COMM_K,ierr)
cccccc  file (31) should have been opened before the do loop for kpt=1,nkpt

ccccccccccccc check the header.
        if(inode==nnodes.and.kpt.eq.1) then

         read(unit=iunit)n1t,n2t,n3t,mg_nxt,mxt
         read(unit=iunit)Ecutt
         read(unit=iunit)ALt
         read(unit=iunit)nnodes_o

         if(n1t.ne.n1.or.n2t.ne.n2.or.n3t.ne.n3) then
         write(6,*) "n1t,n2t,n3t changed, stop", n1t,n2t,n3t
         call mpi_abort(MPI_COMM_WORLD,ierr)
         endif

         if(mxt.ne.mx.or.mg_nxt.ne.mg_nx) then
         write(6,*) "mx,mg_nx changed,stop",mx,mg_nx,mxt,mg_nxt
         call mpi_abort(MPI_COMM_WORLD,ierr)
         endif

         if(abs(Ecut-Ecutt).gt.1.D-9) then
         write(6,*) "Ecut,changed, stop", Ecut,Ecutt
         call mpi_abort(MPI_COMM_WORLD,ierr)
         endif

         diff=0.d0
         do i=1,3
            do j=1,3
               diff=diff+dabs(AL(i,j)-ALt(i,j))
             enddo
         enddo

         if(diff.gt.0.001d0) then
            write(6,*) "the AL.ne.ALt, stop"
         call mpi_abort(MPI_COMM_WORLD,ierr)
         endif

         if(nnodes_o.ne.nnodes) then
           write(6,*) "nnodes_o changed, stop", nnodes_o,nnodes
         call mpi_abort(MPI_COMM_WORLD,ierr)
         endif

      endif     ! check the header, make sure it is the same
ccccccccccccccccccccccccccccccccccccccccc
         call mpi_barrier(MPI_COMM_K,ierr)

         if(inode==nnodes) then

            do i=0,nnodes-2
                  read(unit=iunit) ug_n    ! assuming the mg_nx is the same as before

          call mpi_send(ug_n,mg_nx*mx,MPI_DOUBLE_COMPLEX,i,
     &            102,MPI_COMM_K,ierr)
            end do

               read(unit=iunit) ug_n      ! this is for inode=nnodes itself 

         else   ! for other nodes

         call mpi_recv(ug_n,mg_nx*mx,MPI_DOUBLE_COMPLEX,nnodes-1,
     &       102,MPI_COMM_K,status,ierr)

         end if

        return
        end subroutine read_ug

        end

