      subroutine inputSP(AL0,ilocal,tolug,tolE,
     &  niter0,nline0,iCGmth0,
     &  iscfmth0,FermidE0,
     &  itypeFermi0,mCGbad0,
     &  islda,igga,ntype,iiatom,
     &  ipsp_type,ipsp_all,vwr_atom,nref_type,
     &  ivext_in,idens_out,isym,ikpt_yno,nkpt,nrot,
     &  fxatom_in,iter_PEtot)
******************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
cc     Copyright 2001 The Regents of the University of California
cc     The United States government retains a royalty free license in this work
******************************************

****************************************
****  It stores the wavefunction in G space, only in half
****  of the E_cut sphere. 
******************************************

       use fft_data
       use load_data
       use data
       use MParallel
       use input_head

      implicit double precision (a-h,o-z)

ccc      include 'mpif.h'      ! already included in MParallel

      include 'param.escan_real'
******************************************
       real*8 AL0(3,3)
***********************************************
*************************************************
       real*8 xatom(3,matom)
       integer iatom(matom),imov_at(3,matom),iiatom(mtype),
     &    ityatom(matom)
       integer numref(matom)
       integer smatr(3,3,48),nrot
       integer iCGmth0(100),iCGmth1(100),iscfmth0(100),iscfmth1(100)
       real*8 FermidE0(100),FermidE1(100),totNel
       integer itypeFermi0(100),itypeFermi1(100)
       integer kpt_dens(2),ispin_dens(2),iw_dens(2)
       integer niter0,nline0,niter1,nline1,mCGbad0,mCGbad1
       integer icoul
       real*8 xcoul(3)
 
**************************************************
       integer ipsp_type(mtype),nref_type(mtype)
       character*50 vwr_atom(mtype),fforce_out,fdens_out
       character*50 f_tmp,fxatom_out,fvext_in

       character*50 f_xatom,sym_file,kpt_file,fxatom_in

      common /comcoul/icoul
      common /comxcoul/xcoul

**************************************************
cccccccccccccccccccccccccccccccccccccccc
       character*50 work_dirs(100)
       common /Wdir_com/work_dirs
ccccccccccccccccccccccccccccccccccccccc

       
c       f_xatom=fxatom_in_h
       fxatom_in="xatom.in"     ! this is the xatom name in the sub directory, this is okay
c       open(10,file=f_xatom,status='old',action='read',iostat=ierr)
c       rewind(10)
c       read(10,*) natom
c       read(10,*) AL0(1,1),AL0(2,1),AL0(3,1)
c       read(10,*) AL0(1,2),AL0(2,2),AL0(3,2)
c       read(10,*) AL0(1,3),AL0(2,3),AL0(3,3)
c       close(10)

       ntypet=ntype1_h
       islda=islda_h
       igga=igga_h
       if(islda.ne.1) then
       if(inode.eq.1) write(6,*)  "islda must be 1, stop"
       call mpi_abort(MPI_COMM_WORLD,ierr)
       endif
       Ecut=Ecut_h
       Ecut2=Ecut2_h
       Ecut2L=Ecut2L_h
       Smth=Smth_h
       icoul=icoulF_h
       xcoul(1)=xcoulF_h(1)
       xcoul(2)=xcoulF_h(2)
       xcoul(3)=xcoulF_h(3)
       ivext_in=0
       idens_out=0
       isym=0
       ikpt_yno=0
       nkpt=1
       nrot=1
       tolug=tolug_h
       tolE=tolE_h
       
       if(iter_PEtot.eq.1) then
       niter0=niter1_h
       nline0=nline1_h
       mCGbad0=mCGbad1_h
        do i=1,niter0
        iCGmth0(i)=iCGmth1_h(i)
        iscfmth0(i)=iscfmth1_h(i)
        FermidE0(i)=FermidE1_h(i)
        itypeFermi0(i)=itypeFermi1_h(i)
        FermidE0(i)=FermidE0(i)/27.211396d0
        enddo
       endif

       if(iter_PEtot.ne.1) then
       niter0=niter2_h
       nline0=nline2_h
       mCGbad0=mCGbad2_h
        do i=1,niter0
        iCGmth0(i)=iCGmth2_h(i)
        iscfmth0(i)=iscfmth2_h(i)
        FermidE0(i)=FermidE2_h(i)
        itypeFermi0(i)=itypeFermi2_h(i)
        FermidE0(i)=FermidE0(i)/27.211396d0
        enddo
       endif
        
       ilocal=ilocal_h
       rcut=rcut_h
       ntype=ntype_h
       do ia=1,ntype
       vwr_atom(ia)=fvwr_h(ia)
       ipsp_type(ia)=ipsp_type_h(ia)
       enddo
*************************************************************

       call system_flush(6)

       if(n1.eq.n1L.and.n2.eq.n2L.and.n3.eq.n3L.and.
     &  dabs(Ecut2-Ecut2L).lt.0.01) then
        iflag_fft2L=0        ! fft2 and fft2L are the same
        else
        iflag_fft2L=1
        endif

       ipsp_all=1
       do ia=1,ntype
       if(ipsp_type(ia).eq.2) ipsp_all=2
       enddo
       if(ilocal.eq.1) ipsp_all=1
       

*************************************************
**** change Ecut,Eref to A.U
*************************************************
       Ecut=Ecut/2
       Ecut2=Ecut2/2
       Ecut2L=Ecut2L/2
*************************************************

*************************************************
       nh1=n1/2+1
*************************************************
       if(inode.eq.1) then
        do ia=1,ntype
        if(ipsp_type(ia).eq.1) then
        call readvwr_head()
        else
        call readusp_head(vwr_atom(ia),iiatom(ia),nref_type(ia))
        endif
        enddo
       endif

       call mpi_bcast(nref_type,mtype,MPI_INTEGER,
     &            0,MPI_COMM_K,ierr)
       call mpi_bcast(iiatom,mtype,MPI_INTEGER,
     &            0,MPI_COMM_K,ierr)
*************************************************
      return
      contains

*******************************************
      subroutine readvwr_head()

      implicit double precision (a-h,o-z)


      open(10,file=vwr_atom(ia),status='old',action='read',iostat=ierr)
      if(ierr.ne.0) then
      if(inode.eq.1)
     & write(6,*) "file ***",filename,"*** does not exist, stop"
      call mpi_abort(MPI_COMM_WORLD,ierr)
      endif
      read(10,*) nrr_t,ic_t,iiatom(ia),zatom_t,iloc_t,occ_s_t,
     &  occ_p_t,occ_d_t
      read(10,*) is_ref_t,ip_ref_t,id_ref_t,
     &  is_TB_t,ip_TB_t,id_TB_t
      close(10)


cccccccccccccccccccccccccccccccccccccccccccccccccc
cccc Make sure this is the same as in w_line_vwr.f
cccccccccccccccccccccccccccccccccccccccccc
      if(iloc_t.eq.1) is_ref_t=0
      if(iloc_t.eq.2) ip_ref_t=0
      if(iloc_t.eq.3) id_ref_t=0

      nref_type(ia)=is_ref_t+ip_ref_t*3+id_ref_t*5

      return
      end subroutine readvwr_head


      subroutine error_stop(i1)
      implicit double precision(a-h,o-z)
      if(inode.eq.1) then
      write(6,*) "error in etot.input, line=",i1
      endif
      call mpi_abort(MPI_COMM_WORLD,ierr)

      return
      end subroutine error_stop

      end
      
      

