cc this program average the surface passivation potential dvr for fragments
cc that have a common boundary.
cc this is a specific division of the 1x1x1 base fragment to 8 cubics. 
cccccccccccccccccccccccccccccccccccccccccccc
c      program ave_dvr_cubicN 
      subroutine ave_dvr_cubicN_S(inode,nnodes,m1,m2,m3) 
      implicit double precision(a-h,o-z)

      include 'mpif.h'
      integer status(MPI_STATUS_SIZE)

      character*50 f_dens_d,tmp,f_cubic,file_name
      character*10 fm_label
      real*8  add_vacu(3)
      real*8 AL(3,3),ALI(3,3)
      real*8 vr_test


      real*8, allocatable, dimension (:,:,:) :: vr
      real*8, allocatable, dimension(:) :: vr_tmp,dvr_cub
      integer, allocatable, dimension(:,:,:) :: ifm_exist,icub_rec 
      integer ijk(3),ijk_tmp(3)
      integer ind_pc(3)
      integer ifm(4),ism(4),ipos(4),jfm(4),jsm(4),jpos(4),
     & kfm(4),ksm(4),kpos(4)	!(ipos,jpos,kpos) is the position of the cub inside the fragment
      integer n1,n2,n3,nnodes   ! so to determine the record number for direct accessable file

      integer, allocatable,dimension(:,:,:,:,:,:) :: igroup_ind,
     &          ipos_ind


      integer index_bf(3,8000),irec(4,4,4)
cccccccccccccccccccccccccc


c      call getArg(1,tmp)
c      read(tmp,*) f_cubic

      f_cubic="cubic"

c      call mpi_init(ierr)
c      call mpi_comm_rank(MPI_COMM_WORLD, inode, ierr)   
c      call mpi_comm_size(MPI_COMM_WORLD, nnodes, ierr)
c      inode=inode+1

c      if(inode.eq.1) then
c      write(6,*) "begining of average_dvr", inode
c      endif

      if(inode.gt.m1*m2*m3) goto 8000

      time00=mpi_wtime()

cc read in LS3DF.input
      open(10,file='LS3DF.input',status='old',action='read',iostat=ierr)
      rewind(10)
      read(10,*) itmp 
      read(10,*) itmp 
      read(10,*) itmp,m1,m2,m3
      read(10,*) itmp,ngppa1,ngppa2,ngppa3 ! number of grid points per a
      read(10,*) itmp,add_vacu(1),add_vacu(2),add_vacu(3)
      read(10,*) itmp,nslice, multi     !nprocs_pot=nlice*multi
      read(10,*) itmp
      read(10,*) itmp
      read(10,*) itmp,ntype
      do i=1,ntype
      read(10,*) itmp 
      enddo
      close(10)
      nprocs_pot=nslice*multi		!not being used anyway

      allocate(igroup_ind(m1,m2,m3,2,2,2))
      allocate(ipos_ind(m1,m2,m3,2,2,2))

      open(15,file="ind.store",status="old",form="unformatted")
      rewind(15)
      read(15) igroup_ind
      read(15) ipos_ind
      close(15)


cccccccccccccccccccccccccccccccccccccc
cc the maximum record length for dvr_cp
      LREC_C=ngppa1*(0.50001+add_vacu(1))*
     &       ngppa2*(0.50001+add_vacu(2))*
     &       ngppa3*(0.50001+add_vacu(3))
      LREC_C8=LREC_C*8
cccccccccccccccccccccc
cc for each corner ibf,jbf,kbf, generate dvr coner-cubic (maximum 64) 

      nbuff1=ngppa1*add_vacu(1)+0.0001
      nbuff2=ngppa2*add_vacu(2)+0.0001
      nbuff3=ngppa3*add_vacu(3)+0.0001

ccccccccccccccccccccccccccccccccccccccc
      ijob=0
      do ibf=1,m1
      do jbf=1,m2
      do kbf=1,m3
      ijob=ijob+1
      index_bf(1,ijob)=ibf
      index_bf(2,ijob)=jbf
      index_bf(3,ijob)=kbf
      enddo
      enddo
      enddo
      njobs=m1*m2*m3
ccccccccccccccccccccccccccccccccccccccc

       ijob=0
       njob_count=0
2000   continue

cccccccccc  assign job for each processor inode
       ijob_prev=ijob
       ijob=njob_count*nnodes+inode
       njob_count=njob_count+1
       if(ijob.gt.njobs) goto 2001    ! finish it, jump out point

       ibf=index_bf(1,ijob)
       jbf=index_bf(2,ijob)
       kbf=index_bf(3,ijob)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc directions of each cubic 
      do 1002 idir=-1,1,2
      do 1002 jdir=-1,1,2
      do 1002 kdir=-1,1,2

cc surface or interface? isi=1--> surface;isi=0--> interface 
      do 1003 isi=0,1
         ncp1=ngppa1/2+isi*nbuff1
      do 1003 jsi=0,1
         ncp2=ngppa2/2+jsi*nbuff2
      do 1003 ksi=0,1
         ncp3=ngppa3/2+ksi*nbuff3
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccc Note, one cubic and one type (interface) is only dealt by one processors, 
ccccccc So, there is no danger of redo one cubic by different processors. 

      len_dvr_cub=ncp1*ncp2*ncp3     ! the actual length of the cube

      allocate(dvr_cub(len_dvr_cub))    
      allocate(vr_tmp(len_dvr_cub))
      dvr_cub=0.d0

       call fragment_case(ibf,idir,isi,nicase,ifm,ism,ipos)
       call fragment_case(jbf,jdir,jsi,njcase,jfm,jsm,jpos)
       call fragment_case(kbf,kdir,ksi,nkcase,kfm,ksm,kpos)

       allocate(ifm_exist(nicase,njcase,nkcase))
       allocate(icub_rec(nicase,njcase,nkcase))

ccccccccccccccccccccccccccccccccccccccc
cc Now go through each fragment that contains this cubic
       ncount_case=0
       ifm_exist=1
       do 1005 ic=1,nicase
       do 1005 jc=1,njcase
       do 1005 kc=1,nkcase

       ifm1=mod(ifm(ic)-1+m1,m1)+1     ! wrapping
       jfm1=mod(jfm(jc)-1+m2,m2)+1
       kfm1=mod(kfm(kc)-1+m3,m3)+1


       igroup=igroup_ind(ifm1,jfm1,kfm1,
     &           ism(ic),jsm(jc),ksm(kc))
       ipos_cubic=ipos_ind(ifm1,jfm1,kfm1,
     &           ism(ic),jsm(jc),ksm(kc))

      if(igroup.eq.0) then
      ifm_exist(ic,jc,kc)=0
      icub_rec(ic,jc,kc)=-1
      goto 1005		! this fragment is empty, does not exist
      endif

       ichar4=igroup/1000
       ichar3=(igroup-ichar4*1000)/100
       ichar2=(igroup-ichar4*1000-ichar3*100)/10
       ichar1=igroup-ichar4*1000-ichar3*100-ichar2*10

c       file_name='d_'//trim(f_cubic)//'/'//trim(f_cubic)//'_group.'
       file_name='d_cubic/cubic_group.'
     &   //char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)

       open(12,file=file_name,form="unformatted",access="direct",
     & status='old',action='read',recl=LREC_C8,iostat=ierr)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc for each fragment, define an array irec to determine the record number 
cc of each cubic in the diret accessable density file of this fragment
cc       ith_rec=0
       ith_rec=ipos_cubic-1      ! the starting record position for this fragment
       irec=0
       do 1111 iaxis=1,2*ism(ic)
       do 1111 jaxis=1,2*jsm(jc)
       do 1111 kaxis=1,2*ksm(kc)
       ith_rec=ith_rec+1
       irec(iaxis,jaxis,kaxis)=ith_rec 
1111   continue

       icub_rec(ic,jc,kc)=irec(ipos(ic),jpos(jc),kpos(kc))
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      ncount_case=ncount_case+1
      vr_tmp=0.d0 
      read(12,rec=icub_rec(ic,jc,kc)) vr_tmp
cccccccccccccc   for the inner cubic (no surface), the dvr is set to be zero
      if(isi.eq.0.and.jsi.eq.0.and.ksi.eq.0) then
      vr_tmp=0.d0
      endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      dvr_cub=dvr_cub+vr_tmp

      close(12)

1005   continue


      if(ncount_case.gt.0) then
      dvr_cub=dvr_cub/ncount_case
      else   !this case should never happen
      dvr_cub=0.d0
      endif
     
ccccccccccccccccccccccccccccccccccccccccccccccccc
cc  write dvr_cub into each fragment that contain this cubic 
cccccccccccccccccccccccccccccccccccccccccccccc
       ncount_case=0

       do 1006 ic=1,nicase	!--
       do 1006 jc=1,njcase	!   --> 3 indices Determine one fragment
       do 1006 kc=1,nkcase   	!--

       ifm1=mod(ifm(ic)-1+m1,m1)+1     ! wrapping
       jfm1=mod(jfm(jc)-1+m2,m2)+1
       kfm1=mod(kfm(kc)-1+m3,m3)+1

       igroup=igroup_ind(ifm1,jfm1,kfm1,
     &           ism(ic),jsm(jc),ksm(kc))

       if(igroup.eq.0) goto 1006     ! this fragment doesn't exist, empty

       ichar4=igroup/1000
       ichar3=(igroup-ichar4*1000)/100
       ichar2=(igroup-ichar4*1000-ichar3*100)/10
       ichar1=igroup-ichar4*1000-ichar3*100-ichar2*10

c       file_name='d_'//trim(f_cubic)//'/'//trim(f_cubic)//'_group.'
       file_name='d_cubic/cubic_group.'
     &   //char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if (ifm_exist(ic,jc,kc).eq.1) then
       open(13,file=file_name,form="unformatted",access="direct",
     & status='old',action='write',recl=LREC_C8,iostat=ierr)
      ncount_case=ncount_case+1
      write(13,rec=icub_rec(ic,jc,kc)) dvr_cub
      close(13)
cccccccccccccccccccccc here is a poor man's way for not buffering, but it could be dangerously slow, Lin-Wang, March. 15. 
ccccc This might not work, because other processors might be writting to this file. Does this block the open statement???
cccccc This is not necessary. close(13) should have flushed it, so other processor can read from it. 
c       open(13,file=file_name,form="unformatted",access="direct",
c     & status='old',action='read',recl=LREC_C8,iostat=ierr)
c      ncount_case=ncount_case+1
c      read(13,rec=icub_rec(ic,jc,kc)) vr_test
c      close(13)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      endif

1006   continue		

      deallocate(icub_rec)
      deallocate(ifm_exist)
      deallocate(vr_tmp)
      deallocate(dvr_cub)

ccccc up to here is handling one specific cubic

1003  continue		! isi,jsi,ksi	
1002  continue		! idir,jdir,kdir	
c1001  continue		! ibf,jbf,kbf	

      goto 2000
2001  continue

8000  continue

      call mpi_barrier(MPI_COMM_WORLD,ierr)

cc      call mpi_finalize(ierr)

cc      stop
      return
      end subroutine ave_dvr_cubicN_S

ccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccc
       subroutine fragment_case(ibf,idir,isi,nicase,ifm,ism,ipos)
       implicit double precision (a-h,o-z)
       integer ifm(4),ism(4),ipos(4)
ccccc for a given cornner cubic at ibf, direction idir, interface isi, 
ccccc find all the possible cases (nicase) of fragments which cover this corner cubic
ccccc store in nicase, ifm (fragment position) and ism (fragment size)

       if(idir.eq.1.and.isi.eq.1) then      !  surface
       nicase=2         ! two cases
       ifm(1)=ibf       ! fragment position
       ism(1)=1         ! size
       ipos(1)=1        ! position of the cubic in the original fragment (1:2*ism)
       ifm(2)=ibf
       ism(2)=2
       ipos(2)=1        
       endif

       if(idir.eq.1.and.isi.eq.0) then      ! interface
       nicase=1
       ifm(1)=ibf-1
       ism(1)=2
       ipos(1)=3
       endif

       if(idir.eq.-1.and.isi.eq.1) then
       nicase=2
       ifm(1)=ibf-1
       ism(1)=1
       ipos(1)=2
       ifm(2)=ibf-2
       ism(2)=2
       ipos(2)=4
       endif

       if(idir.eq.-1.and.isi.eq.0) then
       nicase=1
       ifm(1)=ibf-1
       ism(1)=2
       ipos(1)=2
       endif
       
       return
       end 



