      program LS3DF

ccccc This is just a driver program
ccccccccccccccccccccccccccccccccccccccccccccc
      use IOdata
      use MParallel
      use IOmch
      use input_head

ccccc sorry, these two parameters must be the same as in param.escan_real
      parameter (mtype=6)
      parameter (mnq=4000)
ccccccccccccccccccccccccccccccccccccccccccccc
ccccc extremely important, the LS3DF cannot use param.escan_real, 
ccccc otherwise, parameters like MPI_COMM_K will be rewritten. 
ccccc The MPI_COMM_K in LS3DF is fixed, but in mainMV2_S2.f, GENPOT, it is changing. 
ccccc it change from the MPI_COMM_K in LS3DF (in mainMV2_S2) to MPI_COMM_K_G (in GENPOT). 
ccccc Perhaps, we should write MPI_COMM_K as MPI_COMM_K_S here. 
cccccccccccccccccccccccccccccccccccccccccc
      implicit double precision (a-h,o-z)
      character*50 f_dens,f_dens_tot,f_vtot,f_vF
      character*50 fwg_in,fwg_out,frho_in,frho_out,file_tmp
      character*50 fvr_in,fvr_out
      character*50 f_atom_vtot,f_atom_vF

      character (len=50) string1,string2

c      integer :: GLOBAL_totalnodes, GLOBAL_rank
c      integer :: XMPI_COMM_WORLD, XMPI_color, XMPI_key     ! declare in IOdata
c      integer :: nnodes_k              ! declareed in IOdata
      integer ::  num_group
      integer :: inode_tot,nnodes_tot,icolor,ikey,
     &   nnodes,inode,nnodes_all,n_tmp
      integer :: MPI_COMM_K, MPI_COMM_N

      integer nXMPI

      integer ::  ierr
      real*8 AL(3,3)


c      include 'mpif.h'      ! declared in MParallel
      integer status(MPI_STATUS_SIZE)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccc begin the MPI splitting etc. 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      call mpi_init(ierr)
      call mpi_comm_size(MPI_COMM_WORLD,GLOBAL_totalnodes,ierr)
      call mpi_comm_rank(MPI_COMM_WORLD,GLOBAL_rank,ierr)

      nnodes_all=GLOBAL_totalnodes
      inode_all=GLOBAL_rank+1

      time00=mpi_wtime()
      time01_1=mpi_wtime()

      if(inode_all.eq.1) then
      open(3,file="LS3DF.report")
      rewind(3)
      write(3,*) "Beginning of the LS3DF run,after mpi_init",
     &            time01_1-time00
      flush(3)
      endif


c       call mpi_barrier(MPI_COMM_WORLD,ierr)


      call input_LS3DF()
      time01_2=mpi_wtime()

      call mpi_barrier(MPI_COMM_WORLD,ierr)
      if(inode_all.eq.1) then
      write(3,*) "after input_LS3DF ", time01_2-time01_1
      flush(3)
      endif


ccc  Need nnodes_k, num_group
       file_tmp=fxatom_in_h
       iflag_mem_wave=iflag_mem_wave_h
       iflag_mem_loc=iflag_mem_loc_h
       iflag_report=iflag_report_h
       num_groupF=num_groupF_h
       nnodes_k=nnodes_k_h
       nnodes_tot_G=nnodes_tot_G_h
       m1=m1_h
       m2=m2_h
       m3=m3_h
       nm1=nm1_h
       nm2=nm2_h
       nm3=nm3_h
       ngppa1=ngppa1_h
       ngppa2=ngppa2_h
       ngppa3=ngppa3_h
       add_vac1=add_vac1_h
       add_vac2=add_vac2_h
       add_vac3=add_vac3_h
       nslice=nslice_h
       multi=multi_h
       ido_dVr=ido_dVr_h
       dvr_barr=dvr_barr_h
       nbr=nbr_h
       iter_init=iter_init_h
       niter=niter_h
       ntype=ntype1_h
       Ecut=Ecut_h
       niter_t1=niter1_h
       niter_t1=niter2_h
       ilocal=ilocal_h
       rcut=rcut_h
       ntype_t1=ntype_h
       n1_G=n1_h
       n2_G=n2_h
       n3_G=n3_h
       n1L_G=n1L_h
       n2L_G=n2L_h
       n3L_G=n3L_h
       icoul=icoul_h
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       Ecut=Ecut/2
       iflag_mem_loc2=0
       iflag_mem_loc3=0
       if(iflag_mem_loc.eq.1.and.ilocal.eq.2) iflag_mem_loc2=1
       if(iflag_mem_loc.eq.1.and.ilocal.eq.3) iflag_mem_loc3=1
       open(11,file=file_tmp)
       rewind(11)
       read(11,*) natom_all
       read(11,*) AL(1,1),AL(2,1),AL(3,1)
       read(11,*) AL(1,2),AL(2,2),AL(3,2)
       read(11,*) AL(1,3),AL(2,3),AL(3,3)
       close(11)
       volume=al(3,1)*(al(1,2)*al(2,3)-al(1,3)*al(2,2))
     &     +al(3,2)*(al(1,3)*al(2,1)-al(1,1)*al(2,3))
     &     +al(3,3)*(al(1,1)*al(2,2)-al(1,2)*al(2,1))
       n1_all=m1*ngppa1
       n2_all=m2*ngppa2
       n3_all=m3*ngppa3

       vol_pergrid=abs(volume)/(n1_all*n2_all*n3_all)
  
       num_group=1   ! this is the num of k-point group in PEtot for each fragment
       ngroup2=1     ! ngroup2 is used for m1*m2*m3, but it must be 1 in this version
   
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      call mpi_barrier(MPI_COMM_WORLD,ierr)


       if(nslice*multi.ne.nnodes_tot_G) then
        if(inode_all.eq.1)  write(6,*)
     & "STOP, nslice*multi.ne.nnodes_tot_G", nslice,multi,
     &  nnodes_tot_G
        call mpi_abort(MPI_COMM_WORLD,ierr)
        endif

      if(m1*ngppa1.ne.n1_G.or.m2*ngppa2.ne.n2_G.
     &  or.m3*ngppa3.ne.n3_G) then
        if(inode_all.eq.1) write(6,*)
     & "STOP, m1,2,3*nd1,2,3.ne.n1,2,3(for GENPOT)",
     &  m1,m2,m3,ngppa1,ngppa2,ngppa3,n1_G,n2_G,n3_G
        call mpi_abort(MPI_COMM_WORLD,ierr)
        endif

       if(nnodes_all.lt.nm1*nm2*nm3) then
       if(inode_all.eq.1) write(6,*)
     &  "STOP, nnodes_all.lt.nm1*nm2*nm3",nnodes_all,
     &   nm1,nm2,nm3,nm1*nm2*nm3
        call mpi_abort(MPI_COMM_WORLD,ierr)
        endif

       if(nnodes_all.lt.nnodes_k) then
       if(inode_all.eq.1) write(6,*)
     &  "STOP, nnodes_all.lt.nnodes_k",nnodes_all,
     &   nnodes_k
        call mpi_abort(MPI_COMM_WORLD,ierr)
        endif

cccccccc special requirment for this special version
       if(nnodes_all.ne.nnodes_k*num_groupF) then
       if(inode_all.eq.1) write(6,*)
     &  "STOP, nnodes_all.ne.nnodes_k*num_groupF",nnodes_all,
     &   nnodes_k,num_groupF
        call mpi_abort(MPI_COMM_WORLD,ierr)
        endif



      nXMPI=GLOBAL_totalnodes/(nnodes_k*num_group)

cccccc nnodes_k is the num of proc for each k-point
cccccc num_group is the num of k-point groups  (in our case, num_group=1)
cccccc nXMPI  is the num of PEtot groups working on the fragments

      if (nXMPI*nnodes_k*num_group .ne. GLOBAL_totalnodes) then
       write(6,*) "nXMPI*num_group*nnodes_k.ne."//
     &    "GLOBAL_totalnodes, stop",nnodes_k,num_group,nnodes_all
       call mpi_abort(MPI_COMM_WORLD,ierr)
       end if

ccccccccccccccccccccccccccccccccccccccc
       n_tmp=nnodes_k*num_group
       XMPI_color = GLOBAL_RANK/n_tmp    
       XMPI_key = GLOBAL_RANK-XMPI_color*nnodes_k*num_group
ccccccccccccccccccccccccccccccccccccccccccccccccccc

       call mpi_comm_split(MPI_COMM_WORLD,XMPI_color,XMPI_key,
     &         XMPI_COMM_WORLD,ierr)

       call mpi_comm_rank(XMPI_COMM_WORLD,inode_tot,ierr)
       call mpi_comm_size(XMPI_COMM_WORLD,nnodes_tot,ierr)

cccccccc  nnodes_tot is the total number of processors within each PEtot group
cccccccc  XMPI_COMM_WORLD is the COMM_WORLD within each PEtot code (num of proc=nnodes_tot=nnodes_k*num_group=nnodes_k)

       if(nnodes_k*num_group.ne.nnodes_tot) then
       write(6,*) "nnodes_k*num_group.ne.nnodes_tot,stop",
     &            nnodes_k,num_group,nnodes_tot
       call mpi_abort(MPI_COMM_WORLD,ierr)
       endif

       icolor=inode_tot/nnodes_k
       ikey=inode_tot-icolor*nnodes_k

cccccccccccccc in our case, we only have one color

       call mpi_comm_split(XMPI_COMM_WORLD,icolor,ikey,MPI_COMM_K,ierr)
       inode_tot=inode_tot+1
       nnodes=nnodes_k
       inode=ikey+1
cccccccc MPI_COMM_K is the COMM_WORLD within each k-point calculation (same icolor has
cccccccc the same MPI_COMM_K, and ikey determine the ranking within MPI_COMM_K). The number
cccccccc of proc within MPI_COMM_K is nnodes_k. In LS3DF, it is nnodes_tot. 

       call mpi_comm_split(XMPI_COMM_WORLD,ikey,icolor,MPI_COMM_N,ierr)


ccccccc MPI_COMM_N is the COMM_WORLD within each ikey ranked for different k-point groups. In our 
ccccccc case, the number of processors within one MPI_COMM_N is one. 

cccccccccccccc The following is for the spliting for GENPOT_V3
cccccccccc Note, inode_all,nnodes_all are the same as above, everything else has a _G

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        if(inode_all.le.nnodes_tot_G) then
        my_color_G=0
        inode_tot_G=inode_all-1
        else
        my_color_G=1                                   ! not to be used
        inode_tot_G=inode_all-nnodes_tot_G-1
        endif
cccccccccccc original, using two core per node

ccccccccc try to use only one core per node when nnodes_all is large
ccccccccc but only see small difference in time (less than 10%). 
ccccccccc To go back to the original (two core per node), uncomment above, and comment out below
ccccccccc This is for franklin only
c       if(nnodes_all.lt.2*nnodes_tot_G) then
c       if(inode_all.le.nnodes_tot_G) then
c       my_color_G=0
c       inode_tot_G=inode_all-1
c       else
c       my_color_G=1                                   ! not to be used
c       inode_tot_G=inode_all-nnodes_tot_G-1
c       endif
c       else
c       if(inode_all.le.2*nnodes_tot_G.and.mod(inode_all-1,2).eq.0) then
c       my_color_G=0
c       inode_tot_G=(inode_all-1)/2
c       else
c       my_color_G=1
c         if(inode_all.le.2*nnodes_tot_G) then
c         inode_tot_G=inode_all/2-1
c         else
c         inode_tot_G=inode_all-nnodes_tot_G-1
c         endif
c       endif
c       endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc end of GENPOT processor splitting
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


       call mpi_comm_split(MPI_COMM_WORLD,my_color_G,
     &  inode_tot_G,MY_COMM_WORLD_G,ierr)

       nnodes_k_G=nnodes_tot_G
       num_group_G=1

       icolor_G=inode_tot_G/nnodes_k_G
       ikey_G=inode_tot_G-icolor_G*nnodes_k_G

       call mpi_comm_split(MY_COMM_WORLD_G,icolor_G,ikey_G,
     &       MPI_COMM_K_G,ierr)
cccccc  splits the processor into num_group groups, the MPI_COMM_K is the group communicator
cccccc  the ikey is the local inode (in our case, num_group=1 !)

       inode_tot_G=inode_tot_G+1
       nnodes_G=nnodes_k_G
       inode_G=ikey_G+1
       call mpi_comm_split(MY_COMM_WORLD_G,ikey_G,icolor_G,
     &       MPI_COMM_N_G,ierr)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccc end of the MPI splitting etc. 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccc The two sets of splitting parameters are passed in to different
cccccc subroutines. 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      time01=mpi_wtime()

      if(inode_all.eq.1) then
      write(3,*) "finished init mpi_comm_split time(second)=",
     &  time01-time01_2
      flush(3)
      endif

      dt1 = mpi_wtime()
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      dt2 = mpi_wtime()
c      if (mod(inode_all, 100) .eq. 1) then
      if(inode_all.eq.1) then
      write(3,*) "finished init barrier=", dt2 - dt1
      flush(3)
      endif


ccccccccccccccccccccccccccccccccccccccccccc
        io_flag=0
        f_xatom=file_tmp

         dt1=mpi_wtime()
        call io_init(mnq,mtype)
         dt2=mpi_wtime()
        
      if(inode_all.eq.1) then
      write(3,*) "time for io_init",
     &  dt2-dt1
      flush(3)
      endif


        dt1=dt2

        call io_get_frag_info(inode_all-1,vol_pergrid,
     &     Ecut,rcut,inode_tot)

         dt2=mpi_wtime()
      if(inode_all.eq.1) then
      write(3,*) "time for io_get_frag_info",
     &  dt2-dt1
      flush(3)
      endif

        dt1=dt2

        call io_allocate(inode_all-1,iflag_mem_wave,
     &  iflag_mem_loc2,iflag_mem_loc3)

         dt2=mpi_wtime()
      if(inode_all.eq.1) then
      write(3,*) "time for io_allocate",
     &  dt2-dt1
      flush(3)
      endif
        dt1=dt2
        
       mrL=n1L_G*n2L_G*(n3L_G+2)
       mr_nL=mrL/nnodes_tot_G*
     & (1+3.d0*nnodes_tot_G/(n2L_G*n3L_G))
       mr=n1_G*n2_G*(n3_G+2)
       mr_n=mr/nnodes_tot_G*
     & (1+3.d0*nnodes_tot_G/(n2_G*n3_G))

c        npulay_max_G=20
        npulay_max_G=1

        if(my_color_G.eq.0) then    ! only allocate for the processors in the GENPOT group (_G)
        call allocate_mch(npulay_max_G,1, mr_n, mr_nL, 
     &   nnodes_tot_G,
     &  n1L_G,n2L_G,n3L_G)

         dt2=mpi_wtime()
      if(inode_all.eq.1) then
      write(3,*) "time for allocate_mch",
     &  dt2-dt1
      flush(3)
      endif

        endif

      if(inode_all.eq.1) then
      write(3,*) "finished the init allocations"
      flush(3)
      endif

      dt1 = mpi_wtime()
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      dt2 = mpi_wtime()
      if(inode_all.eq.1) then
      write(3,*) "finished the barrier", dt2-dt1
      flush(3)
      endif


ccccccccccccccccccccccccccccccccccccccccccc
cccc This is the extra part of the code to generate d_dvr
        if(ido_dVr.ne.0) then
ccccccccccccccccccc
ccc cp etotN.input.atom into etotN.input

        igroup_start=1
        num_group_persweep=nnodes_all/nnodes_k     ! the num of group can be calculated per sweep
        num_sweep=num_groupF/num_group_persweep
        if(num_sweep*num_group_persweep.lt.num_groupF) 
     &  num_sweep=num_sweep+1
       
cccccccc In this version, num_sweep=1

        fwg_in="BLANK"    
        fwg_out="BLANK"  
        frho_in="dens.out"
c        frho_out="dens.atom"     
        frho_out="dens.out"     ! do not save dens.atom    
        fvr_in="BLANK"
        fvr_out="vr.out"
        iwg_in=0
        iwg_out=0
        irho_in=0
         if(ido_dVr.eq.2.
     &     or.ido_dVr.eq.22) irho_in=1    ! input the rho in d_dens to generate dVr, instead of using atomic dens
        irho_out=2
        ivr_in=0
        ivr_out=2     
        iloc_save=0     
        iter_PEtot=0
        iter_init=0

        if(inode_all.eq.1) then
        write(3,*) "enter mainMV2_S, calc_dVr"
        flush(3)
        endif

       dt1=mpi_wtime()
      call mainMV2_S2(igroup_start,num_sweep,
     &   iter_PEtot,iter_init,fwg_in,fwg_out,frho_in,frho_out, 
     &   fvr_in,fvr_out,iwg_in,iwg_out,irho_in,irho_out,
     &   ivr_in,ivr_out,iloc_save,
     &   nXMPI,num_group,inode_tot,
     &   nnodes_tot,icolor,ikey,nnodes,inode,MPI_COMM_K,MPI_COMM_N,
     &   nnodes_all,GLOBAL_totalnodes, GLOBAL_rank,
     &   XMPI_COMM_WORLD,XMPI_color,XMPI_key,inode_all,iflag_mem_loc3,
     &   E_nsc_vrho_all,E_dvrrho_all,E_dvrrho2_all,
     &   iflag_report)
       dt2=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,*) "out mainMV2_S, calc_dVr",dt2-dt1
        flush(3)
        endif

ccccccccccccccccccc
cccccc it get the fragment density from d_dens.out
        f_dens="dens.out"       ! the fragment dens output (atomic charge) from above mainMV2_S
        f_dens_tot="dens.atom_tot"   ! the total density using atomic charge
        iread_dens=1
        if(inode_all.eq.1) then
        write(3,*) "enter get_denstot_fmPN_S, calc_dVr"
        flush(3)
        endif

       dt1=mpi_wtime()
c      call get_denstot_fmPN_NEW(f_dens,f_dens_tot,
c     &    inode_all,nnodes_all,iread_dens,iflag_report)
      call get_denstot_fmPN_fix(f_dens,f_dens_tot,
     &    inode_all,nnodes_all,iread_dens,iflag_report,
     &    XMPI_color,inode_tot_G)
       dt2=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,*) "out get_denstot_fmPN_NEW, calc_dVr",dt2-dt1
        flush(3)
        endif

ccccccccccccccccccc
ccccc inside GENPOT_V3_S, for icoul=0, always make icoul=0
        nscf=0
        frho_in="dens.atom_tot"     ! the total atomic charge density
        fvr_in="vr.in_tot"          ! not used for nscf=0
        fvr_out="vr.in_tot.001"
        ivr_in=0
        ivr_out=10                  ! write out on disk
        irho_in=1
        irho_out=0


        if(inode_all.eq.1) then
        write(3,*) "enter GENPOT_V3_S, calc_dVr"
        flush(3)
        endif

        dt1=mpi_wtime()
      call GENPOT_V3_S(nscf,frho_in,fvr_in,fvr_out,
     & ivr_in,ivr_out,irho_in,irho_out,
     & inode_all,nnodes_all,inode_tot_G,nnodes_tot_G,my_color_G,
     & nnodes_k_G,num_group_G,icolor_G,ikey_G,nnodes_G,inode_G,
     & MY_COMM_WORLD_G,MPI_COMM_K_G,MPI_COMM_N_G,ido_dVr,
     & Ealphat_head,Ewald_head,E_Hxc,E_ion,V_error,
     & iflag_report,npulay_max_G)
        dt2=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,*) "out GENPOT_V3_S, calc_dVr",dt2-dt1
        flush(3)
        endif

ccccccccccccccccccc
        iflag_mask=1
        if(ido_dVr.eq.11.or.
     &   ido_dVr.eq.22.or.ido_dVr.eq.33) iflag_mask=0
        f_atom_vtot="vr.in_tot.001"   ! the total potential from total atomic charge density"
        f_atom_vF="vr.out"     ! the fragment potential from fragment atomic charge density
ccccc inside gen_dvr_fmPN_S, get f_atom_vF from d_vr.out

        if(inode_all.eq.1) then
        write(3,*) "enter gen_dvr_fmPN_S, calc_dVr"
        flush(3)
        endif
ccccccccccc This is still the old style one, no need to change it
       dt1=mpi_wtime()
       call gen_dvr_fmPN_S(iflag_mask,f_atom_vtot,
     & f_atom_vF,inode_all,nnodes_all,dvr_barr,nbr)
       dt2=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,*) "out gen_dvr_fmPN_S, calc_dVr",dt2-dt1
        flush(3)
        endif
ccccccccccccccccccc
        if(ido_dVr.eq.3.or.ido_dVr.eq.33) goto 220   ! don't do dVr average
        if(inode_all.eq.1) then
       write(3,*) "enter frag2cubicN_S, 1, calc_dVr"
       flush(3)
       endif
       dt1=mpi_wtime()

ccc      call frag2cubicN_S(1,inode_all,nnodes_all,num_groupF)  

       dt2=mpi_wtime()
       if(inode_all.eq.1) then
       write(3,*) "out frag2cubicN_S, 1, calc_dVr",dt2-dt1
       flush(3)
       endif
cccccccccccccccccccccc
       if(inode_all.eq.1) then
       write(3,*) "enter ave_dvr_cubicN_S, calc_dVr"
       flush(3)
       endif
       dt1=mpi_wtime()

ccc      call ave_dvr_cubicN_S(inode_all,nnodes_all,m1,m2,m3)  

       dt2=mpi_wtime()
       if(inode_all.eq.1) then
       write(3,*) "out ave_dvr_cubicN_S, calc_dVr", dt2-dt1
       flush(3)
       endif
ccccccccccccccccccc
       if(inode_all.eq.1) then
       write(3,*) "enter frag2cubicN_S, 2, calc_dVr"
       flush(3)
       endif
       dt1=mpi_wtime()

ccc      call frag2cubicN_S(2,inode_all,nnodes_all,num_groupF)  

       dt2=mpi_wtime()
       if(inode_all.eq.1) then
       write(3,*) "out frag2cubicN_S, 2, calc_dVr",dt2-dt1
       write(3,*) "end of generating dVr"
       flush(3)
       endif
220     continue
ccccccccccccccccccc

       time_dVr=mpi_wtime()
       if(inode_all.eq.1) write(3,101) time_dVr-time01
101    format("time for dVr (second)=",f10.3)

       endif    ! for ido_dVr


ccccccccccccccccccccccccccccccccccccc
        iter_init=iter_init_h

        if(iter_init.lt.1) then
        iter_init=1
          if(inode_all.eq.1) write(6,*) 
     & "iter_init must be >=1, set it to 1"
        endif

       if(inode_all.eq.1) then
       open(72,file="EtotN.report",position="append")
       endif

        E_tot_old=0.d0
        do 1000 iter_PEtot=iter_init,iter_init+niter-1

        if(iter_PEtot.eq.3) goto 3333

        if(iter_PEtot.eq.iter_init+niter-1) then     ! always report at the last step
        iflag_report=1
        iflag_report_h=1
        endif


        write(string1,"(i3.3)") iter_PEtot
        write(string2,"(i3.3)") iter_PEtot+1

        f_vtot="vr.in_tot."//trim(string1)

        f_vF="vr.F"
        iread_dvr=0
        if(iter_PEtot.eq.iter_init) iread_dvr=1      ! read the dvr in for the first iteration, then store it there
        iwrite_vF=0
        if(iter_PEtot.eq.iter_init+niter-1) iwrite_vF=1   ! write the vF out for the last iteration

        if(inode_all.eq.1) then
        write(3,102) iter_PEtot, "  enter gen_vrF_fmPN_S"
102     format(i5,20x,a30)
        flush(3)
        endif
        time_i=mpi_wtime()
c       call gen_vrF_fmPN_NEW(f_vtot,f_vF,inode_all,nnodes_all,
c     &  iread_dvr,iwrite_vF,iflag_report)
       call gen_vrF_fmPN_fix(f_vtot,f_vF,inode_all,nnodes_all,
     &  iread_dvr,iwrite_vF,iflag_report,
     &  XMPI_color,inode_tot_G)
        time_f=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,103) iter_PEtot,time_f-time_i,
     &        time_f-time00, "  out gen_vrF_fmPN_S"
103     format(i5,1x,f9.2,1x,f9.2,a30)
        flush(3)
        endif

        igroup_start=1
        num_group_persweep=nnodes_all/nnodes_k     ! the num of group can be calculated per sweep
        num_sweep=num_groupF/num_group_persweep
        if(num_sweep*num_group_persweep.lt.num_groupF) 
     &  num_sweep=num_sweep+1
        if(num_sweep.ne.1) then
        if(inode_all.eq.1) then
        write(6,*) "num_sweep.ne.1, stop", num_sweep
        endif
        stop
        endif
        

        fwg_in="wg.F"     ! if iter_PEtot.eq.odd, input from d_wg.even/wg.F, otherwise from d_wg.odd/wg.F
        fwg_out="wg.F"    ! if iter_PEtot.eq.odd, output to d_wg.odd/wg.F, otherwise to d_wg.even/wg.F
        frho_in="BLANK"
        frho_out="dens.out"   
        fvr_in="vr.F"
        fvr_out="vr.out"
        irho_in=0
        irho_out=100      ! just write in the memory array frag_group_dens, instead of disk output
        if(iter_PEtot.eq.iter_init+niter-1) irho_out=1      ! also writ out on the disk, in addition to memory output

        ivr_in=100       ! input from the memory array frag_group_pot, instead of disk  
        ivr_out=0
        if(iter_PEtot.eq.1) then
         iwg_in=0         ! generate from random
         iloc_save=2      ! calc. nonloc, write out to disk
         if(iflag_mem_loc2.eq.1) iloc_save=200     ! calc. nonloc, write out to disk and mem.
        else
          iloc_save=1
          if(iflag_mem_loc2.eq.1) then
          if(iter_PEtot.eq.iter_init) then
          iloc_save=1     ! read in from the disk
          else
          iloc_save=100    ! read in from memory
          endif
          endif

          if(ilocal.ne.2) iloc_save=0

          iwg_in=1
          if(iflag_mem_wave.eq.1) then
          if(iter_PEtot.eq.iter_init) then
          iwg_in=1        ! read in from disk
          else
          iwg_in=100      ! read in from memory
          endif
          endif
        endif
       
          iwg_out=1          ! write it out on disk only
          if(iflag_mem_wave.eq.1) then
          if(iter_PEtot.eq.iter_init+niter-1) then    ! last step
cccc          iwg_out=200       ! both write it out and store in memory
ccccccccccc SPECIAL VERSION
          iwg_out=100       ! this is a special version, not write out the wave on disk even for the last iteration, no space
ccccccccccc SPECIAL VERSION
ccccccccc 200 is used, so we can both check point and continue running
ccccccccc or we can just write it out on the last iteration, not store in memory (doesn't really matter here)
cccc      iwg_out=1
ccccccccccccccccccccccccccccccccccc
          else
          iwg_out=100       ! just store in memory without write it out on disk
          endif
          endif


        if(inode_all.eq.1) then
        write(3,102) iter_PEtot, "  enter mainMV2_S"
        flush(3)
        endif
        time_i=mpi_wtime()
      call mainMV2_S2(igroup_start,num_sweep,
     &   iter_PEtot,iter_init,fwg_in,fwg_out,frho_in,frho_out, 
     &   fvr_in,fvr_out,iwg_in,iwg_out,irho_in,irho_out,
     &   ivr_in,ivr_out,iloc_save,
     &   nXMPI,num_group,inode_tot,
     &   nnodes_tot,icolor,ikey,nnodes,inode,MPI_COMM_K,MPI_COMM_N,
     &   nnodes_all,GLOBAL_totalnodes, GLOBAL_rank,
     &   XMPI_COMM_WORLD,XMPI_color,XMPI_key,inode_all,iflag_mem_loc3,
     &   E_nsc_vrho_all,E_dvrrho_all,E_dvrrho2_all,
     &   iflag_report)
        time_f=mpi_wtime()

        if(inode_all.eq.1) then
        write(3,103) iter_PEtot,time_f-time_i,
     &        time_f-time00, "  out mainMV2_S"
        flush(3)
        endif

ccccccccc actually, only the first node in the group has the value, other have zeros. 
        call mpi_allreduce(E_nsc_vrho_all,E_tmp,1,MPI_REAL8,
     &  MPI_SUM,MPI_COMM_WORLD,ierr)
        E_nsc_vrho_all=E_tmp
        call mpi_allreduce(E_dvrrho_all,E_tmp,1,MPI_REAL8,
     &  MPI_SUM,MPI_COMM_WORLD,ierr)
        E_dvrrho_all=E_tmp
        call mpi_allreduce(E_dvrrho2_all,E_tmp,1,MPI_REAL8,
     &  MPI_SUM,MPI_COMM_WORLD,ierr)
        E_dvrrho2_all=E_tmp


ccccccccccccccccc
ccc inside get_denstot_fmPN_S, get density from d_dens.out

        f_dens="dens.out"
        f_dens_tot="dens.out_tot."//trim(string1)
        iread_dens=0
        if(inode_all.eq.1) then
        write(3,102) iter_PEtot, "  enter get_denstot_fmPN_S"
        flush(3)
        endif
        time_i=mpi_wtime()
c        call get_denstot_fmPN_NEW(f_dens,f_dens_tot,
c     &     inode_all,nnodes_all,iread_dens,iflag_report)
        call get_denstot_fmPN_fix(f_dens,f_dens_tot,
     &     inode_all,nnodes_all,iread_dens,iflag_report,
     &     XMPI_color,inode_tot_G)
        time_f=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,103) iter_PEtot,time_f-time_i,
     &        time_f-time00, "  out get_denstot_fmPN_S"
        flush(3)
        endif


      nscf=iter_PEtot-iter_init+1
      frho_in="dens.out_tot."//trim(string1)     ! input charge density
      fvr_in="vr.in_tot."//trim(string1)         ! input pot for the current iter (for mix)
      fvr_out="vr.in_tot."//trim(string2)        ! this is the mixed potential for this iter_PEtot
        ivr_in=1
        ivr_out=1
        irho_in=1
        irho_out=0       !  irho_out is never used
      if(iter_PEtot.eq.iter_init+niter-1) ivr_out=10    ! write out on disk

        if(inode_all.eq.1) then
        write(3,102) iter_PEtot, "  enter GENPOT_V3_S"
        flush(3)
        endif
        time_i=mpi_wtime()
      call GENPOT_V3_S(nscf,frho_in,fvr_in,fvr_out,
     & ivr_in,ivr_out,irho_in,irho_out,
     & inode_all,nnodes_all,inode_tot_G,nnodes_tot_G,my_color_G,
     & nnodes_k_G,num_group_G,icolor_G,ikey_G,nnodes_G,inode_G,
     & MY_COMM_WORLD_G,MPI_COMM_K_G,MPI_COMM_N_G,ido_dVr,
     & Ealphat_tmp,Ewald_tmp,E_Hxc,E_ion,V_error,
     & iflag_report,npulay_max_G)
        time_f=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,103) iter_PEtot,time_f-time_i,
     &        time_f-time00, "  out GENPOT_V3_S"
        flush(3)
        endif


        if(nscf.eq.1.and.(icoul.ne.0.or.ido_dVr.eq.0)) then
        Ewald_head=Ewald_tmp
        endif

        if(nscf.eq.1) then
        Ealphat_head=Ealphat_tmp
        endif


ccccccccccccccccccccccccccccccccccccccccccccccc

      if(inode_all.eq.1) then
      E_tot=Ewald_head+Ealphat_head+E_nsc_vrho_all+
     &         E_Hxc+E_ion+E_dvrrho_all
      write(72,*) "---------------------------------------------------"
      write(72,404) iter_PEtot
      write(72,405) Ewald_head
      write(72,406) Ealphat_head
      write(72,407) E_nsc_vrho_all
      write(72,408) E_Hxc
      write(72,409) E_ion
      write(72,410) E_dvrrho_all,E_dvrrho2_all
      write(72,411) E_tot,E_tot-E_tot_old
      write(72,*) "---------------------------------------------------"
      write(72,412) V_error 
      write(72,*) "---------------------------------------------------"
      flush(72)
      E_tot_old=E_tot

404   format(" NSCF             = ", i20)
405   format(" Ewald            = ", E20.14)
406   format(" Ealphat          = ", E20.14)
407   format(" E_kin+E_noloc    = ", E20.14)
408   format(" E_Hxc            = ", E20.14)
409   format(" E_ion            = ", E20.14)
410   format(" E_dvrho,|E_dvrho|= ", E20.14,4x,E10.3)
411   format(" E_tot, dE_tot    = ", E20.14,4x,E10.3)
412   format("V_error =",E12.6,1x)
      endif

1000   continue
3333   continue

        if(inode_all.eq.1) then
        close(72)
        endif
        time_f=mpi_wtime()
        if(inode_all.eq.1) then
        write(3,*) "total calc. time (second)=",
     &           time_f-time00
        flush(3)
        endif

      if(inode_all.eq.1) close(3)

      call mpi_finalize(ierr)

c      stop
      return
      end
      
     
