      program gen_fragments_fix_ZTO 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc    This program divides a system into m1*m2*m3 number of base fragments. 
cc    The dangling bonds on the surface in each fragment are passivated by hydrogen atoms.
cc    This program require: num_group=m1*m2*m3, and assign the fragment
cc    to the proc. group according to the corner index of the fragment, instead of timing. 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit double precision (a-h, o-z)
c      parameter (matom=16000,len_m=2,mtype=5,m0=300) 
      parameter (matom=37000,len_m=2,mtype=5,m0=300)      ! special

      parameter (mfrag=40000)      
cc      matom: the max number of atoms in the system 
cc      mtype: the types of atoms in the system
cc      len_m=2 means m1,m2,m3 are ranged [0,99]
cc      m0: the max number of atoms in each fragment
      integer natom
      real*8 xatom(3,matom),dx123(3)
      real*8 time_group(20000)            ! maximum, 10,000 group
      integer num_frag_group(20000),num_tot_rec_st(20000)
      integer iatom(matom),imov_at(3,matom),iatom_type(mtype)
      integer iat_type(8), iatom_type_fm(8)
      integer iiatom(mtype),nref_type(mtype),ipsp_type(mtype)
      character*50 file_vwr
      character*50 f_xatom,f_vr_input
      real*8 AL(3,3)	
      real*8 Rbond(mtype)
      character*6 symbol
      integer nbond(mtype)
      integer index_neigh(4,matom),iwrap(3),iwrap_at(3,4,matom)
      integer iwrap_fm(3)
      integer,allocatable,dimension(:)::index_at2fm
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real*8 xatom_store(3,300,mfrag)
      integer iatom_store(300,mfrag)
      real*8 AL_store(3,3,mfrag),totNel_store(mfrag),time(mfrag)
      integer ind_corner_store(3,mfrag),nsize_store(3,mfrag),
     &        natom_store(mfrag),nref_store(mfrag)
      integer n123_store(3,mfrag)
      integer ifrag_order(mfrag),num_rec(mfrag)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc variables for a fragment
      character*40 f_xatom_tmp,f_xatom_tmp2 
      real*8 AL_tmp(3,3),AL_fm(3,3,8),vec(3)
      real*8,allocatable,dimension(:,:):: xatom_tmp,xatom_H
      integer,allocatable,dimension(:,:):: imov_at_tmp,imov_at_H 
      integer,allocatable,dimension(:):: iatom_tmp,iatom_H,ind_tmp,ind_H 
      integer,allocatable,dimension(:):: index_rmap
      integer,allocatable,dimension(:,:):: ind_frag_group

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc work vairables 
      real*8 fms(3),scale(3)
      integer nfms(3)
      integer,allocatable,dimension(:,:,:,:):: ind_fm
      integer,allocatable,dimension(:,:,:):: natom_fm,index_map 
      integer icase_pc(8)
      character*3 tmp_char
      character*2 tmp_char1,tmp_char2,tmp_char3     !charcter*len_m
      character*10 fm_label
      integer ind_pc(3),list_fms(8),iwrap_fms(3,8)
      real*8  add_vacu(3)
      character*20 work_dir,work_dir2

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc vairables for test

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc format for output
255   format(i4, "                |natom")
256   format(3(f16.10, 1x))
257   format(i4,3(f12.7,1x),3x,3(i3,1x),i12)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      open(10,file='LS3DF.input',status='old',action='read',iostat=ierr)
      rewind(10)
      read(10,*) itmp,f_xatom
      read(10,*) itmp,num_group,num_proc_group,nnodes_tot_G
      read(10,*) itmp,m1,m2,m3,mn1,mn2,mn3      ! the num of fragments in each dir. 
      read(10,*) itmp,ngppa1,ngppa2,ngppa3   ! the grid point for each fragment
      read(10,*) itmp,add_vacu(1),add_vacu(2),add_vacu(3)  ! the added vac. in each dir. in unit of fragment
      read(10,*) itmp,nslice,multi
      read(10,*) itmp,ido_dVr
      read(10,*) itmp,iter_init,niter
      read(10,*) itmp,ntype
      do i=1,ntype
      read(10,*) itmp,iatom_type(i),Rbond(i),nbond(i)
      enddo
       read(10,*)
       read(10,*)
       read(10,*)
       read(10,*)
       read(10,*)
       read(10,*) itmp,niter_t1
       do i=1,niter_t1
       read(10,*)
       enddo
       read(10,*) itmp,niter_t1
       do i=1,niter_t1
       read(10,*)
       enddo
       read(10,*)
       read(10,*)
       read(10,*) itmp,ntype_atom
       do ia=1,ntype_atom
       read(10,*) file_vwr,ipsp_type(ia)
         if(ipsp_type(ia).ne.1) then
         write(6,*) "sorry, ipsp_type must be 1", ipsp_type(ia)
         endif
      open(12,file=file_vwr,status='old',action='read',iostat=ierr)
      read(12,*) nrr_t,ic_t,iiatom(ia),zatom_t,iloc_t,occ_s_t,
     &  occ_p_t,occ_d_t
      read(12,*) is_ref_t,ip_ref_t,id_ref_t,
     &  is_TB_t,ip_TB_t,id_TB_t
      close(12)
      if(iloc_t.eq.1) is_ref_t=0
      if(iloc_t.eq.2) ip_ref_t=0
      if(iloc_t.eq.3) id_ref_t=0
      nref_type(ia)=is_ref_t+ip_ref_t*3+id_ref_t*5
       enddo

      read(10,*) itmp,n1_G,n2_G,n3_G
      close(10)

      if(num_group.ne.m1*m2*m3) then
      write(6,*) "num_group.ne.m1*m2*m3 for this fixed version, stop"
      stop
      endif

      if(nslice.gt.num_group) then
      write(6,*) "nslice must be smaller than num_group, sorry, stop"
      stop
      endif
   

      if(nslice*multi.ne.nnodes_tot_G) write(6,*) 
     & "WARNING, nslice*multi.ne.nnodes_tot_G", nslice,multi,
     &  nnodes_tot_G
      if(m1*ngppa1.ne.n1_G.or.m2*ngppa2.ne.n2_G.
     &  or.m3*ngppa3.ne.n3_G) write(6,*) 
     & "WARNING, m1,2,3*nd1,2,3.ne.n1,2,3(for GENPOT)",
     &  m1,m2,m3,ngppa1,ngppa2,ngppa3,n1_G,n2_G,n3_G


      nm1=ngppa1*(1+2*add_vacu(1))+0.1
      nm2=ngppa2*(1+2*add_vacu(2))+0.1
      nm3=ngppa3*(1+2*add_vacu(3))+0.1
      LREC=nm1*nm2*nm3/num_proc_group


cc read in xatom for the system
      call readf_xatom_s()

cc shift xatom into [0,1) range in original coordinate system,
cc provided xatom is normalized already, and in range [-1,2) 
      do ia=1,natom
      do j=1,3
      if (xatom(j,ia).lt.0.d0) then
      xatom(j,ia)=xatom(j,ia)+1.d0 
      endif 
      if (xatom(j,ia).ge.1.d0) then 
      xatom(j,ia)=xatom(j,ia)-1.d0 
      endif
      enddo
      enddo

cc divide the system into m1*m2*m3 base fragments 
      write(6,*) 'm0=',m0
      allocate(ind_fm(m0,m1,m2,m3))
      allocate(natom_fm(m1,m2,m3))

      allocate(index_map(m1,m2,m3))
      allocate(index_rmap(m1*m2*m3))
      allocate(index_at2fm(natom))

cc index_mapping
      call index_mapping()

      natom_fm=0
      do ia=1,natom
      i1=int(xatom(1,ia)*m1)+1	!!!added 1!
      i2=int(xatom(2,ia)*m2)+1
      i3=int(xatom(3,ia)*m3)+1
      natom_fm(i1,i2,i3)=natom_fm(i1,i2,i3)+1
      j=natom_fm(i1,i2,i3) 
      ind_fm(j,i1,i2,i3)=ia
      index_at2fm(ia)=index_map(i1,i2,i3)
      enddo	!do ia=1,natom




cc number of fragments (possible combinations) per corner coordinate
      nfpc=min(2,m1)*min(2,m2)*min(2,m3)	

      ipc=0
      do i1=1,min(2,m1)
      do i2=1,min(2,m2)
      do i3=1,min(2,m3)
      ipc=ipc+1
      AL_tmp(:,1)=AL(:,1)*i1/m1
      AL_tmp(:,2)=AL(:,2)*i2/m2
      AL_tmp(:,3)=AL(:,3)*i3/m3
      icase_pc(ipc)=i1*100+i2*10+i3
      AL_fm(:,:,ipc)=AL_tmp 
      enddo
      enddo
      enddo



cc for each base fragment, finding neighbors 
      allocate(xatom_tmp(3,m0))
      allocate(imov_at_tmp(3,m0))
      allocate(iatom_tmp(m0))
      allocate(ind_tmp(m0))
      allocate(xatom_H(3,m0))	
      allocate(imov_at_H(3,m0))
      allocate(ind_H(m0))
      allocate(iatom_H(m0))

      index_neigh=0

      ii=0
      iwrap_at=0
      do i1=1,m1
      do i2=1,m2
      do i3=1,m3
      ii=ii+1
      do ka1=1,natom_fm(i1,i2,i3) 
        ja=ind_fm(ka1,i1,i2,i3) 
        mt=my_type(ja)
        nnbs=0
        do jj1=i1-1,i1+min(1,m1-2)
        do jj2=i2-1,i2+min(1,m2-2)
        do jj3=i3-1,i3+min(1,m3-2)
        j1=mod(jj1+m1-1,m1)+1
        j2=mod(jj2+m2-1,m2)+1
        j3=mod(jj3+m3-1,m3)+1
cccccccccc
        do ka2=1,natom_fm(j1,j2,j3)
        jb=ind_fm(ka2,j1,j2,j3)
        mt2=my_type(jb)

        do j=1,3
        vec(j)=xatom(j,ja)-xatom(j,jb)
        enddo
cc wrap it
        iwrap=0
        do j=1,3
        if(abs(vec(j)+1.d0).lt.abs(vec(j))) then
        vec(j)=1.d0+vec(j)
        iwrap(j)=-1    !iwrap is used to shift coordinate around
        endif
        if(abs(vec(j)-1.d0).lt.abs(vec(j))) then 
        vec(j)=vec(j)-1.d0
        iwrap(j)=1
        endif
        enddo

        dR=udist(vec,3) 
        if (dR**2.lt.Rbond(mt)*Rbond(mt2)*1.15.and.dR.ne.0.d0) then
        nnbs=nnbs+1
        index_neigh(nnbs,ja)=jb
        iwrap_at(:,nnbs,ja)=iwrap
        endif

        enddo
cccccccccc

        enddo
        enddo
        enddo

cc error check
        if(nnbs.gt.nbond(mt)) then
        write(6,*) 'more neighbors found,nnbs,nbond(mt),stop',
     &   nnbs,nbond(mt) 
        stop
        else if(nnbs.lt.nbond(mt)) then
        write(6,*) 'less neighbors found,nnbs,nbond(mt),stop', 
     &   nnbs,nbond(mt) 
        stop
        else
        endif

      enddo		! do ka1=1,natom_fm(i1,i2,i3) 

      enddo
      enddo
      enddo



 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc this file is to record the non-zero fragments 
c      open(15,file='all_fms')
c      rewind(15)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc generating fragments, run through each corner coordinate
      ii=0
      natom_tot=0
      num_frag=0
      do  2000 i1=1,m1
      call int2char(i1,tmp_char1,len_m)
      do  2000 i2=1,m2
      call int2char(i2,tmp_char2,len_m)
      do  2000 i3=1,m3
      call int2char(i3,tmp_char3,len_m)
      ii=ii+1
c      write(6,*) ii, i1,i2,i3, natom_fm(i1,i2,i3)
      natom_tot=natom_tot+natom_fm(i1,i2,i3)

      do 2000 ipc=1,nfpc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

cc total number of atom number in each fragment
      itmp=icase_pc(ipc)
      do j=1,3
      ind_pc(4-j)=mod(itmp,10)
      itmp=itmp/10
      enddo

      list_fms=0
      len_list=0
      do k1=1,ind_pc(1)
      do k2=1,ind_pc(2)
      do k3=1,ind_pc(3)  
      ik1=mod(i1+k1-2,m1)+1
      ik2=mod(i2+k2-2,m2)+1
      ik3=mod(i3+k3-2,m3)+1
      len_list=len_list+1
      list_fms(len_list)=index_map(ik1,ik2,ik3)
      iwrap_fm=0 
      if(i1+k1-1.eq.m1+1) iwrap_fm(1)=1     !to take care the shift of the coordinates
      if(i2+k2-1.eq.m2+1) iwrap_fm(2)=1
      if(i3+k3-1.eq.m3+1) iwrap_fm(3)=1
      iwrap_fms(:,len_list)=iwrap_fm(:)
      enddo	!k3
      enddo	!k2
      enddo	!k1

cccccccccccccccccccccccccccccccccccccccccccccc
      natom_fms=0
      natom_Hs=0
      iH=0
      iia=0 
      totNel=0
      do 1500 k1=1,ind_pc(1)    ! the size of the frag, 
      do 1500 k2=1,ind_pc(2)    ! doing this, so it includes many cubes of the (m1,m2,m3) grid
      do 1500 k3=1,ind_pc(3)  
      iwrap_fm=0
      ik1=mod(i1+k1-2,m1)+1
      ik2=mod(i2+k2-2,m2)+1
      ik3=mod(i3+k3-2,m3)+1
      if(i1+k1-1.eq.m1+1) iwrap_fm(1)=1     !to take care the shift of the coordinates
      if(i2+k2-1.eq.m2+1) iwrap_fm(2)=1
      if(i3+k3-1.eq.m3+1) iwrap_fm(3)=1
      jj=index_map(ik1,ik2,ik3)
      natom_fms=natom_fm(ik1,ik2,ik3)+natom_fms
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      if(natom_fm(ik1,ik2,ik3).gt.0) then
      do j=1,natom_fm(ik1,ik2,ik3)
      iia=iia+1
      ja=ind_fm(j,ik1,ik2,ik3)
      iatom_tmp(iia)=iatom(ja)
      do k=1,3
      xatom_tmp(k,iia)=xatom(k,ja)+iwrap_fm(k)*1.d0
      imov_at_tmp(k,iia)=imov_at(k,ja)
      enddo
      ind_tmp(iia)=ja

cc  count total number of electrons
      totNel=totNel+totNel_cal(iatom(ja)) 

      enddo
      endif

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do j=1,natom_fm(ik1,ik2,ik3)
      ja=ind_fm(j,ik1,ik2,ik3)

      do jn=1,nbond(my_type(ja)) 	!go through the neighbors
      jb=index_neigh(jn,ja)
      call yn_list(iy,index_at2fm(jb),list_fms,len_list,ind_list)
cccccccccc NEW,new
cccccccccc here, provide an additional test for iy.eq.1
cccccccccc it is possible that the base fragment which jb belong is in this fragment, but
cccccccccc since it is iwraped, so ja and jb are no longer bonded (this is useful for m1,m2,m3=2) 
         if(iy.eq.1) then
       dx123(:)=xatom(:,ja)+iwrap_fm(:)-
     &       (xatom(:,jb)+iwrap_fms(:,ind_list))

        dR=udist(dx123,3) 
        if (dR**2.gt.Rbond(my_type(ja))*Rbond(my_type(jb))*
     &     1.15)  iy=0    ! ja,jb no longer bond
         endif
ccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      if(iy.eq.0) then    !the neighboring atom jb of atom ja is not in the fragment list list_fms


ccccccccccc passivation scheme cccccccccccc
cc specific for CdSe dots and Si dots
      natom_Hs=natom_Hs+1
      iH=iH+1

      if(iatom(jb).eq.1) then
        do k=1,3
        xatom_H(k,iH)=xatom(k,jb)+iwrap_at(k,jn,ja)*1.d0+
     &  iwrap_fm(k)*1.d0
        enddo
        iatom_H(iH)=1   !passivate hydrogen
      else if(iatom(jb).eq.105) then
        do k=1,3
        xatom_H(k,iH)=xatom(k,jb)+iwrap_at(k,jn,ja)*1.d0+
     &  iwrap_fm(k)*1.d0
        enddo
        iatom_H(iH)=105   !passivate hydrogen
      else if(iatom(jb).eq.115) then      ! the neighboring atom jb is a H
        do k=1,3
        xatom_H(k,iH)=xatom(k,jb)+iwrap_at(k,jn,ja)*1.d0+
     &  iwrap_fm(k)*1.d0
        enddo
        iatom_H(iH)=115   !passivate hydrogen

      else if(iatom(jb).eq.14) then   
        if(iatom(ja).eq.14) then     ! the center (kept) atom ja is Si, form a new Si-H
          do k=1,3
          xatom_H(k,iH)=0.5d0*(xatom(k,ja)+xatom(k,jb)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0          ! iwrap_at is for jb relative to ja
          enddo
        else if(iatom(ja).eq.1) then     ! the center (kept) atom ja is H, form a new H-H
          do k=1,3
          vec(k)=(xatom(k,jb)-xatom(k,ja)+iwrap_at(k,jn,ja)*1.d0)
          enddo
          d=udist(vec,3)
          fact=1.4/d                      !  1.4 atomic unit is the H-H bond length
          do k=1,3
          xatom_H(k,iH)=xatom(k,ja)+fact*(xatom(k,jb)-xatom(k,ja)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0
          enddo

        else
          write(6,*)"something was wrong in original system,stop"
          stop
        endif
        iatom_H(iH)=1   !passivate hydrogen

      else if(iatom(jb).eq.34) then   
        if(iatom(ja).eq.48) then     ! the center (kept) atom ja is Cd 
          do k=1,3
          xatom_H(k,iH)=0.5d0*(xatom(k,ja)+xatom(k,jb)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0          ! iwrap_at is for jb relative to ja
          enddo
        else if(iatom(ja).eq.105) then    ! the center (kept) atom ja is H_105, form a new H_105-H_115
          do k=1,3
          vec(k)=(xatom(k,jb)-xatom(k,ja)+iwrap_at(k,jn,ja)*1.d0)
          enddo
          d=udist(vec,3)
          fact=1.4/d                      !  1.4 atomic unit is the H-H bond length
          do k=1,3
          xatom_H(k,iH)=xatom(k,ja)+fact*(xatom(k,jb)-xatom(k,ja)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0
          enddo
        else
          write(6,*)"something was wrong in original system,stop"
          stop
        endif
        iatom_H(iH)=115   !passivate hydrogen

      else if(iatom(jb).eq.8) then ! O
        if(iatom(ja).eq.30) then     ! the center (kept) atom ja is Zn
          do k=1,3
          xatom_H(k,iH)=0.5d0*(xatom(k,ja)+xatom(k,jb)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0          ! iwrap_at is for jb relative to ja
          enddo
        else if(iatom(ja).eq.105) then    ! the center (kept) atom ja is H_105, form a new H_105-H_115
          do k=1,3
          vec(k)=(xatom(k,jb)-xatom(k,ja)+iwrap_at(k,jn,ja)*1.d0)
          enddo
          d=udist(vec,3)
          fact=1.4/d                      !  1.4 atomic unit is the H-H bond length
          do k=1,3
          xatom_H(k,iH)=xatom(k,ja)+fact*(xatom(k,jb)-xatom(k,ja)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0
          enddo
        else
          write(6,*)"something was wrong in original system,stop"
          stop
        endif
        iatom_H(iH)=115   !passivate hydrogen


      else if(iatom(jb).eq.52) then ! Te
        if(iatom(ja).eq.30) then     ! the center (kept) atom ja is Zn
          do k=1,3
          xatom_H(k,iH)=0.5d0*(xatom(k,ja)+xatom(k,jb)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0          ! iwrap_at is for jb relative to ja
          enddo
        else if(iatom(ja).eq.105) then    ! the center (kept) atom ja is H_105, form a new H_105-H_115
          do k=1,3
          vec(k)=(xatom(k,jb)-xatom(k,ja)+iwrap_at(k,jn,ja)*1.d0)
          enddo
          d=udist(vec,3)
          fact=1.4/d                      !  1.4 atomic unit is the H-H bond length
          do k=1,3
          xatom_H(k,iH)=xatom(k,ja)+fact*(xatom(k,jb)-xatom(k,ja)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0
          enddo
        else
          write(6,*)"something was wrong in original system,stop"
          stop
        endif
        iatom_H(iH)=115   !passivate hydrogen



      else if(iatom(jb).eq.48) then   
        if(iatom(ja).eq.34) then     ! the center (kept) atom ja is Se 
          do k=1,3
          xatom_H(k,iH)=0.5d0*(xatom(k,ja)+xatom(k,jb)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0          ! iwrap_at is for jb relative to ja
          enddo
        else if(iatom(ja).eq.115) then    ! the center (kept) atom ja is H_105, form a new H_105-H_115
          do k=1,3
          vec(k)=(xatom(k,jb)-xatom(k,ja)+iwrap_at(k,jn,ja)*1.d0)
          enddo
          d=udist(vec,3)
          fact=1.4/d                      !  1.4 atomic unit is the H-H bond length
          do k=1,3
          xatom_H(k,iH)=xatom(k,ja)+fact*(xatom(k,jb)-xatom(k,ja)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0
          enddo
        else
          write(6,*)"something was wrong in original system,stop"
          stop
        endif
        iatom_H(iH)=105   !passivate hydrogen

      else if(iatom(jb).eq.30) then ! Zn
        if(iatom(ja).eq.52) then     ! the center (kept) atom ja is Te
          do k=1,3
          xatom_H(k,iH)=0.5d0*(xatom(k,ja)+xatom(k,jb)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0          ! iwrap_at is for jb relative to ja
          enddo
        else if(iatom(ja).eq.8) then     ! the center (kept) atom ja is O
          do k=1,3
          xatom_H(k,iH)=0.5d0*(xatom(k,ja)+xatom(k,jb)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0          ! iwrap_at is for jb relative to ja
          enddo
        else if(iatom(ja).eq.115) then    ! the center (kept) atom ja is H_105, form a new H_105-H_115
          do k=1,3
          vec(k)=(xatom(k,jb)-xatom(k,ja)+iwrap_at(k,jn,ja)*1.d0)
          enddo
          d=udist(vec,3)
          fact=1.4/d                      !  1.4 atomic unit is the H-H bond length
          do k=1,3
          xatom_H(k,iH)=xatom(k,ja)+fact*(xatom(k,jb)-xatom(k,ja)+
     &    iwrap_at(k,jn,ja)*1.d0)+iwrap_fm(k)*1.d0
          enddo
        else
          write(6,*)"something was wrong in original system,stop"
          stop
        endif
        iatom_H(iH)=105   !passivate hydrogen



      else
       write(6,*) "more cases than coded have appeared, stop"
       stop
      endif

 
      do k=1,3
      imov_at_H(k,iH)=1
      enddo
      ind_H(iH)=-min(ja,jb)*10000-max(ja,jb)  !record original atom index

      totNel=totNel+totNel_cal(iatom_H(iH))
ccccccccccc up to here passivation scheme cccccccccccc


      endif  		!if(iy.eq.0)
      enddo		!do jn=1,nbond(my_type(ja))
      enddo  		!for ja=1,natom_fm(ik1,ik2,ik3)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

1500  continue    ! k1,k2,k3



cccccccccccccccccccccccccccccccccccccc
cc check if natom_fms_+natom_Hs >m0
      if (natom_fms+natom_Hs.gt.m0) then
      write(6,*) 'the number of atoms in this fragment .gt. m0, 
     & natom_fms+natom_Hs, m0, stop', natom_fms+natom_Hs,m0
      stop
      endif

ccccccccccccccccccccccccccccccccccccc
cc output fragments config file
      if(natom_fms.gt.0) then

      call int2char(icase_pc(ipc),tmp_char,3)
      fm_label=tmp_char1//tmp_char2//tmp_char3//'_'//
     &  tmp_char
      work_dir='fm_'//fm_label 	     
c      call system('mkdir '//work_dir) 
      f_xatom_tmp=trim(work_dir)//'/xatom.in_'//fm_label
c      write(15,*)'fm_'//fm_label, natom_fms+natom_Hs, int(totNel+0.1)

cccccccccccccc
c      open(11,file=f_xatom_tmp)
c      rewind(11)
c      write(11,255) natom_fms+natom_Hs

      num_frag=num_frag+1
      natom_store(num_frag)=natom_fms+natom_Hs
      totNel_store(num_frag)=totNel
      ind_corner_store(1,num_frag)=i1
      ind_corner_store(2,num_frag)=i2
      ind_corner_store(3,num_frag)=i3
      nsize_store(1,num_frag)=ind_pc(1)
      nsize_store(2,num_frag)=ind_pc(2)
      nsize_store(3,num_frag)=ind_pc(3)
      n123_store(1,num_frag)=ngppa1*(ind_pc(1)+2*add_vacu(1))+0.1
      n123_store(2,num_frag)=ngppa2*(ind_pc(2)+2*add_vacu(2))+0.1
      n123_store(3,num_frag)=ngppa3*(ind_pc(3)+2*add_vacu(3))+0.1
      num_rec(num_frag)=int(n123_store(1,num_frag)*
     &  n123_store(2,num_frag)*n123_store(3,num_frag)*
     &   1.d0/num_proc_group/LREC+0.999999999d0)
      num_rec(num_frag)=num_rec(num_frag)*num_proc_group

      xt=n123_store(1,num_frag)*n123_store(2,num_frag)*
     & n123_store(3,num_frag)/1000.d0
      xm=(totNel_store(num_frag)/2+5.d0)/10.d0     ! number of wavefunctions

      



      

      AL_tmp(:,1)=AL_fm(:,1,ipc)+AL(:,1)*2*add_vacu(1)/m1     ! factor of 2 for two sides. 
      AL_tmp(:,2)=AL_fm(:,2,ipc)+AL(:,2)*2*add_vacu(2)/m2
      AL_tmp(:,3)=AL_fm(:,3,ipc)+AL(:,3)*2*add_vacu(3)/m3

      scale(1)=dist(AL(:,1),3)/dist(AL_tmp(:,1),3)
      scale(2)=dist(AL(:,2),3)/dist(AL_tmp(:,2),3)
      scale(3)=dist(AL(:,3),3)/dist(AL_tmp(:,3),3)

c      write(11,256) AL_tmp(1,1),AL_tmp(2,1),AL_tmp(3,1)
c      write(11,256) AL_tmp(1,2),AL_tmp(2,2),AL_tmp(3,2)
c      write(11,256) AL_tmp(1,3),AL_tmp(2,3),AL_tmp(3,3)
       AL_store(:,:,num_frag)=AL_tmp(:,:)

cc add passivated atoms into xatom_tmp
      do jH=1,natom_Hs
      iatom_tmp(jH+natom_fms)=iatom_H(jH)
      xatom_tmp(1,jH+natom_fms)=xatom_H(1,jH)
      xatom_tmp(2,jH+natom_fms)=xatom_H(2,jH)
      xatom_tmp(3,jH+natom_fms)=xatom_H(3,jH)
      imov_at_tmp(1,jH+natom_fms)=imov_at_H(1,jH)
      imov_at_tmp(2,jH+natom_fms)=imov_at_H(2,jH)
      imov_at_tmp(3,jH+natom_fms)=imov_at_H(3,jH)
      ind_tmp(jH+natom_fms)=ind_H(jH)
      enddo
      
cc determine the number of atom types 
      ntype_fm=1
      iatom_type_fm(1)=iatom_tmp(1)
      do ja=2,natom_fms+natom_Hs
      call yn_list(iy,iatom_tmp(ja),iatom_type_fm,ntype_fm,ind_list) 
      if (iy.eq.0) then 
      ntype_fm=ntype_fm+1
      iatom_type_fm(ntype_fm)=iatom_tmp(ja)
      endif
      enddo

      if (ntype_fm.gt.1) then
c      write(6,*) trim(f_xatom_tmp),ntype_fm,natom_fms+natom_Hs
      call reorder(iatom_tmp,xatom_tmp,imov_at_tmp,ind_tmp,
     & natom_fms+natom_Hs, iatom_type_fm)
      endif

cc new origin of this fragment (i1,i2,i3)
      x1_tmp=(i1-1)*1.d0/m1-add_vacu(1)/m1
      x2_tmp=(i2-1)*1.d0/m2-add_vacu(2)/m2
      x3_tmp=(i3-1)*1.d0/m3-add_vacu(3)/m3

cc Note: until this point all the coordinates were written in original system (normalized with AL) 
cc write atoms inside the fragment
      do ja=1,natom_fms+natom_Hs  
c      write(11,257) iatom_tmp(ja),
c     & (xatom_tmp(1,ja)-x1_tmp)*scale(1),
c     & (xatom_tmp(2,ja)-x2_tmp)*scale(2),
c     & (xatom_tmp(3,ja)-x3_tmp)*scale(3),
c     & imov_at_tmp(1,ja),imov_at_tmp(2,ja),imov_at_tmp(3,ja),
c     & ind_tmp(ja)
       iatom_store(ja,num_frag)=iatom_tmp(ja)
       xatom_store(1,ja,num_frag)=(xatom_tmp(1,ja)-x1_tmp)*scale(1)
       xatom_store(2,ja,num_frag)=(xatom_tmp(2,ja)-x2_tmp)*scale(2)
       xatom_store(3,ja,num_frag)=(xatom_tmp(3,ja)-x3_tmp)*scale(3)
      enddo
c      close(11)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc this part is generating the etot.input file for the fragments
cc      call gen_etot_input() 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc The time is calculated here, because only now we know the iatom_store
ccccccccccccccccccccccccccccccccccccccccccc
      nref_tot=0
      do i=1,natom_store(num_frag)
       do itype=1,ntype_atom
       if(iatom_store(i,num_frag).eq.iiatom(itype)) iitype=itype
       enddo
       nref_tot=nref_tot+nref_type(iitype)
      enddo
      nref_store(num_frag)=nref_tot
ccccccccccc the fitted result
ccc this is for CdSe quantum dot fitting 
c      bf1=0.137611E+1
c      bf2=0.175344E-4
c      bf3=0.106609E-2
c      bf4=0.150504E-3
c      time(num_frag)=bf1+bf2*(xt*xm**2)+
c     &  bf3*(natom_store(num_frag)*xm)+bf4*(xt*log(xt)*xm)
cccccccccccccccccccccccccccccccccccccccccccccc
ccc The fitting result for ZnTeO, Ecut=50, q-space nonlocal
      bf1=0.2049666E+00
      bf2=0.1578085E-04
      bf3=0.1255464E-02
      bf4=0.9499800E-04
      time(num_frag)=bf1+bf2*(xt*xm**2)+
     &  bf3*(nref_store(num_frag)*xm)+bf4*(xt*log(xt)*xm)
ccccccccccccccccccccccccccccccccccccccccccc

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccC
      endif	!if(natom_fms... 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
2000  continue   ! do ipc,i1,i2,i3, for all the fragments 


ccccccccccccccccccccccccccccc
c      close(15)
ccccccccccccccccccccccccccccc

      if(natom_tot.ne.natom) then
      write(6,*) 'something is wrong:natom_tot.ne.natom,stop'
      stop
      endif

cc      call sort_fragments()


ccccccccc Now, distribute the fragments into different groups, and 
ccccccccc for each group, write the xatom.in into xatom.group
      work_dir='d_xatom.in'
      work_dir2='d_control'
c      call system('mkdir '//work_dir) 
c      call system('mkdir '//work_dir2) 

      max_frag_per_group=num_frag/num_group*10

      time_group=0.d0
      num_frag_group=0
      allocate(ind_frag_group(max_frag_per_group,
     &   num_group)) 
      min_igroup=1

c      do 2500 ii=1,num_frag
c      time_group(min_igroup)=time_group(min_igroup)+
c     &    time(ifrag_order(ii))         !  assigne this ifrag_order(ii) frag into min_igroup
c      num_frag_group(min_igroup)=num_frag_group(min_igroup)+1
c
c      if(num_frag_group(min_igroup).gt.max_frag_per_group) then
c      write(6,*) "num_frag_group.gt.max_frag_per_group, stop"
c      stop
c      endif
c      ind_frag_group(num_frag_group(min_igroup),min_igroup)=
c     &    ifrag_order(ii)
ccccccccc now, redefine min_igroup
c        time_min=1.D+30
c        do igroup=1,num_group
c        if(time_group(igroup).lt.time_min) then
c        time_min=time_group(igroup)
c        min_igroup=igroup
c        endif
c        enddo
cccccccccccccccccccccccccc
c2500   continue

ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc assigne the group according to the corner index, instead of timing. 
cccc the group number is directly calculated according to the following formula
       do 2500  ind=1,num_frag
       ind_group=ind_corner_store(1,ind)+
     &   (ind_corner_store(2,ind)-1)*m1+
     &   (ind_corner_store(3,ind)-1)*m1*m2
       num_frag_group(ind_group)=num_frag_group(ind_group)+1
       ind_frag_group(num_frag_group(ind_group),ind_group)=ind
2500   continue

cccccccccccccccccccccccccccccccccccccccccccccccccccccc

    

      do 3000 igroup=1,num_group

      num=num_frag_group(igroup)

      num_tot_rec=0 
      do ii=1,num_frag_group(igroup)
      num_tot_rec=num_tot_rec+num_rec(ind_frag_group(ii,igroup))
      enddo
      num_tot_rec_st(igroup)=num_tot_rec
      
      ichar4=igroup/1000 
      ichar3=(igroup-ichar4*1000)/100 
      ichar2=(igroup-ichar4*1000-ichar3*100)/10
      ichar1=igroup-ichar4*1000-ichar3*100-ichar2*10 

      f_xatom_tmp=trim(work_dir)//'/xatom.in_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)

      f_xatom_tmp2=trim(work_dir2)//'/control_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)

      open(12,file=f_xatom_tmp2)
      rewind(12)
      write(12,111) num,num_tot_rec,LREC,time_group(igroup)

      open(11,file=f_xatom_tmp)
      rewind(11)
      write(11,111) num,num_tot_rec,LREC,time_group(igroup)

111   format(3(i6,2x),2x,f15.4, 
     &  " ! num_frag, num_tot_record, Length_record, total_time(sec)")


      num_tot_rec=0
      do 3500 ii=1,num_frag_group(igroup)
      ind=ind_frag_group(ii,igroup)
      ipos_rec=num_tot_rec+1
      num_tot_rec=num_tot_rec+num_rec(ind)

      ind_frag=ind       ! this index is a bit different from before, but this is not really used
cccccccccccccccccccccccccccccccc
      nref_tot=0
      do i=1,natom_store(ind)
       do itype=1,ntype_atom
       if(iatom_store(i,ind).eq.iiatom(itype)) iitype=itype
       enddo
       nref_tot=nref_tot+nref_type(iitype)
      enddo
cccccccccccccccccccccccccccccccccccc

      write(11,*) "----------------------------------"
      write(11,110) natom_store(ind),n123_store(1,ind),
     & n123_store(2,ind),n123_store(3,ind),totNel_store(ind),
     & ind_corner_store(1,ind),ind_corner_store(2,ind),
     & ind_corner_store(3,ind),nsize_store(1,ind),
     & nsize_store(2,ind),nsize_store(3,ind),ind_frag,
     & ipos_rec,num_rec(ind),time(ind_frag),nref_tot

      write(12,110) natom_store(ind),n123_store(1,ind),
     & n123_store(2,ind),n123_store(3,ind),totNel_store(ind),
     & ind_corner_store(1,ind),ind_corner_store(2,ind),
     & ind_corner_store(3,ind),nsize_store(1,ind),
     & nsize_store(2,ind),nsize_store(3,ind),ind_frag,
     & ipos_rec,num_rec(ind),time(ind_frag),nref_tot

110    format(i4,3x,3(i6,1x),2x,f12.3,5x,3(i3,1x),3x,3(i1,1x),4x,i6,
     & 2x,2(i5,1x),2x,f10.2,2x,i6)      

      write(11,120) AL_store(1,1,ind),AL_store(2,1,ind),
     &              AL_store(3,1,ind)
      write(11,120) AL_store(1,2,ind),AL_store(2,2,ind),
     &              AL_store(3,2,ind)
      write(11,120) AL_store(1,3,ind),AL_store(2,3,ind),
     &              AL_store(3,3,ind)
120    format(3(f19.11,1x))
      do i=1,natom_store(ind)
      write(11,130) iatom_store(i,ind),xatom_store(1,i,ind),
     &  xatom_store(2,i,ind),xatom_store(3,i,ind),0,0,0      
130   format(i4,2x,3(f15.11,1x),1x,3(i1,1x))
      enddo

3500  continue     ! fragment within this group

      close(11)
      close(12)

3000  continue     ! group


      write(6,*)   "total num_fragment=",num_frag 

ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc write a information file for each inode within mn1*mn2*mn3
cccc for get_denstot_fmPN_S.f
      md1=m1/mn1     ! the box size in the unit of base fragments to be dealt by each processor
      md2=m2/mn2
      md3=m3/mn3

      nnodes=mn1*mn2*mn3

      do inode=1,nnodes
      mny3=(inode-1)/(mn1*mn2)
      mny2=(inode-1-mny3*mn1*mn2)/mn1
      mny1=inode-1-mny3*mn1*mn2-mny2*mn1
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      my1=mny1*md1          ! the corner index of the proc box in (m1,m2,m3) box, start from 0
      my2=mny2*md2
      my3=mny3*md3
cccccccccccccccccccccccccccccccccccccccccccccccccccc
      num_frag_m123=0
      do igroup=1,num_group
      do ii=1,num_frag_group(igroup)
      ind=ind_frag_group(ii,igroup)
      ic1=ind_corner_store(1,ind)
      ic2=ind_corner_store(2,ind)
      ic3=ind_corner_store(3,ind)
      if(ic1-1.lt.my1.or.ic1-1.ge.my1+md1) goto 1001    ! doesn't belong to this proc
      if(ic2-1.lt.my2.or.ic2-1.ge.my2+md2) goto 1001    ! doesn't belong to this proc
      if(ic3-1.lt.my3.or.ic3-1.ge.my3+md3) goto 1001    ! doesn't belong to this proc
      num_frag_m123=num_frag_m123+1
1001  continue
      enddo
      enddo

      mny1_1=mny1/10
      mny1_2=mny1-mny1_1*10
      mny2_1=mny2/10
      mny2_2=mny2-mny2_1*10
      mny3_1=mny3/10
      mny3_2=mny3-mny3_1*10


      f_xatom_tmp2=trim(work_dir2)//'/m123_getdens.'//char(mny1_1+48)//
     &  char(mny1_2+48)//'.'//char(mny2_1+48)//char(mny2_2+48)//'.'//
     &  char(mny3_1+48)//char(mny3_2+48)

      open(14,file=f_xatom_tmp2)
      rewind(14)
      write(14,*) num_frag_m123

cccccccccccccccccccccccccccccccccccccccccccccccccccc
      num_frag_m123=0
      do igroup=1,num_group

      num_tot_rec=0
      do ii=1,num_frag_group(igroup)
      ind=ind_frag_group(ii,igroup)
      ipos_rec=num_tot_rec+1
      num_tot_rec=num_tot_rec+num_rec(ind)

      ic1=ind_corner_store(1,ind)
      ic2=ind_corner_store(2,ind)
      ic3=ind_corner_store(3,ind)
      if(ic1-1.lt.my1.or.ic1-1.ge.my1+md1) goto 1000    ! doesn't belong to this proc
      if(ic2-1.lt.my2.or.ic2-1.ge.my2+md2) goto 1000    ! doesn't belong to this proc
      if(ic3-1.lt.my3.or.ic3-1.ge.my3+md3) goto 1000    ! doesn't belong to this proc

      num_frag_m123=num_frag_m123+1

      ns1=nsize_store(1,ind)
      ns2=nsize_store(2,ind)
      ns3=nsize_store(3,ind)

      ipc_case=100*ns1+10*ns2+ns3

      if(ipc_case.eq.222) then
      ialpha=1
      else if(ipc_case.eq.111) then
      ialpha=-1
      else if(ipc_case.eq.122.or.
     &        ipc_case.eq.212.or.
     &        ipc_case.eq.221) then
      ialpha=-1
      else if(ipc_case.eq.112.or.
     &        ipc_case.eq.121.or.
     &        ipc_case.eq.211) then
      ialpha=1
      else
        write(6,*) 'wrong ipc_case value,stop'
        stop
      endif
      write(14,113) natom_store(ind),n123_store(1,ind),
     & n123_store(2,ind),n123_store(3,ind),totNel_store(ind),
     & ind_corner_store(1,ind),ind_corner_store(2,ind),
     & ind_corner_store(3,ind),nsize_store(1,ind),
     & nsize_store(2,ind),nsize_store(3,ind),ind,
     & ipos_rec,num_rec(ind),ialpha,time(ind_frag),
     & igroup,num_frag_group(igroup),
     & num_tot_rec_st(igroup),LREC

113    format(i4,3x,3(i6,1x),2x,f12.3,5x,3(i3,1x),3x,3(i1,1x),4x,i6,
     & 2x,3(i5,1x),2x,f10.2,3(i7,1x),i10)      

1000  continue
      enddo     ! ii fragment within the group
      enddo     ! the group index
      close(14)
      enddo     ! inode for m123_getdens

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      
      deallocate(ind_frag_group)

      deallocate(ind_fm)
      deallocate(natom_fm)

      deallocate(index_at2fm)
      deallocate(index_map)
      deallocate(index_rmap)

      deallocate(xatom_tmp)
      deallocate(imov_at_tmp)
      deallocate(iatom_tmp)
      deallocate(ind_tmp)

      deallocate(xatom_H)
      deallocate(imov_at_H)
      deallocate(iatom_H)
      deallocate(ind_H)

      return
      contains

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc reorder so to make the same type of atoms stick together
      subroutine reorder(iat,xat,imat,idx,nat,iat_type)
      
      integer iat(nat),iat_tmp(nat),iat_type(8) 
      real*8 xat(3,nat),xat_tmp(3,nat)
      integer imat(3,nat),imat_tmp(3,nat)
      integer idx(nat),idx_tmp(nat)

      iat_tmp=iat
      xat_tmp=xat
      imat_tmp=imat
      idx_tmp=idx

      ith=0
      itype_rec=0
100   continue
      ncount=0
      itype_tmp=-2
      itype_rec=itype_rec+1

      do ia=1,nat
      if(itype_tmp.eq.-2.and.iat_tmp(ia).ne.-1.and.
     & iat_tmp(ia).eq.iat_type(itype_rec))
     &  itype_tmp=iat_tmp(ia)
                                                                                
      if(iat_tmp(ia).eq.itype_tmp) then
      ith=ith+1
      ncount=ncount+1
      iat(ith)=iat_tmp(ia)
      iat_tmp(ia)=-1
      xat(:,ith)=xat_tmp(:,ia)
      imat(:,ith)=imat_tmp(:,ia)
      idx(ith)=idx_tmp(ia)
      endif
      enddo
      if(ncount.gt.0) goto 100

      if(ith.ne.nat) then
      write(6,*) "something wrong to rearrange xat, ith, nat,stop",
     & ith,nat
      stop
      endif
      end subroutine reorder


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc this subroutine checks if an integer is in the list, it returns yes(1) or no(0)
      subroutine yn_list(iy,l1,list,len,ind)
      integer list(8)
      iy=0
      ind=0
      do i=1,len
      if(list(i).eq.l1) then
      iy=1
      ind=i
      endif
      enddo
      return
      end subroutine yn_list

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function totNel_cal(iatm)
      
      if (iatm.eq.14) then		!Si
        totNel_cal=4
      else if(iatm.eq.1) then		!H
        totNel_cal=1
      else if(iatm.eq.34) then		!Se
        totNel_cal=6
      else if(iatm.eq.48) then		!Cd
        totNel_cal=2
      else if(iatm.eq.105) then		!Pseudo H passivate Se
        totNel_cal=0.5
      else if(iatm.eq.115) then		!Pseudo H passivate Cd
        totNel_cal=1.5
      else if(iatm.eq.30) then          !Zn .. This is with d-orbitals.
        totNel_cal=12
      else if(iatm.eq.8) then          !O
        totNel_cal=6
      else if(iatm.eq.52) then          !Te
        totNel_cal=6
      else
      write(6,*) 'something is wrong in totNel_cal', 
     & 'calculation, program stop'
      stop
      endif
      return
      end function totNel_cal

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc this function finds the type index of an atom
      subroutine my_symbol(symbol,iZ)
      character*6 symbol
      symbol='***'
      if(iZ.eq.1) symbol='H'
      if(iZ.eq.14) symbol='Si'
      if(iZ.eq.34) symbol='Se'
      if(iZ.eq.48) symbol='Cd'
      if(iZ.eq.105) symbol='H0.5'
      if(iZ.eq.115) symbol='H1.5'
      return 
      end subroutine my_symbol 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc this function finds the type index of an atom
      function my_type(ia)
      do iv=1,ntype
      if(iatom(ia).eq.iatom_type(iv)) my_type=iv
      enddo
      return
      end function my_type

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc index mapping of the base fragments
      subroutine index_mapping()
      ii=0
      do i1=1,m1
      do i2=1,m2
      do i3=1,m3
      ii=ii+1
      index_map(i1,i2,i3)=ii
      index_rmap(ii)=i1*10000+i2*100+i3
      enddo
      enddo
      enddo
      return
      end subroutine index_mapping

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc calculate modulus of a vector written on an orthogogal basis (such as distance)
      function dist(vec,n)
      real*8 vec(n)
      s0=0.d0
      do iv=1,n
      s0=s0+vec(iv)*vec(iv)
      enddo
      dist=dsqrt(s0)
      return
      end function dist

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc calculate modulus of a vector written on an unorthogogal basis (in a.u.)
cc note: the unorthogonal basis is AL!
      function udist(vec,n)
      real*8 vec(n)
      dx=0.d0
      dy=0.d0
      dz=0.d0
      do iv=1,3
      dx=dx+AL(1,iv)*vec(iv)
      dy=dy+AL(2,iv)*vec(iv)
      dz=dz+AL(3,iv)*vec(iv)
      enddo
      s0=dx*dx+dy*dy+dz*dz
      udist=dsqrt(s0)
      return
      end function udist

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc screen output the variables coming in from the interface of the subroutine
      subroutine printf_xatom(iatom_t,xatom_t,imov_at_t,natom_t)
      real*8 xatom_t(3,natom_t)
      integer iatom_t(natom_t),imov_at_t(3,natom_t)

      do i=1,natom_t
      write(6,200) iatom_t(i),xatom_t(1,i),xatom_t(2,i),xatom_t(3,i),
     & imov_at_t(1,i),imov_at_t(2,i),imov_at_t(3,i)
      enddo
200   format(i3,2x,3(f12.6,1x),2x,3(i2,1x))
      return
      end subroutine printf_xatom

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc screen output variables in the enclosing procedures.
      subroutine printf_xatom_s()

      do i=1,natom
      write(6,100) iatom(i),xatom(1,i),xatom(2,i),xatom(3,i),
     & imov_at(1,i),imov_at(2,i),imov_at(3,i)
      enddo
100   format(i3,2x,3(f12.6,1x),2x,3(i2,1x))
      return
      end subroutine printf_xatom_s

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc note: this subroutine assigns values for the variables 
cc in the enclosing (outer) program: xatom, natom, imov_at and iatom, AL,etc. 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readf_xatom_s()
      implicit double precision (a-h,o-z)
      real*8, allocatable, dimension(:,:) :: xatom_tmp
      integer, allocatable, dimension(:,:) :: imov_at_tmp
      integer, allocatable, dimension(:)   ::  iatom_tmp
       
       
      open(10,file=f_xatom,status='old',action='read',iostat=ierr)
      if(ierr.ne.0) then
      write(6,*) "file ***",f_xatom, " ***does not exist, stop"
      stop
      endif
       
      rewind(10)
      read(10,*) natom
       
      if(natom.gt.matom) then
      write(6,*) "natom.gt.matom, increase matom, stop"
      stop
      endif
       
      allocate(xatom_tmp(3,natom))
      allocate(imov_at_tmp(3,natom))
      allocate(iatom_tmp(natom))
       
      read(10,*) (AL(i,1),i=1,3)
      read(10,*) (AL(i,2),i=1,3)
      read(10,*) (AL(i,3),i=1,3)
      do i=1,natom
      read(10,*) iatom_tmp(i),xatom_tmp(1,i),
     & xatom_tmp(2,i),xatom_tmp(3,i),
     & imov_at_tmp(1,i),imov_at_tmp(2,i),imov_at_tmp(3,i)
      enddo
      close(10)
       
cccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc Now, re-arrange xatom, so the same atoms are consequentive together.
cccc so to be used in PEtot (This is useful to speed up the getwmask.f)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       
      ii=0
100   continue
      ncount=0
      itype_tmp=-2
      do i=1,natom
      if(itype_tmp.eq.-2.and.iatom_tmp(i).ne.-1)
     &  itype_tmp=iatom_tmp(i)
       
      if(iatom_tmp(i).eq.itype_tmp) then
      ii=ii+1
      ncount=ncount+1
      iatom(ii)=iatom_tmp(i)
      iatom_tmp(i)=-1
      xatom(:,ii)=xatom_tmp(:,i)
      imov_at(:,ii)=imov_at_tmp(:,i)
      endif
      enddo
      if(ncount.gt.0) goto 100
      if(ii.ne.natom) then
      write(6,*) "something wrong to rearrange xatom, stop"
      stop
      endif
       
      deallocate(xatom_tmp)
      deallocate(imov_at_tmp)
      deallocate(iatom_tmp)
      
      return
      end subroutine readf_xatom_s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine sort_fragments()
      implicit double precision (a-h,o-z)
      real*8 tmp_size(mfrag)

cccccccccccc assign a number for sorting
      do ii=1,num_frag
      tmp_size(ii)=time(ii)
      enddo
ccccccccccccccccccccccccccccccccccccccccccccccccc
      do ii2=1,num_frag
      tmp_max=0.d0
      ind_max=0
      do ii=1,num_frag
      if(tmp_size(ii).gt.tmp_max) then
      tmp_max=tmp_size(ii)
      ind_max=ii
      endif
      enddo
      ifrag_order(ii2)=ind_max
      tmp_size(ind_max)=-1.d0
      enddo
ccccccccccccccccccccccccccccccccccccccccccccccccc
      return
      end subroutine sort_fragments
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      end program gen_fragments_fix_ZTO
