******************************************
*******************************************
c      program mainMV
      subroutine mainMV2_S2(igroup_start,num_sweep,
     &   iter_PEtot,iter_init,fwg_in,fwg_out,frho_in,frho_out,
     &   fvr_in,fvr_out,iwg_in,iwg_out,irho_in,irho_out,
     &   ivr_in,ivr_out,iloc_save,
     &   nXMPI,num_group_S,inode_tot_S,
     &   nnodes_tot_S,icolor_S,ikey,nnodes_S,inode_S,
     &   MPI_COMM_K_S,MPI_COMM_N_S,
     &   nnodes_all,
     &   GLOBAL_totalnodes_S, GLOBAL_rank_S,
     &   XMPI_COMM_WORLD_S,XMPI_color_S,XMPI_key_S,
     &   inode_all_S,iflag_mem_loc3,
     &   E_nsc_vrho_all,E_dvrrho_all,E_dvrrho2_all,
     &   iflag_report)

****************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
*************************************************************************
**  copyright (c) 2003, The Regents of the University of California,
**  through Lawrence Berkeley National Laboratory (subject to receipt of any
**  required approvals from the U.S. Dept. of Energy).  All rights reserved.
*************************************************************************

******************************************
**** NOTE: for nscf>0 calculation, the getwq.f or real space can be avoided
cccc by read them in from the disk !!!  Currently, not implemented yet!
cccc Lin-Wang Wang, Sept, 8, 2006
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      use fft_data
      use load_data
      use data
ccccc MParallel need to be here, in order to pass in the XMPI_COMM_WORLD etc. 
      use MParallel     ! we should get rid of MParallel
      use IOdata
      use input_head

      implicit double precision (a-h,o-z)

c      include 'mpif.h'         ! it is already included in MParallel

      include 'param.escan_real'

      integer status(MPI_STATUS_SIZE)

******************************************
       real*8 AL(3,3),AL0(3,3),ALt(3,3)
********************************************
       real*8,allocatable,dimension(:,:,:)  :: E_st,err_st
       real*8,allocatable,dimension(:)  :: wmasktmp,xyzmaptmp
       integer,allocatable,dimension(:) :: indmtmp
       real*8,allocatable,dimension(:) :: rhonew1_nL,rhonew2_nL

       complex*16,allocatable,dimension(:,:)  :: ug_n_tmp
       real*8,allocatable,dimension(:)    :: workr_n_tmp
       complex*16,allocatable,dimension(:)  :: workr_n

       real*8, allocatable, dimension(:)    :: vr_nL

       integer icoul
       integer itmp(20)
       real*8 xcoul(3)
       character (len=50) tmp

       real*8 xatom(3,matom),xatom_old(3,matom)
       integer imov_at(3,matom)

       real*8 fatom(3,matom)
       real*8 occ_t(mtype)
       real*8 zatom(mtype),Ealpha(mtype)
       integer iiatom(mtype),icore(mtype)
       integer nmap(matom)
       integer iatom(matom),ityatom(matom),numref(matom)
       integer is_ref(mtype),ip_ref(mtype),id_ref(mtype),
     &   nref_type(mtype),ipsp_type(mtype)
       integer iCGmth0(100),iCGmth1(100),iscfmth0(100),iscfmth1(100)
       real*8  FermidE0(100),FermidE1(100),totNel
       integer  itypeFermi0(100),itypeFermi1(100)
       integer smatr(3,3,48),nrot
       integer niter0,nline0,niter1,nline1,mCGbad0,mCGbad1
       integer kpt_dens(2),ispin_dens(2),iw_dens(2)
       integer lll(8,mtype),nbeta(mtype)
       integer isNLa(9,matom)
       real*8 Dij0(32,32,mtype),Qij(32,32,mtype)
cc       integer XMPI_color
*************************************************
       character*50 vwr_atom(mtype),fforce_out,fdens_out
       character*50 fwg_in,fwg_out,frho_in,frho_out,
     & fvr_in,fvr_out,f_tmp,fxatom_out,fvext_in,
     & fxatom_in
       character*50 file_tmp,tmp_dir,f_jobs
       character*50 file_name,file_name2,file_name3
       character*20 work_dirs(30000)
       character*10 fm_label(30000)

       character*60 message
*************************************************
c       real*8 MPI_WTIME
       real*8 qi(mnq),wq(mnq,8,mtype)
       real*8 ri(201),amr(201)
       common /comline/qi,wq,ri,amr


       common /comNL2/occ_t,iiatom,icore,numref,ityatom
       common /comisNLa/isNLa,Dij0,Qij,ipsp_all,ipsp_type
       common /comEk/Ek
       common /comzatom/zatom
       common /comnmap/nmap
       common /comispd_ref/is_ref,ip_ref,id_ref

       common /comMainEtot1/totNel,
     &     smatr,nrot,ilocal,Ealpha,Ealphat

       common /comMainEtot2/iatom

       common /comlll/lll,nbeta
       common /comcoul/icoul
       common /comxcoul/xcoul

       common /comVext/ivext_in
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       common /WDir_com/work_dirs      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c
c saved arrays for mch_pulay
c

       complex*16,allocatable,dimension(:) :: ugtemp
       complex*16,allocatable,dimension(:) :: temp_array

       integer  GLOBAL_totalnodes_S, GLOBAL_rank_S,
     &   XMPI_COMM_WORLD_S,XMPI_color_S,XMPI_key_S


cccc NOTE: if a variable V is in the common block or module, then
cccc       it is a global array (among the subroutines used this common block and module). 
cccc       As a global array, V has already been given an address (pointer). Thus, within a 
cccc       subroutine, its pointer cannot be re-assigned. Only its value can be re-assigned. 
cccc       So, one can assign its value as: V=V_S. However, if it is passed in from the
cccc       head of subroutine in fortran program, it is equivalent to assign its address (pointer), 
cccc       instead of its value. Thus, there will be a conflict. In fortran subroutine, the 
cccc       array V_S passed in from the header is like a temperary name of the array in the calling
cccc       program with its address (pointer) point to the original array of the calling program. 
cccc       So it is not an independent array. 
cccc IN SUMMARY: if a array V is in a common block or module inside a subroutine, then it cannot
cccc       be passed in from the header of the subroutine. 
cccc
cccc avoid the double input (from subroutine head and common block)

       inode=inode_S     
       nnodes=nnodes_S
       inode_tot=inode_tot_S
       nnodes_tot=nnodes_tot_S
       icolor=icolor_S
       num_group=num_group_S
       MPI_COMM_K=MPI_COMM_K_S
       MPI_COMM_N=MPI_COMM_N_S
cccc avoid the double input (from subroutine head and module)
       GLOBAL_totalnodes=GLOBAL_totalnodes_S
       GLOBAL_rank=GLOBAL_rank_S
       XMPI_COMM_WORLD=XMPI_COMM_WORLD_S
       XMPI_color=XMPI_color_S
       XMPI_KEY=XMPI_key_S
       

**************************************************
c        call getArg(1,tmp_dir) 
c        read(tmp_dir,*) igroup_start
c        call getArg(2,tmp_dir) 
c        read(tmp_dir,*) num_sweep
c        call getArg(3,tmp_dir) 
c        read(tmp_dir,*) fwg_in_t
c        call getArg(4,tmp_dir) 
c        read(tmp_dir,*) fwg_out_t
c        call getArg(5,tmp_dir) 
c        read(tmp_dir,*) frho_out_t
**************************************************
c      atime00=mclock()/100.d0
c
c initialize mpi and number each node
c

c       file_tmp=fxatom_in_h
       num_groupF=num_groupF_h
       nnodes_k=nnodes_k_h
       nnodes_tot_G=nnodes_tot_G_h
       md1=m1_h
       md2=m2_h
       md3=m3_h
       ngd1=ngppa1_h
       ngd2=ngppa2_h
       ngd3=ngppa3_h
ccccccccccccccccccccccccccccccccccc

       num_group=1          ! the number of k-point group
       num_proc_group=nnodes_k
       n10=md1*ngd1
       n20=md2*ngd2
       n30=md3*ngd3


c       call MP_initialize(nXMPI,nnodes_k,num_group,inode_tot,nnodes_tot, 
c     &  icolor,ikey,nnodes,inode,MPI_COMM_K,MPI_COMM_N,XMPI_color, 
c     &  nnodes_all)

       write(tmp,"(i3.3)") XMPI_color
ccccc MPI_COMM_WORLD   the whole system, all nodes
ccccc XMPI_COMM_WORLD  nnodes_tot nodes within each group (for one fragments)
ccccc MPI_COMM_K      nnodes nodes within each k-group (for the same k, a subgroup of XMPI_COMM_WORLD) 
ccccc MPI_COMM_N      num_group(=1) nodes crossing different k-group (for the same inode, subgr. of XMPI_COMM_WORLD)
ccccc XMPI_COMM_WORLD=MPI_COMM_K*MPI_COMM_N
ccccc MPI_COMM_WORLD = num_groupF*XMPI_COMM_WORLD
ccccc nnodes_all       is the total num of nodes of all processors
ccccc nnodes_tot       is the total number of nodes for each Fragment group 
ccccc nnodes_k=nnodes  is the total number of nodes for each k-point group
ccccc num_group        is the number of k-point group (=1 in this program)
ccccc num_groupF=nXMPI is the number of fragment group 
ccccc nnodes_tot=nnodes_k*num_group
ccccc nnodes_tot*num_groupF= total number of nodes
ccccc inode_tot is the node rank in each Fragment group, runs in XMPI_COMM_WORLD
ccccc inode is the node rank in each k-point group, runs in XMPI_COMM_K
ccccc for n_kpt=1, inode_tot=inode, nnodes_tot=nnodes(=nnodes_k)
ccccc icolor is the color among num_group (so for this case, it is always 0), runs in XMPI_COMM_N
ccccc XMPI_color is the color among num_groupF (0 to num_groupF-1) 
ccccc ikey=inode-1
ccccc nnodes_all must be evenly divided by nnodes_tot

      
      if(mod(nnodes_all,nnodes_tot).ne.0.and.inode.eq.1) then
      write(6,*) "nnodes_all cannot be divided by nnodes_tot,stop",
     &      nnodes_all,nnodes_tot
      call mpi_abort(MPI_COMM_WORLD,ierr)
      endif
    

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       pi=4.0d0*datan(1.0d0)
       E_NSC0 = 0.0d0  !amc
       TS0= 0.0d0
       n33 = 0 
       E_COR0 = 0.0d0 
       E_HXC0 = 0.0d0
       E_TOT0 = 0.0d0
       DVE0 = 0.0d0

cccccccccccccc This might cause problem, why not just read in once, then store it! 
       call inputSP(AL0,ilocal,tolug,tolE,
     &  niter0,nline0,iCGmth0,
     &  iscfmth0,FermidE0,
     &  itypeFermi0,mCGbad0,
     &  islda,igga,ntype,iiatom,
     &  ipsp_type,ipsp_all,vwr_atom,nref_type,
     &  ivext_in,idens_out,isym,ikpt_yno,nkpt,nrot,
     &  fxatom_in,iter_PEtot)


ccccccccccccccccccccccccccccccccccccccccccc

       ivr_rho_out=0
       if(ivr_out.eq.2) then
       ivr_rho_out=2
       ivr_out=1
       endif

       if(irho_out.eq.2) then
       ivr_rho_out=2
       irho_out=1
       endif


       if(inode_tot.eq.1.and.XMPI_color.eq.0) then
c       write(6,*) "start PEtot_Ump"
c       call system('mkdir d_report')
c       call system('mkdir d_etot.out')
c       call system('mkdir d_etot2.out')
c       if(ivr_out.eq.1) call system('mkdir d_'//trim(fvr_out))
c       if(irho_out.eq.1) call system('mkdir d_'//trim(frho_out))
c       if(iwg_out.eq.1) call system('mkdir d_'//trim(fwg_out))
c       if(iloc_save.ne.0) call system('mkdir d_noloc')
       endif

***************************************************************
ccc     We might also want to save the result of w_line, just do it once, for the first iteration   
cccc    This can be a serious one !
       dt1=mpi_wtime()

       if(iter_PEtot.eq.iter_init) then
       call w_line(ilocal,ntype,vwr_atom,Ealpha,
     &   MPI_COMM_WORLD,inode_all_S,
     &   occ_t,iiatom,icore,Dij0,Qij,ipsp_type)
       wq_global=wq
       qi_global=qi
       ri_global=ri
       amr_global=amr
       else
       wq=wq_global
       qi=qi_global
       ri=ri_global
       amr=amr_global
       endif

       dt2=mpi_wtime()
       if(inode_all_S.eq.1.and.iflag_report.eq.1) 
     &  write(111,*) "mainMV, time w_line", 
     &  dt2-dt1,iter_PEtot

       time_genG_real=0.d0
       time_genG_comp=0.d0

       call mpi_barrier(MPI_COMM_WORLD,ierr)
       E_nsc_vrho_all=0.d0
       E_dvrrho_all=0.d0
       E_dvrrho2_all=0.d0

cccc In this version, num_sweep=1
ccccc if num_sweep.gt.1, many of the storage in IOdata.f will be wrong
       do 8000 isweep=1,num_sweep

       igroup=XMPI_color+igroup_start+
     &           (isweep-1)*(nnodes_all/nnodes_tot)      ! nnodes_tot=nnodes_k
       if(igroup.gt.num_groupF) goto 8000

       ichar4=igroup/1000
       ichar3=(igroup-ichar4*1000)/100
       ichar2=(igroup-ichar4*1000-ichar3*100)/10
       ichar1=igroup-ichar4*1000-ichar3*100-ichar2*10

       if(inode.eq.1.and.iflag_report.eq.1) then
        open(unit=6,file="d_unit6.out/unit6.out_group."
     &      //char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
     &  ,action="write")       ! all the group member open the same file
       rewind(6)
       endif  


       time00=mpi_wtime()

cccccccccccccccccccccccccccccccccccccccc
        n_tmp1=nkpt*islda/num_group
        n_tmp2=nkpt*islda-n_tmp1*num_group
        if(icolor+1.le.n_tmp2) then
        kpt_slda_dis(1)=icolor*(n_tmp1+1)+1        ! beginning and the end of one k-point group
        kpt_slda_dis(2)=(icolor+1)*(n_tmp1+1)
        else
        kpt_slda_dis(1)=icolor*n_tmp1+n_tmp2+1
        kpt_slda_dis(2)=(icolor+1)*n_tmp1+n_tmp2
        endif
cccccccccccccccccccccccccccccccccccccccc
        n_tmp1=nkpt/num_group
        n_tmp2=nkpt-n_tmp1*num_group
        if(icolor+1.le.n_tmp2) then
        kpt_dis(1)=icolor*(n_tmp1+1)+1
        kpt_dis(2)=(icolor+1)*(n_tmp1+1)
        else
        kpt_dis(1)=icolor*n_tmp1+n_tmp2+1
        kpt_dis(2)=(icolor+1)*n_tmp1+n_tmp2
        endif
cccccccccccccccccccccccccccccccccccccccc


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       ichar4=igroup/1000
       ichar3=(igroup-ichar4*1000)/100
       ichar2=(igroup-ichar4*1000-ichar3*100)/10
       ichar1=igroup-ichar4*1000-ichar3*100-ichar2*10

ccccc inode_tot goes with XMPI_COMM_WORLD
ccccc inode  goes with MPI_COMM_K
       if(iter_PEtot.le.iter_init) then

       if(inode_tot.eq.1) then                 ! we are not careful about inode,inode_tot, assume nkpt=1
       file_name='d_xatom.in/'//trim(fxatom_in)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       open(50,file=file_name,status='old',action='read')
       rewind(50)
       read(50,*) num_frag,num_tot_rec,LREC
       endif

       call mpi_bcast(num_frag,1,MPI_INTEGER,
     &   0,XMPI_COMM_WORLD,ierr)
       call mpi_bcast(num_tot_rec,1,MPI_INTEGER,
     &   0,XMPI_COMM_WORLD,ierr)
       call mpi_bcast(LREC,1,MPI_INTEGER,
     &   0,XMPI_COMM_WORLD,ierr)

        num_frag_X=num_frag
        num_tot_rec_X=num_tot_rec
        LREC_X=LREC
        else         ! iter_PEtot.le.iter_init
        num_frag=num_frag_X
        num_tot_rec=num_tot_rec_X
        LREC=LREC_X
        endif


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       LREC8=LREC*8


       if(inode_tot.eq.1.and.iflag_report.eq.1) then 
       file_name='d_report/report_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       open(22,file=file_name,action="write")
       rewind(22)
c       file_name='d_etot2.out/etot2.out_group.'//char(ichar4+48)//
c     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
c       open(23,file=file_name,action="write")
c       rewind(23)
c       write(23,*) num_frag, "     ! num_frag"
       endif

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccc The current version only works for islda,nkpt=1, because we do not store the wavefunction 
cccccc on the disk during calculation. 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if(islda.ne.1.or.nkpt.ne.1) then     
       write(6,*) "islda or nkpt.ne.1, stop",islda,nkpt
       stop
       endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccc  open up the group files for IO
cccccc These files are kept open during the whole calculation

       if(icolor.eq.0) then    

       do iislda=1,islda         ! at this moment, can only do islda=1, other wise, need place to hide wavefunc. 

       if(iislda.eq.1.and.iwg_in.eq.1.and.inode.eq.nnodes) then     ! inode.eq.nnodes
ccccc if iwg_in.ne.1, then these files will not be openned. 
c       file_name='d_'//trim(fwg_in)//'/'//trim(fwg_in)

       if(mod(iter_PEtot,2).eq.0) then     ! even inputfrom d_wg.odd (Previous iter)
       file_name='d_wg.odd/'//trim(fwg_in)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       else
       file_name='d_wg.even/'//trim(fwg_in)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
        endif

       iunit_wg_in1=31
       open(unit=iunit_wg_in1,file=file_name,form='unformatted',
     &   status='old',action='read',iostat=ierr)
       rewind(unit=iunit_wg_in1)
       endif

       if(iislda.eq.1.and.ivr_in.eq.1.and.inode.eq.1) then
c       file_name='d_'//trim(fvr_in)//'/'//trim(fvr_in)
       file_name='d_vr.in/'//trim(fvr_in)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       iunit_vr_in1=33
       open(unit=iunit_vr_in1,file=file_name,form='unformatted',
     &   status='old',action='read',access='direct',recl=LREC8,
     &   iostat=ierr)
       endif

       if(iislda.eq.1.and.irho_in.eq.1.and.inode.eq.1) then
c       file_name='d_'//trim(frho_in)//'/'//trim(frho_in)
       file_name='d_dens.in/'//trim(frho_in)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       iunit_rho_in1=35
       open(unit=iunit_rho_in1,file=file_name,form='unformatted',
     &   status='old',action='read',access='direct',recl=LREC8,
     &   iostat=ierr)
       endif

       if(iislda.eq.1.and.iloc_save.eq.1.and.inode.eq.nnodes) then     ! inode.eq.1
       file_name='d_noloc/noloc_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       iunit_loc_in=37
       open(unit=iunit_loc_in,file=file_name,form='unformatted',
     &   status='old',action='read',iostat=ierr)
       rewind(unit=iunit_loc_in)
       endif

       if(iislda.eq.1.and.(iwg_out.eq.1.or.iwg_out.eq.200)           ! write out to disk
     &        .and.inode.eq.1) then
c       file_name='d_'//trim(fwg_out)//'/'//trim(fwg_out)

       if(mod(iter_PEtot,2).eq.0) then     ! even output to d_wg.even
       file_name='d_wg.even/'//trim(fwg_out)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
        else
       file_name='d_wg.odd/'//trim(fwg_out)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
        endif

       iunit_wg_out1=41
       open(unit=iunit_wg_out1,file=file_name,form='unformatted',
     &   action='write',iostat=ierr)
       rewind(unit=iunit_wg_out1)
       endif

       if(iislda.eq.1.and.ivr_out.eq.1.and.inode.eq.1) then
c       file_name='d_'//trim(fvr_out)//'/'//trim(fvr_out)
       file_name='d_vr.out/'//trim(fvr_out)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       iunit_vr_out1=43
       open(unit=iunit_vr_out1,file=file_name,form='unformatted',
     &   action='write',access='direct',recl=LREC8,
     &   iostat=ierr)
       endif

       if(iislda.eq.1.and.irho_out.eq.1.and.inode.eq.1) then
c       file_name='d_'//trim(frho_out)//'/'//trim(frho_out)
       file_name='d_dens.out/'//trim(frho_out)
     &  //'_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       iunit_rho_out1=45
       open(unit=iunit_rho_out1,file=file_name,form='unformatted',
     &   action='write',access='direct',recl=LREC8,
     &   iostat=ierr)
       endif

       if(iislda.eq.1.and.(iloc_save.eq.2.or.iloc_save.eq.200).
     &       and.inode.eq.1.
     &     and.icolor.eq.0) then     ! inode.eq.1
       file_name='d_noloc/noloc_group.'//char(ichar4+48)//
     &  char(ichar3+48)//char(ichar2+48)//char(ichar1+48)
       iunit_loc_out=47
       open(unit=iunit_loc_out,file=file_name,form='unformatted',
     &   action='write',iostat=ierr)
       rewind(unit=iunit_loc_out)
       endif

       enddo     ! do iislda

       endif     ! icolor.eq.0
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

       do 4000 ifrag=1,num_frag

       time000=mpi_wtime()

       if(iter_PEtot.le.iter_init) then

       if(inode_tot.eq.1) then
       read(50,*)         ! A dashed line
       read(50,*) natom,n1,n2,n3,totNel,ic1,ic2,ic3,ns1,ns2,ns3,
     &   ind_frag,ipos_rec,num_rec
       read(50,*) AL(1,1),AL(2,1),AL(3,1)
       read(50,*) AL(1,2),AL(2,2),AL(3,2)
       read(50,*) AL(1,3),AL(2,3),AL(3,3)
ccccccc collect, then broadcast
       call collect_to_itmp()
       endif

       call mpi_bcast(itmp,20,MPI_INTEGER,
     &   0,XMPI_COMM_WORLD,ierr)
       call mpi_bcast(totNel,1,MPI_REAL8,
     &   0,XMPI_COMM_WORLD,ierr)
       call mpi_bcast(AL,9,MPI_REAL8,
     &   0,XMPI_COMM_WORLD,ierr)
       call distribute_from_itmp()

       natom_X(ifrag)=natom
       n1_X(ifrag)=n1
       n2_X(ifrag)=n2
       n3_X(ifrag)=n3
       totNel_X(ifrag)=totNel
       ic1_X(ifrag)=ic1
       ic2_X(ifrag)=ic2
       ic3_X(ifrag)=ic3
       ns1_X(ifrag)=ns1
       ns2_X(ifrag)=ns2
       ns3_X(ifrag)=ns3
       ind_frag_X(ifrag)=ind_frag
       ipos_rec_X(ifrag)=ipos_rec
       num_rec_X(ifrag)=num_rec
       AL_X(:,:,ifrag)=AL(:,:)

       else       ! iter_PEtot.le.iter_init
       natom=natom_X(ifrag)
       n1=n1_X(ifrag)
       n2=n2_X(ifrag)
       n3=n3_X(ifrag)
       totNel=totNel_X(ifrag)
       ic1=ic1_X(ifrag)
       ic2=ic2_X(ifrag)
       ic3=ic3_X(ifrag)
       ns1=ns1_X(ifrag)
       ns2=ns2_X(ifrag)
       ns3=ns3_X(ifrag)
       ind_frag=ind_frag_X(ifrag)
       ipos_rec=ipos_rec_X(ifrag)
       num_rec=num_rec_X(ifrag)
       AL(:,:)=AL_X(:,:,ifrag)
       endif

       if(inode_tot.eq.1.and.iflag_report.eq.1) then
       write(6,*) "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
       write(6,*) "RUNNING, igroup, ifrag, natom, n1,n2,n3,"//
     &  "totNel, ic1,ic2,ic3,ns1,ns2,ns3"
       write(6,505) igroup,ifrag,natom,n1,n2,n3,totNel,ic1,ic2,ic3,
     &  ns1,ns2,ns3
505    format(i4,2x,i4,5x,i4, 3x, 3(i4,1x),2x,f13.5,2x,    
     &    3(i3,1x),2x, 3(i1,1x))
       write(6,*) "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
       call system_flush(6)
       endif


       mx=totNel/2+5

ccccccccccccccccccccccccccccccccccccccccccccccccccc
        n_tmp1=natom/num_group
        n_tmp2=natom-n_tmp1*num_group
        if(icolor+1.le.n_tmp2) then
        natom_dis(1)=icolor*(n_tmp1+1)+1
        natom_dis(2)=(icolor+1)*(n_tmp1+1)
        else
        natom_dis(1)=icolor*n_tmp1+n_tmp2+1
        natom_dis(2)=(icolor+1)*n_tmp1+n_tmp2
        endif
ccccccccccccccccccccccccccccccccccccccccccccccccccc

       if(iter_PEtot.le.iter_init) then

        if(inode.eq.1) then
       do i=1,natom
       read(50,*) iatom(i),xatom(1,i),xatom(2,i),xatom(3,i)
       enddo
        endif
       call mpi_bcast(iatom,natom,MPI_INTEGER,
     &   0,XMPI_COMM_WORLD,ierr)
       call mpi_bcast(xatom,natom*3,MPI_REAL8,
     &   0,XMPI_COMM_WORLD,ierr)

         do i=1,natom
         j=iX_pos_X(ifrag)+i-1
         iatom_X(j)=iatom(i) 
         xatom_X(:,j)=xatom(:,i)
         enddo
       else        ! iter_PEtot.le.iter_init
         do i=1,natom
         j=iX_pos_X(ifrag)+i-1
         iatom(i)=iatom_X(j)
         xatom(:,i)=xatom_X(:,j)
         enddo
       endif
    
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

          nref_tot=0
         do ia=1,natom
            iref_start(ia)=nref_tot
            iitype=0
            do itype=1,ntype
            if(iatom(ia).eq.iiatom(itype)) iitype=itype
            enddo
            if(iitype.eq.0) then
            write(6,*) "itype not found, stop", iatom(ia),ia
            call mpi_abort(MPI_COMM_WORLD,ierr)
            endif
            ityatom(ia)=iitype
            numref(ia)=nref_type(iitype)
            nref_tot=nref_tot+nref_type(iitype)
         enddo


	  Ealphat=0.d0   
	  ch=0.d0
	  do ia=1,natom
	  Ealphat=Ealphat+Ealpha(ityatom(ia))
	  ch=ch+zatom(ityatom(ia))
	  enddo
	  Ealphat=Ealphat*ch/vol
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        n1L=n1
        n2L=n2
        n3L=n3
        iflag_fft2L=0       ! doesn't need fft2L


cccccccccccccccccccccccccccccccccccccccc
        nrL=n1L*n2L*n3L
        nr_nL=n1L*n2L*n3L/nnodes
cccccccccccccccccccccccccccccccccccccccc
cccc this is the correct estimation for n1,n2,n3 even for nonorthogonal AL(3,3)
ccccccccccc
       if(inode_tot.eq.1.and.iflag_report.eq.1) then 

       write(22,*) "***** ))) OUTPUT FILE FROM PETOT ((( *******"
       write(22,303) ic1,ic2,ic3,ns1,ns2,ns3
       write(22,*) "************************"
       write(22,304) n1,n2,n3
       write(22,309) natom
       write(22,301) islda,igga,nkpt
       write(22,305) Ecut*2,Ecut2*2,Ecut2L*2,Smth
       write(22,306) totNel,mx,tolug,tolE
       write(22,307) ilocal,rcut,ntype
       write(22,*) "*********************"
       write(22,*) "AL1,AL2,AL3 in (x,y,z)"
       write(22,133) AL(1,1),AL(2,1),AL(3,1)
       write(22,133) AL(1,2),AL(2,2),AL(3,2)
       write(22,133) AL(1,3),AL(2,3),AL(3,3)
       write(22,*) "************************"
       call system_flush(22)

       endif
303    format("fragment: ic1,2,3, ns1,2,3  :",3(i5,1x),2x,3(i1,1x)) 
304    format("Actual      n1,n2,n3 used here  ***: ",3(i6,1x))
309    format(" natom=",i7)
301    format(" islda=",i7,    "     igga=", i7, "   nkpt=", i4)
305    format("  Ecut=",f7.2,  "    Ecut2=",f7.2,"    Ecut2L=",f7.2,
     &   "   Smth=",f7.2)
306    format("totNel=",f7.2,  "       mx=",i7,  "     tolug=",E7.1,
     &   "   tolE=",E7.1)
307    format("ilocal=",i7,    "     rcut=",f7.2,"     ntype=",i7)
308    format("numkpt=",i7,    "  num-sym=",i7,  "  atom_mov=",i7,
     & " dtstart=",f9.4, " dd_limit=",f9.4)
133    format(3(f14.7,1x))

**********************************
ccccc  mx passed from input from param.escan_real
       mst=mx
        allocate(E_st(mst,nkpt,islda))
        allocate(err_st(mst,nkpt,islda))
**********************************
       Ek=0.5d0

       nr=n1*n2*n3
       nr_n = nr/nnodes

       mr=n1*n2*(n3+2)
       mr_n=mr/nnodes*(1+3.d0*nnodes/(n2*n3))  ! possible imbalance factor, some proc. has 2-3 more column
       mr=mr_n*nnodes
ccccc  (n3+2) is for the half plane in d3fft_real2
ccccc  fact (1+2.d0*nnodes/(n2*n3)) is for possible column load imbalance between diff. processors. 
ccccc  need to check the d3fft_real2 more carefully, and fftprep_real2.f

       nrL=n1L*n2L*n3L
       nr_nL=nrL/nnodes

       mrL=n1L*n2L*(n3L+2)
       mr_nL=mrL/nnodes*(1+3.d0*nnodes/(n2L*n3L))
       mrL=mr_nL*nnodes
ccccc  (n3L+2) is for the half plane in d3fft_real2L
ccccc  fact (1+2.d0*nnodes/(n2*n3)) is for possible column load imbalance between diff. processors. 

c     Calculate the approx. no. of g points, so we can dimension arrays
      volume=al(3,1)*(al(1,2)*al(2,3)-al(1,3)*al(2,2))
     &     +al(3,2)*(al(1,3)*al(2,1)-al(1,1)*al(2,3))
     &     +al(3,3)*(al(1,1)*al(2,2)-al(1,2)*al(2,1))
      volume = dabs(volume)
      vol=volume
      delta_k=(2*pi)**3/volume
      totg=(4.0d0/3.0d0*pi*(dsqrt(2.0d0*Ecut))**3)/delta_k
cc      mg_nx_tmp=int(1.1d0*totg/nnodes)+100
      mg_nx_tmp=int(1.03d0*totg/nnodes)+100

      mg_nx=io_wfrag(ifrag)%mg_nx
      if(mg_nx.ne.mg_nx_tmp.and.inode.eq.1) then
      write(6,*) "mg_nx.ne.mg_nx_tmp,stop",mg_nx,mg_nx_tmp
      call mpi_abort(MPI_COMM_WORLD,ierr)
      endif


c     Check that nr is a mulitple of the no. of nodes
      if (mod(nr,nnodes)/=0.or.mod(mr,nnodes)/=0) then
         write(6,*)'No. of grid points must be multiple of
     &        the no. of nodes. for both nr and mr'
         stop
      end if

      num_scf0=0
      do iter=1,niter0
      if(iscfmth0(iter).ne.0) num_scf0=num_scf0+1
      enddo


      npulay_max=1

      if(ivr_rho_out.eq.2) then            ! just calculate vr_out, then stop
      mx=1                                 ! reduce the memory
      nref_tot=1
      endif

        nkpt=1
        call data_allocate_akx(nkpt)
        call ngtot_allocate(nnodes,nkpt)
        akx(1)=0.d0
        aky(1)=0.d0
        akz(1)=0.d0
        weighkpt(1)=1.d0
 

       call fft_allocate(n1,n2,n3,nnodes)
cccc  ncolx is defined inside fft_allocate
       call load_allocate(n1,n2,n3,ncolx,nnodes,mg_nx,mr_n)
       iGENPOT=0
       call data_allocate(mg_nx,mx,mr_n,mr_nL,ilocal,inode,nkpt,
     &   islda,natom,nref_tot,ipsp_all,nnodes,npulay_max,iGENPOT)


       if(ilocal.eq.2) then
cccccc need the fft from Ecut2(ng2) to real space to run getwmask.f
       call fft_allocateL(n1L,n2L,n3L,nnodes,iflag_fft2L)
       call load_allocateL(n1L,n2L,n3L,ncolxL,nnodes,mr_nL,
     &       iflag_fft2L)
       endif


        allocate(workr_n(mr_n))

**********************************
       call get_ALI(AL,ALI)

       if(ivr_in.ge.1) then
       ido_vr=0
       else
       ido_vr=1
       endif

       if(irho_in.ge.1) then
       ido_rho=0
       else
         if(ivr_in.eq.0) then
         ido_rho=1     ! calculate the atomic charge density only when no input pot
         else
         ido_rho=0
         endif
       endif




       if(ilocal.eq.2.or.ido_vr.eq.1.
     &                   or.ido_rho.eq.1) then    
        dt1=mpi_wtime()
       call gen_G2_real()
       call fftprep_real2(n1,n2,n3,mr_n)
        dt2=mpi_wtime()
        time_genG_real=time_genG_real+dt2-dt1
       endif

*********************************************
       if(nkpt.ne.1) then
       write(6,*) "nkpt.ne.1, stop",nkpt
       stop
       endif

       dt1=mpi_wtime()
       if(ivr_rho_out.ne.2) then
       kpt=1
       if(iter_PEtot.eq.iter_init) then
       call gen_G_comp(kpt,0)        
       else
       call gen_G_comp(kpt,100)        ! do not check whether Ecut is inside the box, reduce some calc.        
       endif

       call fftprep_comp(n1,n2,n3)
       endif
       dt2=mpi_wtime()
       time_genG_comp=time_genG_comp+dt2-dt1

ccccccccc  only call this once for LS3DF

      
       if(icolor.eq.0) then         ! the first group in the k-point group  
       if(ivr_rho_out.ne.2) then    ! for ivr_out.eq.2, ug initi is not necessary

       do iislda=1,islda

       do kpt=1,nkpt
c       call gen_G_comp(kpt,0)         ! need to be called for all icolor to get the kpt related quantities 
c       call fftprep_comp(n1,n2,n3)
       iranm=-4513*(iislda-1)-1371*kpt-5616*inode
       call init_ugSP(AL,iwg_in,workr_n,kpt,iranm,iunit_wg_in1,ifrag)
       enddo

       enddo   ! iislda=1,islda
       endif   ! ivr_rho_out.ne.2

       else   ! icolor.eq.0,  only do above for icolor.eq.0 due to strange arrangement for iwg_in=1

cccc for LS3DF, we will never be here
c       do kpt=1,nkpt
c       call gen_G_comp(kpt,0)         ! need to for  all icolor to initialize the kpt related quantities 
c       enddo
       endif   ! icolor.eq.0
*************************************************************
*********************************************************
       if(ivr_in.ge.1) then
       do iislda=1,islda
       if(ivr_in.eq.1) then    ! input from disk, also put to memory-array
       if(iislda.eq.1) then
       call rhoIO_dir(vr_in_nL(1,iislda),mr_n,2,
     &     n1L,n2L,n3L,iunit_vr_in1,num_proc_group,
     &   num_rec,ipos_rec,LREC)    
       endif
       frag_group_pot(frag_group_p(ifrag):
     &  frag_group_p(ifrag)+nr_nL-1)=vr_in_nL(1:nr_nL,iislda)
       else          ! input from memory-array
       vr_in_nL(1:nr_nL,iislda)=frag_group_pot(
     &  frag_group_p(ifrag):frag_group_p(ifrag)+nr_nL-1)
       endif
       enddo
       ido_vr=0
       else
       ido_vr=1
       endif


       if(irho_in.ge.1) then
       do iislda=1,islda

       if(irho_in.eq.1) then
       if(iislda.eq.1) then
       call rhoIO_dir(rho_nL(1,iislda),mr_n,2,
     &     n1L,n2L,n3L,iunit_rho_in1,num_proc_group,
     &     num_rec,ipos_rec,LREC)    
       endif
       frag_group_dens(frag_group_p(ifrag):                         ! write the input rho_nL into memory-array
     &  frag_group_p(ifrag)+nr_nL-1)=rho_nL(1:nr_nL,iislda)
       else
       rho_nL(1:nr_nL,iislda)=frag_group_dens(
     &  frag_group_p(ifrag):frag_group_p(ifrag)+nr_nL-1)
       endif

       enddo
       ido_rho=0
       else
         if(ivr_in.eq.0) then
         ido_rho=1     ! calculate the atomic charge density only when no input pot
         else
         ido_rho=0
         endif
       endif


cccccccc  ido_rho=0;1, initially, not calc. or calc. rho_n from atom
cccccccc  ido_vr=0;1,  initially, not calc. or calc. vr_in_n from rho_n
cccccccc  iforce_cal=0;1    not calc. or calc. force

cccccccc   one total energy calculation before moving the atoms

       call mpi_barrier(XMPI_COMM_WORLD,ierr)

       iforce_cal=0

       call Etotcalc_V(xatom,fatom,workr_n,Etot,
     &  iforce_cal,ido_rho,ido_vr,tolug,tolE,niter0,nline0,
     &  iCGmth0,iscfmth0,FermidE0,itypeFermi0,mCGbad0,E_st,err_st,AL,
     &  nkpt,convergE,islda,igga,ivr_rho_out,igroup,
     &  iloc_save,iunit_loc_in,iunit_loc_out,ifrag,inode_all_S,
     &  iter_PEtot,iter_init,iflag_mem_loc3,
     &  E_nsc_vrho_report,E_dvrrho_report,
     &  iflag_report)

      if(ns1.eq.2.and.ns2.eq.2.and.ns3.eq.2) alpha=1.d0
      if(ns1.eq.2.and.ns2.eq.2.and.ns3.eq.1) alpha=-1.d0
      if(ns1.eq.2.and.ns2.eq.1.and.ns3.eq.2) alpha=-1.d0
      if(ns1.eq.1.and.ns2.eq.2.and.ns3.eq.2) alpha=-1.d0
      if(ns1.eq.2.and.ns2.eq.1.and.ns3.eq.1) alpha=1.d0
      if(ns1.eq.1.and.ns2.eq.2.and.ns3.eq.1) alpha=1.d0
      if(ns1.eq.1.and.ns2.eq.1.and.ns3.eq.2) alpha=1.d0
      if(ns1.eq.1.and.ns2.eq.1.and.ns3.eq.1) alpha=-1.d0
      E_dvrrho_all=E_dvrrho_all+alpha*E_dvrrho_report
      E_dvrrho2_all=E_dvrrho2_all+abs(E_dvrrho_report)
      E_nsc_vrho_all=E_nsc_vrho_all+alpha*E_nsc_vrho_report



      if(iwg_out.ge.1) then
      if(icolor.eq.0) then    ! the first group in k-point group
      call write_wgSP(AL,islda,nkpt,iunit_wg_out1,iwg_out,ifrag)
      endif
      endif

ccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if(ivr_out.ge.1) then
       do iislda=1,islda

       if(ivr_out.eq.1) then
       if(iislda.eq.1) then
       call rhoIO_dir(vr_in_nL(1,iislda),mr_n,1,
     &     n1L,n2L,n3L,iunit_vr_out1,num_proc_group,
     &     num_rec,ipos_rec,LREC)   
       endif
       frag_group_pot(frag_group_p(ifrag):
     &  frag_group_p(ifrag)+nr_nL-1)=vr_in_nL(1:nr_nL,iislda)
       else                           ! write it out to memory only
       frag_group_pot(frag_group_p(ifrag):
     &  frag_group_p(ifrag)+nr_nL-1)=vr_in_nL(1:nr_nL,iislda)
       endif

       enddo
       endif

cccccccccccccccccccccccccccccccccccccccccccccccccccc
       if(irho_out.ge.1) then
       do iislda=1,islda

       if(irho_out.eq.1) then  ! write it out to disk and memory
       if(iislda.eq.1) then
       call rhoIO_dir(rho_nL(1,iislda),mr_n,1,
     &     n1L,n2L,n3L,iunit_rho_out1,num_proc_group,
     &     num_rec,ipos_rec,LREC)    
       endif
       frag_group_dens(frag_group_p(ifrag):
     &  frag_group_p(ifrag)+nr_nL-1)=rho_nL(1:nr_nL,iislda)
       else                           ! write it out to memory only
       frag_group_dens(frag_group_p(ifrag):
     &  frag_group_p(ifrag)+nr_nL-1)=rho_nL(1:nr_nL,iislda)
       endif

       enddo
       endif
ccccccccccccccccccccccccccccccccccccccc
*******************************************************
*******************************************************

       if(inode_tot.eq.1.and.iflag_report.eq.1) then
       write(22,*) "computational time=", tim
       write(22,*) "last report from diag_real"
       write(22,*) "*********************************"
       write(22,*) 
     & "Eigen energies are values after setting ave(Vtot)=0"
       write(22,*) 
     & "For Vtot=V_ion+V_Hartree+V_xc, and"
       write(22,*) 
     & "ave(V_ion+V_Hatree)=0, ave(V_xc).ne.0:  E=E+v0"
       do iislda=1,islda
       do kpt=1,nkpt
       write(22,*) "*********************************"
       write(22,104) iislda, kpt
       write(22,*) "err of each states, A.U"
       write(22,102) (err_st(i,kpt,iislda), i=1,mx)
       write(22,*) "eigen energies, in eV "
       write(22,103) (E_st(i,kpt,iislda)*27.211396d0, i=1,mx)
       write(22,*) "*********************************"
       enddo
       enddo
       endif

102   format(5(E10.4,3x))
103   format(5(f12.8,1x))
104   format("iislda,kpt= ",i3,", ", i4)


      call deletefile()
      call data_deallocate(iGENPOT)
      call load_deallocate()
      call fft_deallocate()

      if(ilocal.eq.2) then
      call fft_deallocateL(iflag_fft2L)
      call load_deallocateL(iflag_fft2L)
      endif

ccc      call fft_deallocate2L()      ! strange, why?

      deallocate(workr_n)

      if(icoul.ne.0) then
      call data_deallocate_nL2()
      endif

cccccccccccccccccccccccccccccc   returning point
 

       call data_deallocate_akx()
       deallocate(E_st)
       deallocate(err_st)
       time111=mpi_wtime()
       if(inode.eq.1.and.iflag_report.eq.1) then
       write(6,*) "time for this fragment",ifrag,
     & time111-time000,n1,n2,n3,natom,mx
       endif
4000   continue

       time11=mpi_wtime()
       if(inode.eq.1.and.iflag_report.eq.1) then
       write(6,*) "total time for this group",time11-time00
       endif


       if(isweep.lt.num_sweep.and.inode.eq.1.and.
     &  iflag_report.eq.1)  close(unit=6)    

       if(inode_tot.eq.1.and.iflag_report.eq.1) then
       close(22) 
c       close(23)
       endif

       if(iter_PEtot.le.iter_init) then
       if(inode_tot.eq.1) then
       close(50)
       endif
       endif


       if(icolor.eq.0) then    
       do iislda=1,islda         ! at this moment, can only do islda=1, other wise, need place to hide wavefunc. 

       if(iislda.eq.1.and.iwg_in.eq.1.and.inode.eq.nnodes) then     ! inode.eq.nnodes
       close(unit=iunit_wg_in1)
       endif

       if(iislda.eq.1.and.ivr_in.eq.1.and.inode.eq.1) then     ! inode.eq.1
       close(unit=iunit_vr_in1)
       endif

       if(iislda.eq.1.and.irho_in.eq.1.and.inode.eq.1) then
       close(unit=iunit_rho_in1)
       endif

       if(iislda.eq.1.and.iloc_save.eq.1.and.inode.eq.nnodes) then     ! inode.eq.1
       close(unit=iunit_loc_in)
       endif

       if(iislda.eq.1.and.(iwg_out.eq.1.or.iwg_out.eq.200).
     &          and.inode.eq.1) then
       close(unit=iunit_wg_out1)
       endif

       if(iislda.eq.1.and.ivr_out.eq.1.and.inode.eq.1) then
       close(unit=iunit_vr_out1)
       endif

       if(iislda.eq.1.and.irho_out.eq.1.and.inode.eq.1) then
       close(unit=iunit_rho_out1)
       endif

       if(iislda.eq.1.and.(iloc_save.eq.2.or.iloc_save.eq.200).
     &     and.inode.eq.1.
     &     and.icolor.eq.0) then     ! inode.eq.1
       close(unit=iunit_loc_out)
       endif
       enddo     ! do iislda
       endif     ! icolor.eq.0
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
8000   continue

        if(inode_all_S.eq.1.and.iflag_report.eq.1) then
       write(111,*) "main, time G_comp,G_real",
     & time_genG_comp,time_genG_real,iter_PEtot,
     &   ilocal,ido_vr,ido_rho
         endif


      call mpi_barrier(MPI_COMM_WORLD,ierr)


       time22=mpi_wtime()
       if(inode.eq.1.and.iflag_report.eq.1) then
       write(6,*) "total time for all groups",time22-time00
       write(6,*) "main, time G_comp,G_real",
     & time_genG_comp,time_genG_real
       endif
       if(inode.eq.1)  close(unit=6)    




c      call mpi_finalize(ierr)


cc      stop
      return

      contains
      
*****************************************************
*****************************************************
       subroutine collect_to_itmp()
       implicit double precision (a-h,o-z)
       itmp=0
       itmp(1)=natom
       itmp(2)=n1
       itmp(3)=n2
       itmp(4)=n3
       itmp(5)=ic1
       itmp(6)=ic2
       itmp(7)=ic3
       itmp(8)=ns1
       itmp(9)=ns2
       itmp(10)=ns3
       itmp(11)=ind_frag
       itmp(12)=ipos_rec
       itmp(13)=num_rec
       return
       end subroutine collect_to_itmp
*****************************************************
       subroutine distribute_from_itmp()
       implicit double precision (a-h,o-z)
       natom=itmp(1)
       n1=itmp(2)
       n2=itmp(3)
       n3=itmp(4)
       ic1=itmp(5)
       ic2=itmp(6)
       ic3=itmp(7)
       ns1=itmp(8)
       ns2=itmp(9)
       ns3=itmp(10)
       ind_frag=itmp(11)
       ipos_rec=itmp(12)
       num_rec=itmp(13)
       return
       end subroutine distribute_from_itmp
*****************************************************

ccccccccccccccccccccccccccccccccccccccccccccccccccccc
       subroutine deletefile()
       implicit double precision(a-h,o-z)
       character*8 fname
       character*9 fname9


       if(inode_tot.eq.1) then

       do istep=0,1
       do iislda=1,islda
       do kpt=1,nkpt

       fname="ugiofile"
       kpt1=mod(kpt,10)
       kpt2=mod((kpt-kpt1)/10,10)
       kpt3=mod((kpt-kpt1-kpt2*10)/100,10)
       kpt4=mod((kpt-kpt1-kpt2*10-kpt3*100)/1000,10)

ccccccccccc do not need to delete ugio, never used
c       open(10,file=
c     & trim(work_dirs(XMPI_color+1))//'/'//fname//char(iislda+48)//
c     & char(istep+48)//char(kpt4+48)//
c     &  char(kpt3+48)//char(kpt2+48)//char(kpt1+48),
c     &  form="unformatted")
c       close(10,status='delete')

       if(ipsp_all.eq.2) then
       fname9="bpsiiofil"
       kpt1=mod(kpt,10)
       kpt2=mod((kpt-kpt1)/10,10)
       kpt3=mod((kpt-kpt1-kpt2*10)/100,10)
       kpt4=mod((kpt-kpt1-kpt2*10-kpt3*100)/1000,10)

       open(10,file=
     & trim(work_dirs(XMPI_color+1))//'/'//
     & fname9//char(iislda+48)//
     & char(istep+48)//char(kpt4+48)//
     &  char(kpt3+48)//char(kpt2+48)//char(kpt1+48),
     &       form="unformatted")
       close(10,status='delete')
       endif

       enddo
       enddo
       enddo


       if(ilocal.eq.3) then
       do kpt=1,nkpt

       fname="wqiofile"
       kpt1=mod(kpt,10)
       kpt2=mod((kpt-kpt1)/10,10)
       kpt3=mod((kpt-kpt1-kpt2*10)/100,10)
       kpt4=mod((kpt-kpt1-kpt2*10-kpt3*100)/1000,10)

c       open(10,file=
c     & trim(work_dirs(XMPI_color+1))//'/'//
c     & fname//char(kpt3+48)//
c     &  char(kpt2+48)//char(kpt1+48),
c     &       form="unformatted")
c       close(10,status='delete')
       enddo
       endif

c       open(10,file=
c     & trim(work_dirs(XMPI_color+1))//'/'//'wrhofile1000')
c       close(10,status='delete')
c       open(10,file=
c     & trim(work_dirs(XMPI_color+1))//'/'//'wrhofile2000')
c       close(10,status='delete')

       endif

       return
       end subroutine deletefile
       
ccccccccccccccccccccccccccccccccccccccccccccccccccccc

        end
      


