      subroutine mch_pulay_GENPOT(w_in,w_out,nscf,islda,AL)
******************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
cc     Copyright 2001 The Regents of the University of California
cc     The United States government retains a royalty free license in this work
******************************************


      use fft_data
      use load_data
      use data
      use IOmch

      implicit double precision (a-h,o-z)
      include 'param.escan_real'
      include 'mpif.h'

      real*8 w_in(mr_nL,islda),w_out(mr_nL,islda)

      real*8 AA(npulay_max,npulay_max),B(npulay_max)
      real*8 AA1(npulay_max,npulay_max)
      real*8 AL(3,3),tmp(npulay_max)

      real*8 dt1,dt2,dt3

cccc  _G means _GENPOT. 
cccc  They have to redefined since they conflict with the one in data.f
cccc  The original dw,dR might still be used by other subroutine, so they are not comment out

c      real*8,allocatable,dimension(:,:,:)      :: dw_G,dR_G     
c      real*8,allocatable,dimension(:,:)        :: R0_G,w_in0_G

      character*50 tmp_arg

      alpha2=1.d0
cccc alpha2 controls how many recent charge densities
cccc to be used. If alpha2 > 1, then, the very old
cccc charge density is not used effectivly. 
cccc We find that alpha2=1 is O.K.
******************************************************

       if(npulay_max.eq.1) return 
cccccc for npulay_max.eq.1, there is no effect for this program, just return. 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      ireset=(nscf-1)/npulay_max                ! nscf=iter_PEtot-iter_init+1
      nint=nscf-npulay_max*ireset

c      allocate(dw_G(mr_nL,nint-1,islda))    ! they are opened in IOmch
c      allocate(dR_G(mr_nL,nint-1,islda))    ! 
c      allocate(R0_G(mr_nL,islda))
c      allocate(w_in0_G(mr_nL,islda))


       
       if (nint.gt.2) then	
       AA=AA_G                         ! AA_G is stored in IOmch
       endif

ccccccccccccccccccccccccccccccccccccccccccccc

      if(nint.eq.1) then

      do iislda=1,islda
      do i=1,nr_nL
      R0_G(i,iislda)=w_out(i,iislda)-w_in(i,iislda)
      w_in0_G(i,iislda)=w_in(i,iislda)
      enddo
      enddo

      endif

******************************************************
      if(nint.gt.1) then

      do iislda=1,islda
      do i=1,nr_nL
      dw_G(i,nint-1,iislda)=w_in(i,iislda)-w_in0_G(i,iislda)
      dR_G(i,nint-1,iislda)=w_out(i,iislda)-w_in(i,iislda)-
     &                 R0_G(i,iislda)
      R0_G(i,iislda)=w_out(i,iislda)-w_in(i,iislda)
      w_in0_G(i,iislda)=w_in(i,iislda)
      enddo
      enddo


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      do m=1,nint-1
c      s=0.d0
c      do iislda=1,islda
c      do i=1,nr_nL
c      s=s+dR_G(i,m,iislda)*R0_G(i,iislda)       ! use blas ?
c      enddo
c      enddo
c      s=s*vol/nrL
c      tmp(m)=-s
c      enddo

       tmp(1:nint-1)=0.d0
       fact=-vol/nrL
       do iislda=1,islda
       call dgemv('T',nr_nL,nint-1,fact,dR_G(1,1,iislda),
     &  mr_nL,R0_G(1,iislda),1,1.d0,tmp,1)
       enddo
ccccccccccccccccccccccccccccccccccccccccccc

      call mpi_allreduce(tmp,B,nint-1,
     $     MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)


******************************************************
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      do m=1,nint-1
c      s1=0.d0
c      do iislda=1,islda
c      do i=1,nr_nL
c      s1=s1+dR_G(i,m,iislda)*dR_G(i,nint-1,iislda)     ! use blas ?
c      enddo
c      enddo
c      s1=s1*vol/nrL
c      tmp(m)=s1
c      enddo

      tmp(1:nint-1)=0.d0
      fact=vol/nrL
      do iislda=1,islda
      call dgemv('T',nr_nL,nint-1,fact,dR_G(1,1,iislda),
     &  mr_nL,dR_G(1,nint-1,iislda),1,1.d0,tmp,1)
       enddo
ccccccccccccccccccccccccccccccccccccccccccc


      call mpi_allreduce(tmp,AA(1,nint-1),nint-1,
     $     MPI_REAL8,MPI_SUM,MPI_COMM_K,ierr)

      do m=1,nint-1
      AA(nint-1,m)=AA(m,nint-1)
      enddo
ccccccccccccccccccccccccccccccccc


cccccccccc pulay optimization
**********************************************************
      do m2=1,nint-1
      do m1=1,nint-1
      AA1(m1,m2)=AA(m1,m2)
      enddo
      enddo

      w=1.0d0
      do m=nint-1,1,-1
      AA1(m,m)=AA1(m,m)*w
      w=w*alpha2
      enddo

**********************************************************
      call gaussj(AA1,nint-1,npulay_max,B,1,1)       ! don't use gaussj ?

      do iislda=1,islda
      do i=1,nr_nL
      w_out(i,iislda)=R0_G(i,iislda)
      enddo
      enddo

      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       do m=1,nint-1
c      do iislda=1,islda
c      do i=1,nr_nL
c      w_in(i,iislda)=w_in(i,iislda)+B(m)*dw_G(i,m,iislda)
c      w_out(i,iislda)=w_out(i,iislda)+B(m)*dR_G(i,m,iislda)
c      enddo
c      enddo
c      enddo

      do iislda=1,islda
      call dgemv('N',nr_nL,nint-1,1.d0,dw_G(1,1,iislda),
     &  mr_nL,B,1,1.d0,w_in(1,iislda),1)
      call dgemv('N',nr_nL,nint-1,1.d0,dR_G(1,1,iislda),
     &  mr_nL,B,1,1.d0,w_out(1,iislda),1)
       enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



      do iislda=1,islda
      do i=1,nr_nL
      w_out(i,iislda)=w_out(i,iislda)+w_in(i,iislda)
      enddo
      enddo

      endif     ! nint.gt.1
cccccccccccccccccccccccccccccccccccccccccccccccccccccc

       


       if(nint.gt.1) then   

        AA_G=AA       ! AA_G is a storage array in IOchm.f

       endif


c      deallocate(dw_G)
c      deallocate(dR_G)
c      deallocate(R0_G)
c      deallocate(w_in0_G)


      return
      end
      

