      subroutine rhoIO_dir(vr_n_tmp,mr_ni,iflag,
     &    n1i,n2i,n3i,iunit,num_proc_group,
     &    num_rec,ipos_rec,LREC)
******************************************
cc     Written by Lin-Wang Wang, March 30, 2001.  
*************************************************************************
**  copyright (c) 2003, The Regents of the University of California,
**  through Lawrence Berkeley National Laboratory (subject to receipt of any
**  required approvals from the U.S. Dept. of Energy).  All rights reserved.
*************************************************************************

******************************************


cccc when iflag=1, the original vr_n_tmp will not be destroyed.

ccccccc iflag=1, write the charge density vr_n_tmp to fdens_name
ccccccc iflag=2, read the charge density vr_n_tmp from fdens_name
      
      use MParallel

      implicit double precision (a-h,o-z)

ccc      include 'mpif.h'
      include 'param.escan_real'


      real*8,allocatable,dimension(:)   :: tempvr1,tempvr2

      real*8,allocatable,dimension(:)   :: temp_rho,vr_tmp
    
      real*8 vr_n_tmp(mr_ni)

      integer status(MPI_STATUS_SIZE)

      nri=n1i*n2i*n3i

      if(nnodes.ne.num_proc_group) then
      write(6,*) "nnodes.ne.num_proc_group,stop", 
     &                        nnodes,num_proc_group
      stop
      endif
    
      nri_n=nri/nnodes
      num_rec_proc=num_rec/nnodes
      LREC_end=nri_n-(num_rec_proc-1)*LREC




      if(iflag.eq.2) then   ! read the charge density
      if(icolor.eq.0) then    ! only read from the icolor group

     
      call mpi_barrier(MPI_COMM_K,ierr)

      if(inode.eq.1) then
         allocate(vr_tmp(LREC))
         allocate(tempvr1(nri_n))
            do isend=0,nnodes-1
        do irec=1,num_rec_proc
        length=LREC
        if(irec.eq.num_rec_proc) length=LREC_end
        ipos=ipos_rec+isend*num_rec_proc+irec-1
        read(unit=iunit,rec=ipos) vr_tmp(1:length)
        tempvr1((irec-1)*LREC+1:(irec-1)*LREC+length)=vr_tmp(1:length)
        enddo
               if (isend==0) then
                  vr_n_tmp(1:nri_n)=tempvr1
               else
                  call mpi_send(tempvr1,nri_n,MPI_REAL8,isend,
     &                 100,MPI_COMM_K,ierr)
               end if
            end do

         deallocate(tempvr1)
         deallocate(vr_tmp)
         
      else
         call mpi_recv(vr_n_tmp,nri_n,MPI_REAL8,0,100,
     &        MPI_COMM_K,status,ierr)
      end if

      call mpi_barrier(MPI_COMM_K,ierr)


      endif     ! icolor=0 group
ccccccccc  send the data from icolor group to other groups
      if(num_group.gt.1) then    ! number of k-point group, num_group from param.escan.real
      call mpi_barrier(XMPI_COMM_WORLD,ierr)
      call mpi_bcast(vr_n_tmp,nri_n,MPI_REAL8,0,MPI_COMM_N,ierr)
      endif

      return
      endif     ! iflag=2, read
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      if(iflag.eq.1) then     ! write the charge 
      if(icolor.eq.0) then


       if(inode.eq.1) then
       allocate(tempvr1(nri_n))
       allocate(vr_tmp(LREC))
        do irec=1,num_rec_proc
        length=LREC
        if(irec.eq.num_rec_proc) length=LREC_end
        ipos=ipos_rec+irec-1
        vr_tmp(1:length)=vr_n_tmp((irec-1)*LREC+1:(irec-1)*LREC+length)
         
        write(unit=iunit,rec=ipos) vr_tmp(1:length)
        enddo
       endif

       do isend=1,nnodes-1
       call mpi_barrier(MPI_COMM_K,ierr)
       if(inode==isend+1) then
        call  mpi_send(vr_n_tmp,nri_n,MPI_REAL8,0,
     &   100,MPI_COMM_K,ierr)
       endif

       if(inode.eq.1) then
        call mpi_recv(tempvr1,nri_n,MPI_REAL8,isend,
     &   100,MPI_COMM_K,status,ierr)
        do irec=1,num_rec_proc
        length=LREC
        if(irec.eq.num_rec_proc) length=LREC_end
        ipos=ipos_rec+isend*num_rec_proc+irec-1
        vr_tmp(1:length)=tempvr1((irec-1)*LREC+1:(irec-1)*LREC+length)
        write(unit=iunit,rec=ipos) vr_tmp(1:length)
        enddo
       endif
       enddo

       call mpi_barrier(MPI_COMM_K,ierr)

        if(inode.eq.1) then
        deallocate(tempvr1)
        deallocate(vr_tmp)
        endif
*****************************************************
        endif    ! icolor.eq.0
        endif    ! iflag=1, write

        return
        end
      
